#%%
# def result2csv(contribp_l):
def gen_result(file_list):
    for i in range(len(file_list)):
        file_path = file_list[i]
        data = np.loadtxt(file_path,dtype=np.float64,delimiter=" ")
        yield data

def result2ary(contribp_l):
    rmat = np.array(
        list(gen_result(contribp_l))
    )

    r_norm = np.linalg.norm(rmat,1,axis=2,keepdims=True)
    rmat /= r_norm

    r_mean = np.mean(rmat,axis=1)
    return r_mean

def result2csv(contribp_l, csv_path):
    data = result2ary(contribp_l)
    ddf = pd.DataFrame(data,columns=label_list)

    ddf.to_csv(csv_path,index=False)

def call_result2csv():
    test_target = "lr"
    contribp_l = [
        "evaluation/feature_importance/lightgbm/lambdarank/representation/{}-{}.txt".format(test_target,float2fs(x))\
            for x in nbrs
    ]
    csv_path = "evaluation/feature_importance/lightgbm/lambdarank/representation/lr_summary.csv"
    result2csv(contribp_l,csv_path)

#%%
if __name__ == "__main__":
    import numpy as np
    import pandas as pd
    import matplotlib as mpl
    from matplotlib import pylab as pl

    def float2fs(f):
        s = str(round(f,3))
        import re

        srepl = re.compile("\.")
        fs = srepl.sub("_",s)
        return fs

    nbrs = np.arange(0.125,0.24,0.005)

    label_list = ["LinearSVM(HMM)","LinearSVM(PSSM)",
        "DFG-S2C(HHblits)","DFG-S2C(HHsearch)",
        "DFG-S2C(PSI-BLAST)","DFG-S2C(DELTA-BLAST)"]

    call_result2csv()


#%%
import numpy as np

np.round(np.logspace(-3,0,num=20),4)
#%%
np.round(np.linspace(10,500,num=20),0)
