# To add a new cell, type '# %%'
# To add a new markdown cell, type '# %% [markdown]'
# %% [markdown]
# ## 进行5-fold cross validation
# 
# ### 1. 先把数据集进行拆分

# %%
from src.evaluation.cross_validation import Run

datasetPath = "dataset/benchmark/all/SCOP_Experimental"
resultPath = "dataset/benchmark/cross"
# n = 5 # 默认就是5折

runCV = Run(datasetPath)
runCV.spilt_n_folds(resultPath=resultPath)

# %% [markdown]
# ### 2. 生成查询用的database 
# #### 2.1 psiblast

# %%
from src.utils.tools import Assembly
import os
import subprocess as sp

toolA = Assembly()

def combination(L, k):
    L_size = len(L)
    if k == 0:
        return [[]]
    if L_size == 0:
        return []
    
    x = L[0]
    res = L[1:]

    part = [[x] + c for c in combination(res,k-1)]
    return part + combination(res,k)
    
n = 5
k = 4
combs = combination(list(range(n)),k)
combs.reverse()

tmpFilePath = "dataset/benchmark/tmp/fasta合集"
seFoldNo_l = ["dataset/benchmark/cross/SCOP_Experimental_foldNo{}".format(x)        for x in range(n)]
db_l = ["dataset/benchmark/db/template/scop_{}_psiblast".format(x)     for x in range(n)]

for i, c in enumerate(combs):
    dbPath = db_l[i]
    with open(tmpFilePath,"w") as h:
        for j in c:
            seFoldNoPath = seFoldNo_l[j]
            with open (seFoldNoPath,"r") as h1:
                h.write(h1.read())
    # cmd = "makeblastdb -in {} -dbtype 'prot' -out {} > psi.log".format(tmpFilePath,dbPath)
    # sp.call(cmd,shell=True)
    cmd = "makeblastdb -help > psi.log"
    sp.call(cmd,shell=True)
    # toolA.use_makeblastdb(tmpFilePath,dbPath)


# %%
import os

seqsPath_l = ["dataset/benchmark/seqs/SCOP_Experimental_foldNo{}".format(x)        for x in range(0,5)]

for seqsPath in seqsPath_l:
    if not os.path.exists(seqsPath):
        os.mkdir(seqsPath)


# %%
from src.utils.tools import Assembly
from use_utils import use_splitfasta

import subprocess as sp


toolA = Assembly()

n = 5

oriFastFile_l = ["dataset/benchmark/cross/SCOP_Experimental_foldNo{}".format(x)     for x in range(1,n)]
seqs_l = ["dataset/benchmark/seqs/SCOP_Experimental_foldNo{}".format(x)     for x in range(1,n)]

seqs_l = [os.path.abspath(x) for x in seqs_l]

use_splitfasta(oriFastFile_l,seqs_l)


# %%
from src.utils.tools import Assembly

toolA = Assembly()

seqFastaFilePath = "dataset/benchmark/seqs/SCOP_Experimental_foldNo0/d1a8qa_.seq"
dbPath = "dataset/benchmark/db/template/scop_0_psiblast"
resultFilePath = "dataset/benchmark/tmp/d1a8qa_.psi"

toolA.use_psiblast(seqFastaFilePath,dbPath,resultFilePath)

# %% [markdown]
# ### 2.2 mmseqs

# %%
# tmpFilePath用之前赋值的
dbPath = "dataset/benchmark/db/scop_1_4_mmseqs"
mmseqs_createdb_cmd = "mmseqs createdb {} {}".format(tmpFilePath,dbPath)
sp.call(mmseqs_createdb_cmd,shell=True)

# %% [markdown]
# > 简单测试下mmseqs的检索能力

# %%
resultFilePath = "dataset/benchmark/tmp/d1a8qa_.txt"
tmpDir = "dataset/benchmark/tmp/tmp"
rm_cmd = "rm -r {}".format(tmpDir)
if os.path.exists(tmpDir):
    sp.call(rm_cmd,shell=True)
os.mkdir(tmpDir)
mmseqs_search_cmd = "mmseqs easy-search {} {} {} {}".format(
    seqFastaFilePath,dbPath,resultFilePath,tmpDir
)
sp.call(mmseqs_search_cmd,shell=True)
rm_cmd = "rm -r {}".format(tmpDir)
sp.call(rm_cmd,shell=True)

# %% [markdown]
# > 通过mmseqs制作用于hhblits检索的数据库

# %%
n = 5
fasta_l = ["dataset/benchmark/cross/SCOP_Experimental_foldNo{}".format(x)        for x in range(n)]
resultPath_l = ["dataset/benchmark/db/query/scop_{}_mmseqs".format(x)        for x in range(n)]
# 这是把多个文件合成一个database的操作
# part_cmd = "mmseqs createdb {} {} {} {} {}".format(*fasta_l)
# print(part_cmd)

for i, fasta_path in enumerate(fasta_l):
    resultFilePath = resultPath_l[i]
    createdb_cmd = "mmseqs createdb {} {}".format(fasta_path,resultFilePath)
    sp.call(createdb_cmd,shell=True)


# %%
import subprocess as sp

def combination(L, k):
    L_size = len(L)
    if k == 0:
        return [[]]
    if L_size == 0:
        return []
    
    x = L[0]
    res = L[1:]

    part = [[x] + c for c in combination(res,k-1)]
    return part + combination(res,k)

n = 5

combs = combination(list(range(5)),4)
combs.reverse()

resultPath_l = ["dataset/benchmark/db/template/scop_{}_mmseqs".format(x)        for x in range(n)]
for i, c in enumerate(combs):
    fasta_l = ["dataset/benchmark/cross/SCOP_Experimental_foldNo{}".format(x)         for x in c]
    resultPath = resultPath_l[i]
    fasta_l.append(resultPath)
    create_cmd = "mmseqs createdb {} {} {} {} {}".format(*fasta_l)
    sp.call(create_cmd,shell=True)

# %% [markdown]
# > 对每一折进行查询，targetDB选uniprot20
# > 但这个方法出现了问题，因此，现在改为通过cluster的方法来生成
# %% [markdown]
# > 先进行prefilter
# ```bash
# mmseqs prefilter ${MMSEQDB} ${MMSEQDB} ${MMSEQPREF} -s ${SENSITIVITY} --threads ${THREADS} &>> ${FILELOG}
# ```

# %%
import os
import subprocess as sp

n = 5
sensitivity = 7.5

templateDB_l = ["dataset/benchmark/db/template/scop_{}_mmseqs".format(x)        for x in range(n)]
prefilter_l = ["dataset/benchmark/db/template/scop_{}_mmseqs_prefilter".format(x)     for x in range(n)]

for i, templateDBPath in enumerate(templateDB_l):
    prefilterPath = prefilter_l[i]
    prefilter_cmd = "mmseqs prefilter {} {} {} -s {}".format(
        templateDBPath,templateDBPath,prefilterPath,sensitivity
    )
    recode = sp.call(prefilter_cmd,shell=True)
    print(recode)

# %% [markdown]
# > 再进行align
# ```bash
# mmseqs align ${MMSEQDB} ${MMSEQDB} ${MMSEQPREF} ${MMSEQALN} -e ${EVALUE} \
#   --min-seq-id ${IDENTITY} -c ${COVERAGE} --threads ${THREADS} &>> ${FILELOG}
# ```

# %%
import subprocess as sp

n = 5
prefilter_l = ["dataset/benchmark/db/template/scop_{}_mmseqs_prefilter".format(x)     for x in range(n)]
templateDB_l = ["dataset/benchmark/db/template/scop_{}_mmseqs".format(x)        for x in range(n)]
align_l = ["dataset/benchmark/db/template/scop_{}_mmseqs_align".format(x)     for x in range(n)]
evalue = 1e-4

for i, templateDBPath in enumerate(templateDB_l):
    prefilterPath = prefilter_l[i]
    alignPath = align_l[i]
    align_cmd = "mmseqs align {} {} {} {} -e {}".format(
        templateDBPath,templateDBPath,prefilterPath,alignPath,
        evalue
    )
    sp.call(align_cmd,shell=True)

# %% [markdown]
# > 再进行clust
# ```bash
# mmseqs clust ${MMSEQDB} ${MMSEQALN} ${MMSEQCLU} --cluster-mode ${CLU_MODE} --threads ${THREADS} &> ${FILELOG} &>> ${FILELOG}
# ```

# %%
clu_l = ["dataset/benchmark/pre_db/template/scop_{}_mmseqs_clu".format(x)     for x in range(n)]

CLU_MODE=1

for i, templateDBPath in enumerate(templateDB_l):
    alignPath = align_l[i]
    cluPath = clu_l[i]
    align_cmd = "mmseqs clust {} {} {} --cluster-mode {}".format(
        templateDBPath,alignPath,cluPath,CLU_MODE
    )
    sp.call(align_cmd,shell=True)


# %%


# queryDB_l = ["dataset/benchmark/db/template/scop_{}_mmseqs".format(x)\
#         for x in range(n)]
templateDB_l = ["dataset/benchmark/db/template/scop_{}_mmseqs".format(x)        for x in range(n)]
dbPath = "/home/shaojiangyi/source/Representative_Rank/dataset/db/uniprotkb_swiss_prot/uniprotkb_swiss_prot"
result_l = ["dataset/benchmark/pre_db/SCOP_Experimental_foldNo{}".format(x)     for x in range(n)]
tmpDir = "dataset/benchmark/tmp/tmp"
rmdir = "rm -r {}"

if os.path.exists(tmpDir):
    cmd = rmdir.format(tmpDir)
    sp.call(cmd,shell=True)
os.mkdir(tmpDir)

for i, templateDBPath in enumerate(templateDB_l):
    resultPath = result_l[i]
    resultFilePath = os.path.join(resultPath,"mmseqs_clu")
    if not os.path.exists(resultPath):
        os.mkdir(resultPath)
    # search_cmd = "mmseqs search {} {} {} {} -a".format(
    #     queryDBPath,dbPath,resultFilePath,tmpDir
    # )
    cluster_cmd = "mmseqs cluster {} {} {}".format(
        templateDBPath,resultFilePath,tmpDir
    )
    try:
        sp.call(cluster_cmd,shell=True)
    except Exception as e:
        print(e)
cmd = rmdir.format(tmpDir)
sp.call(cmd,shell=True)

# %% [markdown]
# > 转为msa
# ```bash
# mmseqs result2msa ${MMSEQDB} ${MMSEQDB} ${MMSEQCLU} ${MMSEQMSA} --compress --threads ${THREADS} &>> ${FILELOG}
# ```

# %%
import subprocess as sp

n = 5

templateDB_l = ["dataset/benchmark/db/template/scop_{}_mmseqs".format(x)        for x in range(n)]
clu_l = ["dataset/benchmark/pre_db/template/scop_{}_mmseqs_clu".format(x)     for x in range(n)]
msa_l = ["dataset/benchmark/pre_db/template/scop_{}_mmseqs_msa".format(x)     for x in range(n)]

for i, templateDBPath in enumerate(templateDB_l):
    cluPath = clu_l[i]
    msaPath = msa_l[i]
    result2msa_cmd = "mmseqs result2msa {} {} {} {} --compress".format(
        templateDBPath,templateDBPath,cluPath,msaPath
    )
    sp.call(result2msa_cmd,shell=True)

# %% [markdown]
# > 将msa转为cs219，命令行示例：mpirun -np 2 cstranslate_mpi -i searchMsa -o searchMsa_cs219 -x 0.3 -c 4 -I ca3m -b 或 cstranslate -i searchMsa -o searchMsa_cs219 -f -x 0.3 -c 4 -I ca3m -b
# 
# ```shell
# mmseqs cluster DB clu tmp
# mmseqs result2msa DB DB clu cluMsa --compress
# ln -s DB_h cluMsa_header.ffdata
# ln -s DB_h.index cluMsa_header.ffindex
# ln -s DB cluMsa_sequence.ffdata
# ln -s DB.index cluMsa_sequence.ffindex
# mpirun -np 2 cstranslate_mpi -i cluMsa -o cluMsa_cs219 -A /path/to/cs219.lib -D /path/to/context_data.lib -x 0.3 -c 4 -I ca3m -b
# ```
# 
# %% [markdown]
# > 通过代码创建软链接
# ```bash
# ln -s ${MMSEQDB}_h ${MMSEQMSA}_header.ffdata &>> ${FILELOG}
# ln -s ${MMSEQDB}_h.index ${MMSEQMSA}_header.ffindex &>> ${FILELOG}
# ln -s ${MMSEQDB} ${MMSEQMSA}_sequence.ffdata &>> ${FILELOG}
# ln -s ${MMSEQDB}.index ${MMSEQMSA}_sequence.ffindex &>> ${FILELOG}
# ```

# %%
dbH_l = ["/home/shaojiangyi/source/Representative_Rank/dataset/benchmark/db/template/scop_{}_mmseqs_h".format(x)     for x in range(n)]
dbhIndex_l = ["/home/shaojiangyi/source/Representative_Rank/dataset/benchmark/db/template/scop_{}_mmseqs_h.index".format(x)     for x in range(n)]
db_l = ["/home/shaojiangyi/source/Representative_Rank/dataset/benchmark/db/template/scop_{}_mmseqs".format(x)     for x in range(n)]
dbIndex_l = ["/home/shaojiangyi/source/Representative_Rank/dataset/benchmark/db/template/scop_{}_mmseqs.index".format(x)     for x in range(n)]
msaDir = "dataset/benchmark/pre_db/template"
for i in range(n):
    ln_s = "ln -s {} {}"
    headerPath = os.path.join(msaDir,"scop_{}_mmseqs_msa_header.ffdata".format(i))
    headerIndexPath = os.path.join(msaDir,"scop_{}_mmseqs_msa_header.ffindex".format(i))
    sequencePath = os.path.join(msaDir,"scop_{}_mmseqs_msa_sequence.ffdata".format(i))
    sequenceIndexPath = os.path.join(msaDir,"scop_{}_mmseqs_msa_sequence.ffindex".format(i))

    sp.call(ln_s.format(dbH_l[i],headerPath),shell=True)
    sp.call(ln_s.format(dbhIndex_l[i],headerIndexPath),shell=True)
    sp.call(ln_s.format(db_l[i],sequencePath),shell=True)
    sp.call(ln_s.format(dbIndex_l[i],sequenceIndexPath),shell=True)

# %% [markdown]
# > 清除空文件

# %%
import os
import subprocess as sp

n = 5
pre_db_l = ["dataset/benchmark/pre_db/SCOP_Experimental_foldNo{}".format(x)     for x in range(n)]

for i, preDBPath in enumerate(pre_db_l):
    rm = "rm {}"
    for fileName in os.listdir(preDBPath):
        filePath = os.path.join(preDBPath,fileName)
        if os.stat(filePath).st_size == 0:
            cmd = rm.format(filePath)
            sp.call(cmd,shell=True)
        

# %% [markdown]
# > 生成cs219文件
# ```bash
# cstranslate -f -i ${MMSEQMSA} -o ${MMSEQMSA}_cs219 \
#   -A ${HH_LIB} \
#   -D ${HH_CONTEXT_DATA} \
#   -x 0.3 -c 4 -I ca3m &>> ${FILELOG}
# ```
# 

# %%
import subprocess as sp

n = 5

msa_l = ["dataset/benchmark/pre_db/template/scop_{}_mmseqs_msa".format(x)     for x in range(n)]
cs219_l = ["dataset/benchmark/pre_db/template/scop_{}_mmseqs_msa_cs219".format(x)     for x in range(n)]

hhlibPath = "/home/shaojiangyi/source/Representative_Rank/software/hh-suite/data/cs219.lib"
hhcontextPath = "/home/shaojiangyi/source/Representative_Rank/software/hh-suite/data/context_data.lib"
for i, msaPath in enumerate(msa_l):
    cs219Path = cs219_l[i]
    # mpirun_cmd = "cstranslate -f -i {} -o {} -A {} -D {} -x 0.3 -c 4 -I ca3m -b".format(
    #     msaPath,cs219Path,hhlibPath,hhcontextPath
    # )
    
    mpirun_cmd = "mpirun -np 2 cstranslate_mpi -i {} -o {} -A {} -D {} -x 0.3 -c 4 -I ca3m -b".format(
        msaPath,cs219Path,hhlibPath,hhcontextPath
    )

    try:
        sp.call(mpirun_cmd,shell=True)
    except Exception as e:
        print(e)

# %% [markdown]
# ### 2.3 hhblits
# > 先使用ffindex_from_fasta，把fasta文件转为ffindex和ffdata
# ```bash
# ffindex_from_fasta -s <db>_fas.ff{data,index} <db.fas> 
# ```

# %%
import subprocess as sp
import os

def combination(L, k):
    L_size = len(L)
    if k == 0:
        return [[]]
    if L_size == 0:
        return []
    
    x = L[0]
    res = L[1:]

    part = [[x] + c for c in combination(res,k-1)]
    return part + combination(res,k)
n = 5
combs = combination(list(range(0,n)),4)
combs.reverse() #一定要加这个，不然名字就是反的，不reverse就是4,3,2,1,0，因此，等这次运行完，一定要修改
fasta_l = ["dataset/benchmark/cross/SCOP_Experimental_foldNo{}".format(x)     for x in range(n)]
tmpFastaComp = "dataset/benchmark/tmp/fasta合集"
ff_l = ["dataset/benchmark/pre_db/template/scop_{}_hhblits".format(x)     for x in range(n)]

for i, c in enumerate(combs):
    with open(tmpFastaComp, "w") as h:
        for foldNo in c:
            fastaFilePath = fasta_l[i]
            with open(fastaFilePath, "r") as h1:
                h.write(h1.read())
    ffPath = ff_l[i]
    ffDataPath = ffPath + ".ffdata"
    ffIndexPath = ffPath + ".ffindex"
    ffindex_cmd = "ffindex_from_fasta -s {} {} {}".format(
        ffDataPath,ffIndexPath,tmpFastaComp
    )
    try:
        sp.call(ffindex_cmd,shell=True)
    except:
        print("失败")

# %% [markdown]
# > 生成msa
# ```bash
# mpirun -np <number_threads> \
#   hhblits_mpi -i <db>_fas -d <path_to/uniclust30> -oa3m <db>_a3m_wo_ss -n 2 -cpu 1 -v 0
# ```

# %%
ff_l = ["dataset/benchmark/pre_db/template/scop_{}_hhblits".format(x)     for x in range(n)]
dbPath = "dataset/db/uniprot20_2016_02/uniprot20_2016_02"
a3m_l = ["dataset/benchmark/pre_db/template/scop_{}_hhblits_a3m_wo_ss".format(x)     for x in range(n)]
combs = combination(list(range(0,n)),4)

for i, c in enumerate(combs):
    with open(tmpFastaComp, "w") as h:
        for foldNo in c:
            fastaFilePath = fasta_l[i]
            with open(fastaFilePath, "r") as h1:
                h.write(h1.read())
    ffPath = ff_l[i]
    a3mPath = a3m_l[i]
    a3m_cmd = "mpirun -np 10         hhblits_mpi -i {} -d {} -oa3m {} -n 2 -cpu 1 -v 0".format(
            ffPath,dbPath,a3mPath
        )
    sp.call(a3m_cmd,shell=True)

# %% [markdown]
# ###
# %% [markdown]
# ### 2.4 hmmer
# > 先测试hmmer

# %%
import os
import subprocess as sp

seqName = "d1a8qa_"
seqFilePath = "dataset/benchmark/seqs/SCOP_Experimental_foldNo0/{}.seq".format(seqName)
template_l = ["dataset/benchmark/cross/SCOP_Experimental_foldNo{}".format(x)     for x in range(1,5)]
hmmFilePath = "dataset/benchmark/tmp/{}.hmm".format(seqName)
tmpFastaFilePath = "dataset/benchmark/tmp/fasta合集"
maFilePath = "dataset/benchmark/tmp/{}Ma_hits.txt".format(seqName)

with open(tmpFastaFilePath,"w") as h:
    for templatePath in template_l:
        with open(templatePath,"r") as h1:
            h.write(h1.read())


# %%
# --qformat fasta --tformat fasta
E_value = 1e6 #<= this E-value threshold in output
dbPath = "dataset/benchmark/all/SCOP_experimental"
jackhmmer_cmd = "jackhmmer --mpi  -o {} -A {} -E {} {} {}".format(
    hmmFilePath,maFilePath,E_value,seqFilePath,dbPath
) 
sp.call(jackhmmer_cmd,shell=True)


# %%


