# 基于排序结果进行聚类
# 进一步提升模型
# 但这一步的目的，是为了进行clustering analysis
import numpy as np
import pandas as pd
import tensorflow as tf
from src.model.learningtorank import LambdaMART

run_lambdamart = LambdaMART()

class Cluster2Cluster(object):
    def __init__(self):
        pass

    def read_prediction(self, pred_path):
        return np.load(pred_path)
    
    def save_prediction(self, save_path,mat):
        return np.save(save_path,mat)
    
    def clustering(self, clua):
        def clu_func(*args):
            feamat, params = args
            model = clua(params)
            return model.fit_predict(feamat)
        return clu_func

    # labels表示聚类的结果
    # prediction表示原本的排序结果
    # 大小为
    # n_samples * n_classes
    def rerank(self, *args):
        labels, prediction = args
        # 排序结果要归一化
        # 每条序列排序结果中打分最高的
        prediction = tf.cast(run_lambdamart.normalization(prediction,axis=1),dtype=tf.float32)
        score_ary = tf.transpose(tf.sort(prediction,axis=1,direction="DESCENDING"))[0].numpy()
        lble_df = pd.DataFrame(dict(label=labels,score=score_ary))
        # 这里的row num 也对应着prediction中序列对应的位置
        lble_df.loc[:,"row num"] = lble_df.index

        def cons(gdf):
            ser = gdf.loc[gdf.loc[:,"score"].idxmax()]
            ary = ser.to_numpy()
            mat = np.stack([ary]*gdf.shape[0],axis=0)
            gdf.loc[gdf.index] = mat
            return gdf
        
        g = lble_df.groupby(by="label")
        lble_df = g.apply(cons)
        indices = lble_df.loc[:,"row num"].to_numpy(int)
        npred = tf.gather_nd(prediction,indices.reshape((-1,1)))
        return npred.numpy()


# #%%
# import pandas as pd

# df = pd.DataFrame(dict(A=[3,3,3,4,4,4,5,5],B=[23,11,-2,5,7,56,22,3]))
# #%%
# def cons(gdf):
#     ser = gdf.loc[gdf.loc[:,"B"].idxmax()]
#     ary = ser.to_numpy()
#     mat = np.stack([ary]*gdf.shape[0],axis=0)
#     gdf.loc[gdf.index] = mat
#     return gdf

# df.groupby("A").apply(cons)
# # %%
# import numpy as np
# df.loc[df.index] = np.random.random((8,2))
# # %%
# df
# # %%
# import numpy as np
# import tensorflow as tf

# con = tf.constant(np.random.random((5,9)),tf.float32)
# c_mean = tf.math.reduce_mean(con,axis=0,keepdims=True)
# c_mean.shape
# # %%
# ones = tf.ones(con.shape,tf.float32)
# ones
# # %%
# ones * c_mean
# # %%
