def training_ltr():
    run_lambdamart = LambdaMART()

    
    # boosting_type = "dart" # dart 的目的是提高模型的泛化能力, 但是early_stopping会失效
    '''
    max_bin过大也可能引起过拟合
    参考朱山风老师的论文，max_depth设置为4，因此，leaves<2**max_depth,设置为11
    但是这样不如max_depth=9, leaves=255（并不）
    但是如果此时增加max_bin呢？
    对于测试集而言roc1会增加，但对应roc50减少
    对验证集而言roc1, roc50都会下降
    目前在SCOP1.75和SCOPe2.07上综合表现最好的是num_leaves: 11, max_depth:4, max_bin:1023
    改变训练集的特征后，num_boost_round: 67, num_leaves: 11, max_depth:4, max_bin:255表现最好
    20201002-10:30:44, leaves: 11, max_depth: 4, max_bin: 255, learning_rate: 0.07表现最好
    '''
    params = {
        'boosting_type': boosting_type,
        'objective': "lambdarank",
        'metric': 'ndcg',
        'num_leaves':num_leaves,
        'max_depth':max_depth,
        'learning_rate': learning_rate,
        'feature_fraction': 1.0,
        'bagging_fraction': 0.9,
        'bagging_freq': 1,
        "max_bin":max_bin,
        "min_data_in_leaf":50,
        "min_sum_hessian_in_leaf":5.0,
        "is_enable_sparse":"true",
        "force_row_wise":"true",
        "lambda_l1":5.7,
        "lambda_l2":32.,
        "ndcg_eval_at":"50"
    }
    
    # 因为发现tree少点的话，可以有效防止过拟合
    if use_test_flag or use_eval_flag:
        train_args = {
            "num_boost_round":num_boost_round,
            "early_stopping_rounds":early_stopping_rounds,
            "verbose_eval":5
        }
    else:
        train_args = {
            "num_boost_round":num_boost_round,
            "verbose_eval":5
        }

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    vspecific_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(vspecific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    vtemplate_df = vspec_df.reset_index().rename(columns={"index":"template"})

    representation_dirs = [
        "feature/multiclassification/training/hhblits/representation",
        "feature/multiclassification/training/psiblast/representation",
        "feature/S2C/training_cluster/hhblitsexb",
        "feature/S2C/training_cluster/hhsearchexb",
        "feature/S2C/training_cluster/psiblastexb",
        "feature/S2C/training_cluster/deltablast"
    ]

    trepresentation_dirs = [
        "feature/multiclassification/hhblits/representation",
        "feature/multiclassification/psiblast/representation",
        "feature/S2C/test/hhblitsexb",
        "feature/S2C/test/hhblitsexb",
        "feature/S2C/test/psiblastexb",
        "feature/S2C/test/deltablast"
    ]


    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"cv0{}.npy".format(i)) \
                for x in representation_dirs
        ]

    vrepresentation_dict = {}
    for i in range(n):
        vrepresentation_dict[i] = [
            os.path.join(x,"val0{}.npy".format(i)) \
                for x in representation_dirs
        ]

    trepresentation_dict = {}
    for i in range(n):
        trepresentation_dict[i] = [
            os.path.join(x,"cv0{}.npy".format(i)) \
                for x in trepresentation_dirs
        ]


    k_df = template_df.join(kv_df.set_index("template"),on="template").loc[:,["template","sf","label"]]
    for i in range(n):
        fn_col = str(i)
        t_i_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = k_df.loc[~k_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = kv_i_df.sort_values(by="label")
    
        representation_l = representation_dict[i]
        vrepresentation_l = vrepresentation_dict[i]
        trepresentation_l = trepresentation_dict[i]

        query_df = template_df.loc[template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]

        save_path = save_booster_l[i]
        con = run_lambdamart.get_training_set(representation_l)
        # k_df不按交叉验证的划分结果去处理，是因为这里不仅仅处理训练集和验证集，还会处理测试集
        label = run_lambdamart.get_label(kv_df,kv_i_df, t_i_df,True)

        # # 进行行归一化
        if norm_flag:
            con = run_lambdamart.normalization(con,2)

        # 目前con还是n_sample * n_class * k大小
        # 这为了方便得到group
        group = con.shape[1]*np.ones(con.shape[0])
        # 构造dataset前对con和vcon进行reshape
        con = tf.reshape(con,(-1,con.shape[-1]))
        # label和vlabel目前也是n_sample*n_class大小，需要reshape
        label = tf.reshape(label,(-1,))
        
        train_set = lgb.Dataset(con.numpy(),label.numpy(),group=group)
        train_args["train_set"] = train_set

        if use_test_flag:
            tcon = run_lambdamart.get_training_set(trepresentation_l)
            tlabel = run_lambdamart.get_label(kv_df, kv_i_df, query_df,True)
            
            # 归一化
            if eval_norm:
                tcon = run_lambdamart.normalization(tcon,2)
            # 同理
            tgroup = tcon.shape[1]*np.ones(tcon.shape[0])
            tlabel = tf.reshape(tlabel,(-1,))
            tcon = tf.reshape(tcon,(-1,tcon.shape[-1]))
            test_set = lgb.Dataset(tcon.numpy(),tlabel.numpy(),group=tgroup)
            train_args["valid_sets"] = [test_set]

        elif use_eval_flag:
            vcon = run_lambdamart.get_training_set(vrepresentation_l)
            vlabel = run_lambdamart.get_label(kv_df, kv_i_df, vtemplate_df,True)

            # 归一化
            if eval_norm:
                tcon = run_lambdamart.normalization(vcon,2)

            # 同理
            vgroup = vcon.shape[1]*np.ones(vcon.shape[0])
            vlabel = tf.reshape(vlabel,(-1,))
            vcon = tf.reshape(vcon,(-1,vcon.shape[-1]))
            val_set = lgb.Dataset(vcon.numpy(),vlabel.numpy(),group=vgroup)
            train_args["valid_sets"] = [val_set]

        booster = run_lambdamart.train(params,**train_args)
        
        # 保存训练好的模型
        booster.save_model(save_path)


def ind_ltr():
    run_lambdamart = LambdaMART()
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    ikey2value_path = "dataset/scop_scope/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    ispecific_path = "feature/hhblits/acc_hmm/ind_sequence_name2row_num.csv"

    cv_df = pd.read_csv(cross_validation_path)
    ikv_df = pd.read_csv(ikey2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    ispec_df = pd.read_csv(ispecific_path,index_col=0)


    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    itemplate_df = ispec_df.reset_index().rename(columns={"index":"template"})

    representation_dirs = [
        "feature/multiclassification/training/hhblits/representation",
        "feature/multiclassification/training/psiblast/representation",
        "feature/S2C/training_cluster/hhblitsexb",
        "feature/S2C/training_cluster/hhsearchexb",
        "feature/S2C/training_cluster/psiblastexb",
        "feature/S2C/training_cluster/deltablast"
    ]

    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"ind0{}.npy".format(i)) \
                for x in representation_dirs
        ]
    

    # 为了方便得到label还要对kv_df处理一下
    # 这里使用ikv_df是为了保证后面能正确生成label
    ik_df = template_df.join(ikv_df.set_index("template"),on="template").loc[:,["template","sf","label"]]
    roc_score_list = []
    fc_list = []
    for i in range(n):
        fn_col = str(i)
        # print(query_df)
        representation_l = representation_dict[i]
        load_path = save_booster_l[i]
        booster = lgb.Booster(model_file=load_path)

        # 获取每种特征的importance
        fary = booster.feature_importance()
        fc_list.append(fary)

        # 构造测试集，不同方法的测试结果，对于某些序列可能缺失，因此要进行补全
        # 在进行测试之前调用run_lambdamart.completement_test_set进行补全
        # 参考pre_test_ltr()程序
        kv_i_df = ik_df.loc[~ik_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = kv_i_df.sort_values(by="label")

        con = run_lambdamart.get_training_set(representation_l)
        label = run_lambdamart.get_label(ikv_df,kv_i_df, itemplate_df,keepdims=True)
        # 行归一化
        # 因为con是n_sample*n_class*k大小的tensor
        # 要对k个特征进行行归一化
        if eval_norm:
            con = run_lambdamart.normalization(con,2)

        # print(con.shape)
        # print(label.shape)
        X = con.numpy()
        y = label.numpy()

    
        for j in range(X.shape[0]):
            X_test = X[j] # n_class * k
            y_test = y[j] # n_class

            y_pred = booster.predict(X_test, raw_score=True)
            indices = tf.argsort(y_pred,axis=0,direction="DESCENDING").numpy()
            # indices = np.flip(np.argsort(y_pred,axis=0),0)
            # print(indices.shape)
            # print(indices)
            # print(y.shape)
            yt = y_test[indices]
            score1 = run_cv.cal_roc_mu_at(1,yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)
            try:
                ascore = roc_auc_score(y_test,y_pred)
            except:
                ascore = 0.0
            if each_flag:
                cli_print = "printf '{} {} {}\n'".format(score1,score50,ascore)
                sp.call(cli_print,shell=True) 

            roc_score_list.append([score1,score50,ascore])


    score = np.array(roc_score_list).mean(0)
    # cli_print = "printf '{}\n'".format(score)
    # sp.call(cli_print,shell=True)

    fmat = np.vstack(fc_list)

    if os.path.exists(eval_print_path):
        with open(eval_print_path,"a") as h:
            line = "{}\n".format(
                " ".join(score.astype(str).tolist())
            )
            h.write(line)
    else:
        print(score)
    
    np.savetxt(contrib_print_path,fmat,"%d")
            

if __name__ == "__main__":
    import lightgbm as lgb
    import numpy as np
    import pandas as pd
    import time
    import os
    import subprocess as sp
    import tensorflow as tf
    from src.model.learningtorank import LambdaMART
    from src.evaluation.cross_validation import Run
    from sklearn.metrics import roc_auc_score
    from sklearn.preprocessing import label_binarize

    # test_target = "tree"
    test_target = "lr"

    boosting_type = "gbdt"

    num_leaves = 11
    max_depth = 4
    # learning_rate = 0.07 # 在使用psiblastexb情况下
    learning_rate = 0.089  # 在使用使用hhblitsexb, hhsearchexb情况下
    max_bin = 127 # 减小以防止过拟合,但太小模型的性能也会不好
    early_stopping_rounds = 100
    if test_target == "tree":
        nbrs = np.hstack(
            [
                np.arange(10,210,10),
                np.array([300,400,500])
            ]
        )
        use_eval_flag = False # 用验证集找最优tree
    elif test_target == "lr":
        # nbrs = np.arange(0.01,0.125,0.005)
        nbrs = np.arange(0.125,0.24,0.005) # 由于已经测了一半了所以，目前从0.125开始
        # nbrs = np.arange(0.01,0.24,0.005) # 本来要测46组的
        num_boost_round = 107 # 控制最大tree的个数
        use_eval_flag = True # 用验证集找最优tree

    eval_print_path = "output/lgb_tc_lr.out"   

    exb_flag = True # 结果保存到exb目录下
    # 为了方便得到label还要对kv_df处理一下
    
    use_test_flag = False # 用测试集做验证集
    norm_flag = False # 训练集归一化，这里不需要因为LTR训练中包含了归一化
    eval_norm = True # 验证集或测试集归一化
    each_flag = False # 输出每个序列的roc1, roc50值
    need_training_flag = True

    n = 5 # 表示5折交叉验证

    dir_name = "lambdarank"

    def float2fs(f):
        s = str(round(f,3))
        import re

        srepl = re.compile("\.")
        fs = srepl.sub("_",s)
        return fs

    if test_target == "lr":
        contribp_l = [
            "evaluation/feature_importance/lightgbm/lambdarank/representation/{}-{}.txt".format(test_target,float2fs(x))\
                for x in nbrs
        ]    
    elif test_target == "tree":    
        contribp_l = [
            "evaluation/feature_importance/lightgbm/lambdarank/representation/{}-{}.txt".format(test_target,x)\
                for x in nbrs
        ]
    

    for i in range(nbrs.shape[0]):
        if test_target == "tree":
            num_boost_round = nbrs[i]
        elif test_target == "lr":
            learning_rate = nbrs[i]
        if test_target == "tree":
            save_booster_l = [
                "model/contrib/lightgbm/{}/representation/cv0{}-{}-{}.txt".format(dir_name,x,test_target,num_boost_round)\
                    for x in range(n)
            ]
        elif test_target  == "lr":
            save_booster_l = [
                "model/contrib/lightgbm/{}/representation/cv0{}-{}-{}.txt".format(dir_name,x,test_target,float2fs(learning_rate))\
                    for x in range(n)
            ]            
        contrib_print_path = contribp_l[i]
        if need_training_flag:
            training_ltr()
        ind_ltr()