def training_classifier():
    representaion_path = "feature/hhblits/acc_hmm/multiclass.train"

    rep = np.loadtxt(representaion_path)
    print(rep.shape)
    # rep
    size = 1000
    X = rep[:size, 1:]
    y = rep[:size, 0]

    print(X.shape)
    print(y.shape)

    params = {
        'boosting_type': 'gbdt',
        'objective': "multiclass",
        'metric': 'auc_mu,multi_logloss',
        "num_trees":500,
        'num_leaves': 255,
        'learning_rate': 0.01,
        "min_data_in_leaf":0,
        "min_sum_hessian_in_leaf":100,
        "force_col_wise":"true"
    }

    X_train, X_test, y_train, y_test = train_test_split(
        X, y,test_size=0.1,train_size=0.9,random_state=0)
    print(X_train.shape)
    print(X_test.shape)

    def construct_dataset(data, dataset_path):
        r, c = data.shape
        format = "\t".join(["%.4f"]*(c-1))
        with open(dataset_path,"w") as h:
            for i in range(r):
                x = data[i]
                label = int(x[0])
                feature = tuple(x[1:])
                f_str = format % feature
                line = "{}\t{}\n".format(label,f_str)
                h.write(line)
            print(label)
            
    def save_conf(params, conf_path):
        with open(conf_path, "w") as h:
            for key in params:
                line = "{} = {}\n".format(key,params[key])
                h.write(line)

    conf_path = "model/test/train.conf"
    training_dataset_path = "feature/tmp/multiclass.train"
    validation_dataset_path = "feature/tmp/multiclass.valid"
    savePath = "model/test/cv_00_20200807-09:57:57"

    y_df = pd.DataFrame(y,columns=["label"])
    yDf_g = y_df.groupby("label")
    idx = [x[0] for x in yDf_g.groups.values()]
    df = y_df.loc[idx]
    df = df.reset_index(drop=True).reset_index() 
    y_df1 = pd.DataFrame(y_train, columns=["label"])
    y_df2 = pd.DataFrame(y_test, columns=["label"])   
    y_df1 = y_df1.join(df.set_index("label"),on="label")
    y_df2 = y_df2.join(df.set_index("label"),on="label")
    y_ntrain = y_df1.loc[:, "index"].to_numpy(np.int64) 
    y_ntest = y_df2.loc[:, "index"].to_numpy(np.int64)

    num_class = len(df.groupby("index"))
    params["num_class"] = num_class
    params["data"] = training_dataset_path
    params["valid_data"] = validation_dataset_path
    params["output_model"] = savePath

    nTrain = np.hstack([y_ntrain.reshape((-1,1)),X_train])
    nTest = np.hstack([y_ntest.reshape((-1,1)),X_test])

    save_conf(params, conf_path)
    construct_dataset(nTrain,training_dataset_path)
    construct_dataset(nTest,validation_dataset_path)

    training = "lightgbm config={}".format(conf_path)
    sp.call(training,shell=True)

def auc_mu(y_pred, y_true, classes):
    y_true = label_binarize(y_true, classes=classes)
    fpr = dict()
    tpr = dict()
    roc_auc = []
    for i in range(len(classes)):
        fpr[i], tpr[i], _ = roc_curve(y_true[:, i], y_pred[:, i])
        if not np.isnan(tpr[i]).any():
            try:
                roc_auc.append(auc(fpr[i], tpr[i]))
            except:
                if 1 in tpr[i]:
                    roc_auc.append(1.)
                else:
                    roc_auc.append(0.)
    auc_score = np.array(roc_auc).mean()
    return auc_score

def sklearn_svm(params, X,y, eX, ey, classes, savePath):
    clf = LinearSVC(**params)
    clf.fit(X, y)
    score = clf.decision_function(eX)
    am = auc_mu(score, ey, classes)
    printStart = "printf {}".format(am)
    sp.call(printStart,shell=True)
    with open(savePath, "wb") as h:
        cPickle.dump(clf, h)

def use_svm():
    params = {
        "C": 32
    }

    representaion_path = "feature/hhblits/acc_hmm/multiclass.train"
    savePath = "model/test/svm_20200807-12:09:00"

    rep = np.loadtxt(representaion_path)
    print(rep.shape)
    # rep
    size = 1000
    X = rep[:size, 1:]
    y = rep[:size, 0].astype(np.int64)

    print(X.shape)
    print(y.shape)

    X_train, X_test, y_train, y_test = train_test_split(
        X, y,test_size=0.1,train_size=0.9,random_state=0)
    print(X_train.shape)
    print(X_test.shape)

    y_df = pd.DataFrame(y,columns=["label"])
    yDf_g = y_df.groupby("label")
    idx = [x[0] for x in yDf_g.groups.values()]
    df = y_df.loc[idx]
    df = df.reset_index(drop=True).reset_index() 
    y_df = y_df.join(df.set_index("label"),on="label")
    y_df1 = pd.DataFrame(y_train, columns=["label"])
    y_df2 = pd.DataFrame(y_test, columns=["label"])   
    y_df1 = y_df1.join(df.set_index("label"),on="label")
    y_df2 = y_df2.join(df.set_index("label"),on="label")
    y_ntrain = y_df1.loc[:, "index"].to_numpy(np.int64) 
    y_ntest = y_df2.loc[:, "index"].to_numpy(np.int64)

    vs = [x for x in y_df1.groupby("index").groups.keys()]
    # print(vs)

    sklearn_svm(params,X_train,y_ntrain, X_test,y_ntest,vs,savePath)

    # sklearn_svm(params, X, y, eX, ey,vs,savePath)


if __name__ == "__main__":
    import numpy as np
    import pandas as pd
    import subprocess as sp
    from sklearn.model_selection import train_test_split
    from sklearn.metrics import auc, roc_curve
    from sklearn.preprocessing import label_binarize
    import pandas as pd
    from sklearn.linear_model import SGDClassifier
    from sklearn.kernel_approximation import Nystroem
    from sklearn.svm import LinearSVC
    from six.moves import cPickle

    # training_classifier()
    # test_classifier()
    use_svm()