def val_extract_checkpoints():
    seqDir = "dataset/benchmark/seqs/validation"
    fasPath = "dataset/benchmark/all/validation"
    rpsdbPath = "/home/shaojiangyi/source/C2C-DFG-LTR/dataset/db/cdd_delta/cdd_delta"
    
    sel_db = "uniref"

    if sel_db == "nrdb":
        dbPath = "/home/shaojiangyi/source/C2C-DFG-LTR/dataset/db/nrdb90/nrdb90" # 使用nrdb90进行检索
        pssmDir = "feature/deltablast/pssm/val"
    else:
        dbPath = "/home/shaojiangyi/source/C2C-DFG-LTR/dataset/db/uniref50/uniref50" # 使用uniref50进行检索
        pssmDir = "feature/deltablast/uniref/pssm/val"

    evalue = 1e-3
    num_iterations = 3
    num_alignments = int(1e6)
    num_threads = 20

    run_psiblast = PsiBlast()

    with open(fasPath,"r") as h:
        seq_list = [
            r.name for r in parse(h,"fasta")
        ]

    for seqName in seq_list:
        seqPath = os.path.join(seqDir,"{}.seq".format(seqName))
        
        pssmPath = os.path.join(pssmDir,"{}.pssm".format(seqName))
        if os.path.exists(pssmPath):
            continue
        # set_params = {
        #     "query":seqPath,
        #     "db":dbPath,
        #     "num_iteration":num_iterations,
        #     "evalue":evalue,
        #     "out_ascii_pssm":pssmPath,
        #     "num_threads": num_threads
        # }
        
        # run_psiblast.extract_pssm(set_params)
        set_params = {
            "query":seqPath,
            "db":dbPath,
            "num_alignments":num_alignments,
            "out_pssm":pssmPath,
            "num_threads": num_threads,
            "rpsdb":rpsdbPath
        }
        
        run_psiblast.deltablast_checkpoints(set_params)

if __name__ == "__main__":
    from src.utils.feature_extraction import PsiBlast
    from src.utils.tools import Assembly
    import os
    import numpy as np
    import re
    import pandas as pd
    from Bio.SeqIO import parse
    import subprocess as sp

    val_extract_checkpoints()