

def use_auc_mu():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/psipred/representation/sequence_name2row_num.csv"
    vspecific_path = "feature/psipred/representation/val_sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    representation_path = "feature/hhblits/representation/representation_profile.npy"
    vrepresentation_path = "feature/hhblits/representation/val_representation_profile.npy"

    # classifier_path = "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_01_20200807-23:13:03"
    # classifier_l = [
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_00_20200807-13:57:25",
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_01_20200807-23:13:03",
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_02_20200808-08:15:56",
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_03_20200808-17:50:05",
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_04_20200809-05:03:09"
    # ]
    classifier_l = [
        "model/all/fine_tunning/svm/hhblits/representation/cv_00_20200824-20:58:16",
        "model/all/fine_tunning/svm/hhblits/representation/cv_01_20200824-22:57:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_02_20200825-00:46:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_03_20200825-02:36:22",
        "model/all/fine_tunning/svm/hhblits/representation/cv_04_20200825-04:27:26"
    ]
    # classifier_l = [
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_00_20200808-16:31:01",
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_01_20200809-10:29:14",
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_02_20200810-04:14:55",
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_03_20200810-22:14:47",
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_04_20200811-16:34:48"
    # ]
    # classifier_l = [
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_00_20200808-16:37:37",
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_01_20200809-10:35:50",
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_02_20200810-04:21:31",
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_03_20200810-22:20:49",
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_04_20200811-16:40:49"
    # ]
    # classifier_l = [
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_00_20200824-22:07:23",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_01_20200824-23:56:21",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_02_20200825-01:46:23",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_03_20200825-03:37:06",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_04_20200825-05:28:51"
    # ]
    # classifier_l = [
    #     "model/all/fine_tunning/svm/psiblast/top_n_gram/cv_00_20200819-08:51:06"
    # ]
    # classifier_l = [
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_00_20200809-10:13:44",
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_01_20200810-03:59:47",
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_02_20200810-21:59:03",
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_03_20200811-16:19:20",
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_04_20200812-10:19:14"
    # ]

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(vspecific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    rep = np.load(representation_path)
    vrep = np.load(vrepresentation_path)

    # with open(classifier_path,"rb") as h:
    #     clf = cPickle.load(h)

    # fold_num = "1"
    # run_cv.auc_mu(fold_num,cv_df,spec_df,vspec_df, kv_df, clf, rep, vrep)

    # 进行归一化
    rnomrs = run_cv.norms(rep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    rep /= rnorm

    vrep = None # 评估测试集性能是，将vrep赋值为None
    for i, classifier_path in enumerate(classifier_l):
        fold_num = str(i)
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)
        # cli_print = "printf '模型加载完成\n'"
        # sp.call(cli_print,shell=True)
        run_cv.auc_mu(fold_num,cv_df,spec_df,vspec_df, kv_df, clf, rep, vrep)

def use_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    vspecific_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    representation_path = "feature/hhblits/representation/representation_profile.npy"
    vrepresentation_path = "feature/hhblits/representation/val_representation_profile.npy"

    # classifier_path = "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_01_20200807-23:13:03"
    # classifier_l = [
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_00_20200807-13:57:25",
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_01_20200807-23:13:03",
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_02_20200808-08:15:56",
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_03_20200808-17:50:05",
    #     "model/all/fine_tunning/lightgbm/multiclass/hhblits/cv_04_20200809-05:03:09"
    # ]
    classifier_l = [
        "model/all/fine_tunning/svm/hhblits/representation/cv_00_20200915-22:03:16",
        "model/all/fine_tunning/svm/hhblits/representation/cv_01_20200915-23:07:19",
        "model/all/fine_tunning/svm/hhblits/representation/cv_02_20200916-00:07:37",
        "model/all/fine_tunning/svm/hhblits/representation/cv_03_20200916-01:08:07",
        "model/all/fine_tunning/svm/hhblits/representation/cv_04_20200916-02:08:57"
    ]
    # classifier_l = [
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_00_20200808-16:31:01",
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_01_20200809-10:29:14",
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_02_20200810-04:14:55",
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_03_20200810-22:14:47",
    #     "model/all/fine_tunning/lightgbm/multiclass/physicochemical/cv_04_20200811-16:34:48"
    # ]
    # classifier_l = [
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_00_20200808-16:37:37",
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_01_20200809-10:35:50",
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_02_20200810-04:21:31",
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_03_20200810-22:20:49",
    #     "model/all/fine_tunning/lightgbm/multiclass/psiblast/cv_04_20200811-16:40:49"
    # ]
    # classifier_l = [
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_00_20200915-16:35:51",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_01_20200915-17:36:45",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_02_20200915-18:40:15",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_03_20200915-19:45:24",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_04_20200915-20:41:21"
    # ]
    # classifier_l = [
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_00_20200819-13:12:58",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_01_20200819-15:58:48",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_02_20200819-18:38:38",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_03_20200819-21:12:29",
    #     "model/all/fine_tunning/svm/psiblast/representation/cv_04_20200819-23:47:02"
    # ]
    # classifier_l = [
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_00_20200809-10:13:44",
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_01_20200810-03:59:47",
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_02_20200810-21:59:03",
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_03_20200811-16:19:20",
    #     "model/all/fine_tunning/lightgbm/multiclass/psipred/cv_04_20200812-10:19:14"
    # ]


    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(vspecific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    rep = np.load(representation_path)
    vrep = np.load(vrepresentation_path)

    # with open(classifier_path,"rb") as h:
    #     clf = cPickle.load(h)

    # fold_num = "1"
    # run_cv.auc_mu(fold_num,cv_df,spec_df,vspec_df, kv_df, clf, rep, vrep)

    # 进行归一化
    rnomrs = run_cv.norms(rep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    rep /= rnorm

    cli_print = "printf 'roc1 roc50\n'"
    sp.call(cli_print,shell=True)
    for i, classifier_path in enumerate(classifier_l):
        fold_num = str(i)
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)
        vrep = None
        # level = 1
        # score1 = run_cv.roc_mu_at(level, fold_num, cv_df, spec_df, vspec_df, kv_df, clf, rep, vrep)
        # level = 50
        # score50 = run_cv.roc_mu_at(level, fold_num, cv_df, spec_df, vspec_df, kv_df, clf, rep, vrep)
        # cli_print = "printf '{} {}\n'".format(score1,score50)
        level = [1,50]
        score = run_cv.roc_mu_at(level, fold_num, cv_df, spec_df, vspec_df, kv_df, clf, rep, vrep)

        cli_print = "printf '{}\n'".format(score)
        sp.call(cli_print,shell=True)

def srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    # searched_path = "feature/hhblits/searched/searched_nr_e.csv"
    # searched_path = "feature/hhblits/searched/searched_nr.csv"
    # searched_path = "feature/hhsearch/searched/searched_nr_e.csv"
    # searched_path = "feature/hhsearch/searched/searched_nr.csv"
    # searched_path = "feature/mmseqs2/searched/searched_nr.csv"
    searched_path = "feature/psiblast/searched/searched_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    srch_df = pd.read_csv(searched_path)

    each_flag = False # 控制输出每个序列的评估结果

    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = True # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[srch_df.loc[:,"query"].isin(cv_df.loc[:,fold_num])]
        pairwise_df = pairwise_df.loc[~pairwise_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])
            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)

def val_srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    searched_path = "feature/hhblits/searched/validation_nr.csv"
    # searched_path = "feature/hhsearch/searched/validation_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    srch_df = pd.read_csv(searched_path)

    each_flag = False

    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = True # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)

def ind_srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    ind_kv_path = "dataset/SCOPe/csv/sequence_superfamily.csv"
    searched_path = "feature/hhblits/searched/independent_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    dkv_df = pd.read_csv(ind_kv_path)
    srch_df = pd.read_csv(searched_path)

    # 要把kv_df, dkv_df的sf组合起来
    m_df = pd.concat([kv_df,dkv_df])
    mg = m_df.groupby("template")
    idx = [x[0] for x in mg.groups.values()]
    m_df = m_df.loc[idx,["template","sf"]]
    m_df = m_df.reset_index(drop=True)
    mg = m_df.groupby("sf")
    idx = [x[0] for x in mg.groups.values()]
    sf_df = m_df.loc[idx, ["sf"]].reset_index(drop=True)
    sf_df = sf_df.reset_index().rename(columns={"index":"label"})
    m_df = m_df.join(sf_df.set_index("sf"),on="sf")

    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = False # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    each_flag = False # 这个标志控制是否输出每个序列的评估结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        
        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)
    
def perfect_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/psipred/representation/sequence_name2row_num.csv"
    vspecific_path = "feature/psipred/representation/val_sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    representation_path = "feature/psipred/representation/representation_profile.npy"
    vrepresentation_path = "feature/psipred/representation/val_representation_profile.npy"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(vspecific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    rep = np.load(representation_path)
    vrep = np.load(vrepresentation_path)

    n = 5
    cli_print = "printf 'roc1 roc50\n'"
    sp.call(cli_print,shell=True)
    for i in range(n):
        vrep = None
        fold_num = str(i)
        # level = 1
        # score1 = run_cv.perfect_roc_at(level, fold_num, cv_df, spec_df, vspec_df, kv_df, rep, vrep)
        # level = 50
        # score50 = run_cv.perfect_roc_at(level, fold_num, cv_df, spec_df, vspec_df, kv_df, rep, vrep)
        # cli_print = "printf '{} {}\n'".format(score1,score50)

        level = [1,50]
        score = run_cv.perfect_roc_at(level, fold_num, cv_df, spec_df, vspec_df, kv_df, rep, vrep)
        cli_print = "printf '{}\n'".format(score)
        sp.call(cli_print,shell=True)   

if __name__ == "__main__":
    import pandas as pd
    import numpy as np
    from six.moves import cPickle
    from src.evaluation.cross_validation import Run
    import subprocess as sp
    import time

    s = time.time()

    # use_auc_mu()
    # use_roc_at()
    # perfect_roc_at()
    # srch_roc_at()
    val_srch_roc_at()
    # ind_srch_roc_at()
    e = time.time()
    print("time: {}".format(e-s))