

def combination(L, k):
    L_size = len(L)
    if k == 0:
        return [[]]
    if L_size == 0:
        return []
    
    x = L[0]
    res = L[1:]

    part = [[x] + c for c in combination(res,k-1)]
    return part + combination(res,k)

def getFileNameWithoutSurfix(psName):
    rv_psN = psName[::-1]
    name_size = len(psName)
    surfixParser = re.compile(r"\.")
    s_r = surfixParser.search(rv_psN)
    if s_r is not None:
        surfix_start = s_r.start()
        name = psName[:name_size-surfix_start-1]
        surfix = psName[name_size-surfix_start:]
    else:
        name = psName
    return name, surfix

def fasta2ffFile():
    fasPath = "dataset/benchmark/all/validation"
    ffdataPath = "dataset/benchmark/db/tmp/validation.ffdata"
    ffindexPath = "dataset/benchmark/db/tmp/validation.ffindex"

    ffindex_from_fasta = "ffindex_from_fasta {} {} {}".format(ffdataPath,ffindexPath,fasPath)
    sp.call(ffindex_from_fasta,shell=True)



def fasta2a3m():
    n = 5
    ff_l = ["dataset/benchmark/db/tmp/scop_{}_hhblits".format(x) \
        for x in range(n)]
    dbPath = "dataset/db/uniprot20_2016_02/uniprot20_2016_02"
    a3m_l = ["dataset/benchmark/db/template/scop_{}_hhblits_a3m".format(x) \
        for x in range(n)]
    hhm_l = ["dataset/benchmark/db/template/scop_{}_hhblits_hhm".format(x) \
        for x in range(n)]

    for i in range(n):
        ffPath = ff_l[i]
        a3mPath = a3m_l[i]
        hhmPath = hhm_l[i]
        a3m_cmd = "mpirun -np 15 \
            hhblits_mpi -i {} -d {} -oa3m {} -ohhm {} -n 2 -cpu 1 -maxfilt 500000 -diff inf -id 99 -cov 60".format(
                ffPath,dbPath,a3mPath,hhmPath
            )
        # print(a3m_cmd)
        sp.call(a3m_cmd,shell=True)

def fasta2a3mAndhhm():
    ffPath = "dataset/benchmark/db/tmp/SCOP_Experimental"
    dbPath = "dataset/db/uniprot20_2016_02/uniprot20_2016_02"
    a3mPath = "dataset/benchmark/db/all/SCOP_Experimental_a3m"
    hhmPath = "dataset/benchmark/db/all/SCOP_Experimental_hhm"

    cmd = "mpirun -np 10 \
        hhblits_mpi -i {} -d {} -oa3m {} -ohhm {} -n 2 -cpu 1 -maxfilt 500000 -diff inf -id 99 -cov 60".format(
            ffPath,dbPath,a3mPath,hhmPath
        )
    # print(cmd)
    sp.call(cmd,shell=True)

def validation_fasta2a3mAndhhm():
    ffPath = "dataset/benchmark/db/tmp/validation"
    dbPath = "dataset/db/uniprot20_2016_02/uniprot20_2016_02"
    a3mPath = "dataset/benchmark/db/validation/validation_a3m"
    hhmPath = "dataset/benchmark/db/validation/validation_hhm"

    cmd = "mpirun -np 20 \
        hhblits_mpi -i {} -d {} -oa3m {} -ohhm {} -n 2 -cpu 1 -maxfilt 500000 -diff inf -id 99 -cov 60".format(
            ffPath,dbPath,a3mPath,hhmPath
        )
    # print(cmd)
    sp.call(cmd,shell=True)
    

def a3m2hhm():
    # mpirun -np <number_threads> ffindex_apply_mpi <db>_a3m.ff{data,index} \\
    # -i <db>_hhm.ffindex -d <db>_hhm.ffdata -- hhmake -i stdin -o stdout -v 0
    n = 5
    a3mData_l = ["dataset/benchmark/pre_db/template/scop_{}_hhblits_a3m.ffdata".format(x) \
        for x in range(n)]
    a3mIndex_l = ["dataset/benchmark/pre_db/template/scop_{}_hhblits_a3m.ffindex".format(x) \
        for x in range(n)]
    hhmData_l = ["dataset/benchmark/pre_db/template/scop_{}_hhblits_hhm.ffdata".format(x) \
        for x in range(n)]
    hhmIndex_l = ["dataset/benchmark/pre_db/template/scop_{}_hhblits_hhm.ffindex".format(x) \
        for x in range(n)]
    threads = 10
    mpirun = "mpirun -np {} ffindex_apply_mpi {} {} -d {} -i {} -- hhmake -i stdin -o stdout -v 0"


    for i in range(n):
        a3mDataPath = a3mData_l[i]
        a3mIndexPath = a3mIndex_l[i]
        hhmDataPath = hhmData_l[i]
        hhmIndexPath = hhmIndex_l[i]
        cmd = mpirun.format(
                threads,
                a3mDataPath,a3mIndexPath,hhmDataPath,hhmIndexPath
            )
        sp.call(cmd,shell=True)
        # print(cmd) # 用于查看命令行是否正确
    

def a3m2cs219():
    # n = 5
    n = 1
    # a3m_l = ["dataset/benchmark/pre_db/template/scop_{}_hhblits_a3m".format(x) \
    #     for x in range(n)]
    a3m_l = ["dataset/benchmark/db/all/SCOP_Experimental_a3m"]
    # cs219_l = ["dataset/benchmark/pre_db/template/scop_{}_hhblits_cs219".format(x) \
    #     for x in range(n)]
    cs219_l = ["dataset/benchmark/db/all/SCOP_Experimental_cs219"]
   
    threads = 10

    # mpirun -np <number_threads> cstranslate_mpi -f -x 0.3 -c 4 -I a3m -i <db>_a3m -o <db>_cs219

    mpirun = "mpirun -np {} cstranslate_mpi -f -x 0.3 -c 4 -I a3m -i {} -o {}"

    for i in range(n):
        a3mPath = a3m_l[i]
        cs219Path = cs219_l[i]
        cmd = mpirun.format(threads,a3mPath,cs219Path)
        sp.call(cmd,shell=True)
        # print(cmd)

# 生成器
def genHMMFromFile(handle):
    if not handle.readable():
        return
    content = []
    parser = re.compile(r"^>(?P<queryName>[a-z0-9_\.]+)\s+[a-z]\.[0-9]+\.[0-9]+\.[0-9]+")
    parsedFlag = False
    readFlag = False
    for line in handle:
        parsing_r = parser.search(line)
        if parsing_r is not None and not parsedFlag:
            if readFlag:
                yield (queryName, content)
                content = []
                readFlag = False
            parsedFlag = True
            queryName = parsing_r.group("queryName")
        if parsedFlag and not readFlag:
            parsedFlag = False
            readFlag = True
        if not parsedFlag and readFlag:
            content.append(line)
    yield (queryName, content)
    return

# 使用生成器将hmm.ffdata文件按不同序列拆分成多个文件
def splitHMMData():
    n = 5

    hmmPath = "dataset/benchmark/db/all/SCOP_Experimental_hhm.ffdata"
    tg_l = ["feature/hhblits/hmm/scop_{}".format(x) \
        for x in range(n)]
    sequence_name2fold_num_path = "dataset/benchmark/cross/sequence_name2fold_num"
    with open(sequence_name2fold_num_path,"rb") as h:
        sn2fN = cPickle.load(h)

    # L = []
    with open(hmmPath,"r") as h:
        spliter = genHMMFromFile(h)
        for q, content in spliter:
            foldN = sn2fN[q]
            targetDir = tg_l[foldN]
            querPath = os.path.join(targetDir,"{}.hmm".format(q))
            # L.append(querPath)
            with open(querPath,"w") as h1:
                h1.writelines(content)
            
    # print(L[:10],len(L))

def validation_splitHMMData():
    hmmPath = "dataset/benchmark/db/validation/validation_hhm.ffdata"
    targetDir = "feature/hhblits/hmm/validation"

    with open(hmmPath,"r") as h:
        spliter = genHMMFromFile(h)
        for q, content in spliter:
            querPath = os.path.join(targetDir,"{}.hmm".format(q))
            # L.append(querPath)
            with open(querPath,"w") as h1:
                h1.writelines(content)

def use_hhblits_to_search():
    n = 5

    run_hhblits = HHblits()
    set_params = {
        "input":"",
        "db":"dataset/benchmark/db/all/SCOP_Experimental",
        "output":"",
        "iteration":3,
        "cpu_core":1,
        "maxfilt":500000,
        "diff":"inf",
        "id":99,
        "cov":60,
        "np":20
    }

    ff_l = ["dataset/benchmark/db/query/scop_{}_hhblits".format(x) \
        for x in range(n)]
    output_l = ["feature/hhblits/searched/scop_{}.hhr".format(x) \
        for x in range(n)]

    for i, ffPath in enumerate(ff_l):
        outputPath = output_l[i]
        set_params["input"] = ffPath
        set_params["output"] = outputPath
        run_hhblits.search(set_params)

def validation_search():
    run_hhblits = HHblits()
    set_params = {
        "input":"dataset/benchmark/db/tmp/validation",
        "db":"dataset/benchmark/db/all/SCOP_Experimental",
        "output":"feature/hhblits/searched/validation_hhr",
        "iteration":3,
        "cpu_core":1,
        "maxfilt":500000,
        "diff":"inf",
        "id":99,
        "cov":60,
        "np":20
    }

    run_hhblits.search(set_params)

def use_hhsearch():
    n = 5

    run_hhblits = HHblits()
    set_params = {
        "input":"",
        "db":"dataset/benchmark/db/all/SCOP_Experimental",
        "output":"",
        "cpu_core":1,
        "diff":"inf",
        "id":99,
        "cov":60,
        "np":20
    }

    # hhsearch的输入和hhblits是一样的
    ff_l = ["dataset/benchmark/db/query/scop_{}_hhblits".format(x) \
        for x in range(n)]
    output_l = ["feature/hhsearch/searched/scop_{}.hhr".format(x) \
        for x in range(n)]

    for i, ffPath in enumerate(ff_l):
        outputPath = output_l[i]
        set_params["input"] = ffPath
        set_params["output"] = outputPath
        run_hhblits.hhsearch(set_params)    

def parsing_searched_result():
    n = 5
    hhrData_l = ["feature/hhblits/searched/scop_{}.hhr.ffdata".format(x) \
        for x in range(n)]
    hhrIndex_l = ["feature/hhblits/searched/scop_{}.hhr.ffindex".format(x) \
        for x in range(n)]
    fold_num2sequence_name_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    with open(fold_num2sequence_name_path,"r") as h:
        fN2sn_df = pd.read_csv(h)

    searchedPath = "feature/hhblits/searched/searched_ref.csv"

    buf_l = []
    run_hhblits = HHblits()
    for i, hhrPath in enumerate(hhrData_l):
        hhrIndexPath = hhrIndex_l[i]
        with open(hhrIndexPath,"r") as h:
            hhrIAry = np.loadtxt(h,dtype=str)
        hhrI_df = pd.DataFrame(hhrIAry,columns=["query","num 1","num 2"])
        diff_ss = fN2sn_df.loc[~fN2sn_df.iloc[:,i].isin(hhrI_df.loc[:,"query"]),str(i)]
        m = diff_ss.shape[0]

        buf_l.append(run_hhblits.parsing_searched_result(hhrPath))

        res_buf = []
        if m > 1:
            dss1 = diff_ss.loc[~pd.isna(diff_ss)]
            for x in dss1:
                res_buf.append([x] + [None]*5)
        buf_l.append(res_buf)

    buffer = ft.reduce(lambda x,y: x+y,buf_l)
    cols = ["query","template","prob", "evalue", "pvalue", "score"]
    df = pd.DataFrame(buffer,columns=cols)
    df = df.astype({"query":str,"template":str,"prob":float, "evalue":float, "pvalue":float, "score":float})
    with open(searchedPath,"w",newline='') as h:
        df.to_csv(h,index=False)

def parsing_validation_result():
    from Bio.SeqIO import parse

    fasPath = "dataset/benchmark/all/validation"
    with open(fasPath,"r") as h:
        seqName_l = [r.name for r in parse(h,"fasta")]
    val_df = pd.DataFrame(seqName_l,columns=["validation"])

    searchedPath = "feature/hhblits/searched/validation.csv"

    hhrPath = "feature/hhblits/searched/validation_hhr.ffdata"
    hhrIndexPath = "feature/hhblits/searched/validation_hhr.ffindex"

    buf_l = []
    run_hhblits = HHblits()
    with open(hhrIndexPath,"r") as h:
        hhrIAry = np.loadtxt(h,dtype=str)
    hhrI_df = pd.DataFrame(hhrIAry,columns=["query","num 1","num 2"])
    diff_ss = val_df.loc[~val_df.loc[:,"validation"].isin(hhrI_df.loc[:,"query"]),"validation"]
    m = diff_ss.shape[0]
    buf_l.append(run_hhblits.parsing_searched_result(hhrPath))
    res_buf = []
    if m > 1:
        dss1 = diff_ss.loc[~pd.isna(diff_ss)]
        for x in dss1:
            res_buf.append([x] + [None]*5)
    buf_l.append(res_buf)

    buffer = ft.reduce(lambda x,y: x+y,buf_l)
    cols = ["query","template","prob", "evalue", "pvalue", "score"]
    df = pd.DataFrame(buffer,columns=cols)
    df = df.astype({"query":str,"template":str,"prob":float, "evalue":float, "pvalue":float, "score":float})

    df.to_csv(searchedPath,index=False)

def parsing_hhsearch_result():
    n = 5
    hhrData_l = ["feature/hhsearch/searched/scop_{}.hhr.ffdata".format(x) \
        for x in range(n)]
    hhrIndex_l = ["feature/hhsearch/searched/scop_{}.hhr.ffindex".format(x) \
        for x in range(n)]
    fold_num2sequence_name_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    with open(fold_num2sequence_name_path,"r") as h:
        fN2sn_df = pd.read_csv(h)

    searchedPath = "feature/hhsearch/searched/searched_ref.csv"

    buf_l = []
    run_hhblits = HHblits()
    for i, hhrPath in enumerate(hhrData_l):
        hhrIndexPath = hhrIndex_l[i]
        with open(hhrIndexPath,"r") as h:
            hhrIAry = np.loadtxt(h,dtype=str)
        hhrI_df = pd.DataFrame(hhrIAry,columns=["query","num 1","num 2"])
        diff_ss = fN2sn_df.loc[~fN2sn_df.iloc[:,i].isin(hhrI_df.loc[:,"query"]),str(i)]
        m = diff_ss.shape[0]

        buf_l.append(run_hhblits.parsing_searched_result(hhrPath))

        res_buf = []
        if m > 1:
            dss1 = diff_ss.loc[~pd.isna(diff_ss)]
            for x in dss1:
                res_buf.append([x] + [None]*5)
        buf_l.append(res_buf)

    buffer = ft.reduce(lambda x,y: x+y,buf_l)
    cols = ["query","template","prob", "evalue", "pvalue", "score"]
    df = pd.DataFrame(buffer,columns=cols)
    df = df.astype({"query":str,"template":str,"prob":float, "evalue":float, "pvalue":float, "score":float})
    with open(searchedPath,"w",newline='') as h:
        df.to_csv(h,index=False)

def val_hhsearch():
    run_hhblits = HHblits()
    set_params = {
        "input":"dataset/benchmark/db/tmp/validation",
        "db":"dataset/benchmark/db/all/SCOP_Experimental",
        "output":"feature/hhsearch/searched/validation_hhr",
        "cpu_core":1,
        "diff":"inf",
        "id":99,
        "cov":60,
        "np":20
    }

    run_hhblits.hhsearch(set_params)  

def val_parsing_hhsearch():
    from Bio.SeqIO import parse

    fasPath = "dataset/benchmark/all/validation"
    with open(fasPath,"r") as h:
        seqName_l = [r.name for r in parse(h,"fasta")]
    val_df = pd.DataFrame(seqName_l,columns=["validation"])

    searchedPath = "feature/hhsearch/searched/validation.csv"

    hhrPath = "feature/hhsearch/searched/validation_hhr.ffdata"
    hhrIndexPath = "feature/hhsearch/searched/validation_hhr.ffindex"

    buf_l = []
    run_hhblits = HHblits()
    with open(hhrIndexPath,"r") as h:
        hhrIAry = np.loadtxt(h,dtype=str)
    hhrI_df = pd.DataFrame(hhrIAry,columns=["query","num 1","num 2"])
    diff_ss = val_df.loc[~val_df.loc[:,"validation"].isin(hhrI_df.loc[:,"query"]),"validation"]
    m = diff_ss.shape[0]
    buf_l.append(run_hhblits.parsing_searched_result(hhrPath))
    res_buf = []
    if m > 1:
        dss1 = diff_ss.loc[~pd.isna(diff_ss)]
        for x in dss1:
            res_buf.append([x] + [None]*5)
    buf_l.append(res_buf)

    buffer = ft.reduce(lambda x,y: x+y,buf_l)
    cols = ["query","template","prob", "evalue", "pvalue", "score"]
    df = pd.DataFrame(buffer,columns=cols)
    df = df.astype({"query":str,"template":str,"prob":float, "evalue":float, "pvalue":float, "score":float})

    df.to_csv(searchedPath,index=False)  

def remove_redundancy_pairwise():
    searchedFilePath = "feature/hhblits/searched/searched_ref.csv"
    depandentFilePath = "dataset/benchmark/cross/sequence_name2fold_num"
    targetFilePath = "feature/hhblits/searched/searched.csv"

    run_hhblits = HHblits()

    run_hhblits.remove_redundancy_pairwise(searchedFilePath,depandentFilePath,targetFilePath)

def remove_repetitive_pairwise():
    searchedFilePath = "feature/hhblits/searched/searched_ref.csv"
    targetFilePath = "feature/hhblits/searched/searched_nr.csv"
    run_hhblits = HHblits()
    run_hhblits.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)

def val_rm_repetitive():
    searchedFilePath = "feature/hhblits/searched/validation.csv"
    targetFilePath = "feature/hhblits/searched/validation_nr.csv"
    run_hhblits = HHblits()
    run_hhblits.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)

def hhsearch_rm_rep_pairwise():
    # searchedFilePath = "feature/hhsearch/searched/searched_ref.csv"
    # targetFilePath = "feature/hhsearch/searched/searched_nr.csv"
    searchedFilePath = "feature/hhsearch/searched/searched_ref_bak.csv"
    targetFilePath = "feature/hhsearch/searched/searched_nr_bak.csv"
    run_hhblits = HHblits()
    run_hhblits.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)

def hhsearch_rm_red_pairwise():
    searchedFilePath = "feature/hhsearch/searched/searched_ref.csv"
    depandentFilePath = "dataset/benchmark/cross/sequence_name2fold_num"
    targetFilePath = "feature/hhsearch/searched/searched.csv"

    run_hhblits = HHblits()

    run_hhblits.remove_redundancy_pairwise(searchedFilePath,depandentFilePath,targetFilePath)

def val_hhsearch_rm_rep():
    searchedFilePath = "feature/hhsearch/searched/validation.csv"
    targetFilePath = "feature/hhsearch/searched/validation_nr.csv"
    run_hhblits = HHblits()
    run_hhblits.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)    

def convert_hmm2csv():
    n = 5

    hmm_l = ["feature/hhblits/hmm/scop_{}".format(x) \
        for x in range(n)]
    
    run_hhblits = HHblits()
    
    for hmmDir in hmm_l:
        for hmmName in os.listdir(hmmDir):
            name,_ = getFileNameWithoutSurfix(hmmName)
            hmmFilePath = os.path.join(hmmDir,hmmName)
            csvFilePath = os.path.join(hmmDir,"{}.csv".format(name))
            run_hhblits.hmm2csvFormat(hmmFilePath,csvFilePath)

def validation_convert_hmm2csv():
    run_hhblits = HHblits()
    hmmDir = "feature/hhblits/hmm/validation"
    for hmmName in os.listdir(hmmDir):
        name,_ = getFileNameWithoutSurfix(hmmName)
        hmmFilePath = os.path.join(hmmDir,hmmName)
        csvFilePath = os.path.join(hmmDir,"{}.csv".format(name))
        run_hhblits.hmm2csvFormat(hmmFilePath,csvFilePath)

def use_acc_hmm():
    # 先按照字典顺序，将ss2文件按顺序编号，这个编号对应着处理顺序，也对应着特征向量在矩阵中的位置
    n = 5
    hmm_l = ["feature/hhblits/hmm/scop_{}".format(x) \
        for x in range(n)]

    sequence_name2row_num_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    forceFlag = True # 如果要强制更新就改为True
    if forceFlag or not os.path.exists(sequence_name2row_num_path):
        all_file_name_l = []
        for hmmDir in hmm_l:
            name_l = [getFileNameWithoutSurfix(x)[0] for x in os.listdir(hmmDir) \
                if getFileNameWithoutSurfix(x)[1] == "csv"]
            name_l = sorted(name_l)
            all_file_name_l += name_l
        
        row_num_l = list(range(len(all_file_name_l)))

        sn2rN_df = pd.DataFrame(row_num_l,columns=["row num"],index=all_file_name_l)
        with open(sequence_name2row_num_path,"w",newline='') as h:
            sn2rN_df.to_csv(h)
    
    acc_list = []
    run_hhblits = HHblits()
    for hmmDir in hmm_l:
        name_l = [x for x in os.listdir(hmmDir) \
            if getFileNameWithoutSurfix(x)[1] == "csv"]
        name_l = sorted(name_l)
        for name in name_l:
            hmm_csvFormat_path = os.path.join(hmmDir,name)
            acc_hmm = run_hhblits.acc_hmm(hmm_csvFormat_path) # 默认LG=5
            m = acc_hmm.shape[0]
            if m != 2000:
                # print(name_l)
                print(hmm_csvFormat_path)
                break
            acc_list.append(acc_hmm)
    
    acc_hmm_mat_path = "feature/hhblits/acc_hmm/representaion_profile.npy"
    acc_hmm_mat = np.vstack(acc_list)

    # try:
    np.save(acc_hmm_mat_path,acc_hmm_mat)
    # except:
    #     np.savetxt(acc_hmm_mat_path,acc_list)

def validation_use_acc_hmm():
    hmmDir = "feature/hhblits/hmm/validation"
    sequence_name2row_num_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"
    forceFlag = True # 如果要强制更新就改为True
    if forceFlag or not os.path.exists(sequence_name2row_num_path):
        all_file_name_l = []

        name_l = [getFileNameWithoutSurfix(x)[0] for x in os.listdir(hmmDir) \
            if getFileNameWithoutSurfix(x)[1] == "csv"]
        name_l = sorted(name_l)
        all_file_name_l += name_l
    
        row_num_l = list(range(len(all_file_name_l)))

        sn2rN_df = pd.DataFrame(row_num_l,columns=["row num"],index=all_file_name_l)
        with open(sequence_name2row_num_path,"w",newline='') as h:
            sn2rN_df.to_csv(h)

    acc_list = []
    run_hhblits = HHblits()

    name_l = [x for x in os.listdir(hmmDir) \
        if getFileNameWithoutSurfix(x)[1] == "csv"]
    name_l = sorted(name_l)
    for name in name_l:
        hmm_csvFormat_path = os.path.join(hmmDir,name)
        acc_hmm = run_hhblits.acc_hmm(hmm_csvFormat_path) # 默认LG=5
        m = acc_hmm.shape[0]
        if m != 2000:
            # print(name_l)
            print(hmm_csvFormat_path)
            break
        acc_list.append(acc_hmm)
    
    acc_hmm_mat_path = "feature/hhblits/acc_hmm/val_representaion_profile.npy"
    acc_hmm_mat = np.vstack(acc_list)

    # try:
    np.save(acc_hmm_mat_path,acc_hmm_mat)

def use_top_n_gram():
    n = 5
    hmm_l = ["feature/hhblits/hmm/scop_{}".format(x) \
        for x in range(n)]

    run_hhblits = HHblits()
    ngram = 2
    L = 20
    top_n_gram_list = []
    for hmmDir in hmm_l:
        name_l = [x for x in os.listdir(hmmDir) \
            if getFileNameWithoutSurfix(x)[1] == "csv"]
        name_l = sorted(name_l)

        for name in name_l:
            hmm_csvFormat_path = os.path.join(hmmDir,name)
            top_n_gram_list.append(run_hhblits.top_n_gram(hmm_csvFormat_path,ngram,L))
    
    top_n_gram_path = "feature/hhblits/top_n_gram/top{}/representation_profile.npy".format(ngram)
    top_n_gram_mat = np.vstack(top_n_gram_list)

    np.save(top_n_gram_path,top_n_gram_mat)

def val_top_n_gram():
    hmmDir = "feature/hhblits/hmm/validation"

    run_hhblits = HHblits()
    ngram = 2
    L = 20
    top_n_gram_list = []

    name_l = [x for x in os.listdir(hmmDir) \
        if getFileNameWithoutSurfix(x)[1] == "csv"]
    name_l = sorted(name_l)

    for name in name_l:
        hmm_csvFormat_path = os.path.join(hmmDir,name)
        top_n_gram_list.append(run_hhblits.top_n_gram(hmm_csvFormat_path,ngram,L))
    
    top_n_gram_path = "feature/hhblits/top_n_gram/top{}/val_representation_profile.npy".format(ngram)
    top_n_gram_mat = np.vstack(top_n_gram_list)

    np.save(top_n_gram_path,top_n_gram_mat)

def combine_top_n_gram():
    top1_path = "feature/hhblits/top_n_gram/top1/representation_profile.npy"
    top2_path = "feature/hhblits/top_n_gram/top2/representation_profile.npy"
    topc_path = "feature/hhblits/top_n_gram/combine/representation_profile.npy"

    top1_ary = np.load(top1_path)
    top2_ary = np.load(top2_path)

    topc_ary = np.hstack([top1_ary,top2_ary])
    np.save(topc_path,topc_ary)

def val_combine_topn():
    top1_path = "feature/hhblits/top_n_gram/top1/val_representation_profile.npy"
    top2_path = "feature/hhblits/top_n_gram/top2/val_representation_profile.npy"
    topc_path = "feature/hhblits/top_n_gram/combine/val_representation_profile.npy"

    top1_ary = np.load(top1_path)
    top2_ary = np.load(top2_path)

    topc_ary = np.hstack([top1_ary,top2_ary])
    np.save(topc_path,topc_ary)

def comb_acc_topn():
    acc_path = "feature/hhblits/acc_hmm/representation_profile.npy"
    topn_path = "feature/hhblits/top_n_gram/combine/representation_profile.npy"
    comb_path = "feature/hhblits/representation/representation_profile.npy"
    
    acc_ary = np.load(acc_path)
    topn_ary = np.load(topn_path)

    cary = np.hstack([acc_ary,topn_ary])
    np.save(comb_path,cary)

def val_acc_topn():
    acc_path = "feature/hhblits/acc_hmm/val_representation_profile.npy"
    topn_path = "feature/hhblits/top_n_gram/combine/val_representation_profile.npy"
    comb_path = "feature/hhblits/representation/val_representation_profile.npy"
    
    acc_ary = np.load(acc_path)
    topn_ary = np.load(topn_path)

    cary = np.hstack([acc_ary,topn_ary])
    np.save(comb_path,cary)

def use_native():
    run_hhblits = HHblits()

    searched_path = "feature/hhblits/searched/searched_nr.csv"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    srch_df = pd.read_csv(searched_path)
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    save_l = [
        "feature/native/training/hhblits/cv0{}.npy".format(x)\
            for x in range(n)
    ]
    
    for i in range(n):
        fold_num = str(i)
        save_path = save_l[i]

        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_df = template_df.join(kv_df.set_index("template"),on="template")
        t_i_df = t_df.loc[~t_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        h_df = srch_df.loc[~srch_df.loc[:,"query"].isin(cv_df.loc[:,fold_num])]
        h_df = h_df.loc[~h_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        con = run_hhblits.native(h_df,t_i_df)

        np.save(save_path,con)

def test_native():
    run_hhblits = HHblits()

    searched_path = "feature/hhblits/searched/searched_nr.csv"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    srch_df = pd.read_csv(searched_path)
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    save_l = [
        "feature/native/hhblits/cv0{}.npy".format(x)\
            for x in range(n)
    ]
    
    for i in range(n):
        fold_num = str(i)
        save_path = save_l[i]

        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_df = template_df.join(kv_df.set_index("template"),on="template")
        t_i_df = t_df.loc[~t_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        h_df = srch_df.loc[srch_df.loc[:,"query"].isin(cv_df.loc[:,fold_num])]
        h_df = h_df.loc[~h_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        con = run_hhblits.native(h_df,t_i_df)

        np.save(save_path,con)

def val_native():
    run_hhblits = HHblits()

    searched_path = "feature/hhblits/searched/validation_nr.csv"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    srch_df = pd.read_csv(searched_path)
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    save_l = [
        "feature/native/training/hhblits/val0{}.npy".format(x)\
            for x in range(n)
    ]
    
    for i in range(n):
        fold_num = str(i)
        save_path = save_l[i]

        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_df = template_df.join(kv_df.set_index("template"),on="template")
        t_i_df = t_df.loc[~t_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        h_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        con = run_hhblits.native(h_df,t_i_df)

        np.save(save_path,con)

def use_hhsearch_native():
    run_hhblits = HHblits()

    searched_path = "feature/hhsearch/searched/searched_nr.csv"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    srch_df = pd.read_csv(searched_path)
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    save_l = [
        "feature/native/training/hhsearch/cv0{}.npy".format(x)\
            for x in range(n)
    ]
    
    for i in range(n):
        fold_num = str(i)
        save_path = save_l[i]

        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_df = template_df.join(kv_df.set_index("template"),on="template")
        t_i_df = t_df.loc[~t_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        h_df = srch_df.loc[~srch_df.loc[:,"query"].isin(cv_df.loc[:,fold_num])]
        h_df = h_df.loc[~h_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        con = run_hhblits.native(h_df,t_i_df)

        np.save(save_path,con)

def test_hhsearch_native():
    run_hhblits = HHblits()

    searched_path = "feature/hhsearch/searched/searched_nr.csv"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    srch_df = pd.read_csv(searched_path)
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    save_l = [
        "feature/native/hhsearch/cv0{}.npy".format(x)\
            for x in range(n)
    ]
    
    for i in range(n):
        fold_num = str(i)
        save_path = save_l[i]

        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_df = template_df.join(kv_df.set_index("template"),on="template")
        t_i_df = t_df.loc[~t_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        h_df = srch_df.loc[srch_df.loc[:,"query"].isin(cv_df.loc[:,fold_num])]
        h_df = h_df.loc[~h_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        con = run_hhblits.native(h_df,t_i_df)

        np.save(save_path,con)

def val_hhsearch_native():
    run_hhblits = HHblits()

    searched_path = "feature/hhsearch/searched/validation_nr.csv"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    srch_df = pd.read_csv(searched_path)
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    save_l = [
        "feature/native/training/hhsearch/val0{}.npy".format(x)\
            for x in range(n)
    ]
    
    for i in range(n):
        fold_num = str(i)
        save_path = save_l[i]

        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_df = template_df.join(kv_df.set_index("template"),on="template")
        t_i_df = t_df.loc[~t_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        h_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        con = run_hhblits.native(h_df,t_i_df)

        np.save(save_path,con)
        cli_print = "printf '{}\n'".format(save_path)
        sp.call(cli_print,shell=True)


# 将hhmm和pssm相关特征组合
def merge_hmm_pssm():
    hmm_rep_path = "feature/hhblits/representation/representation_profile.npy"
    pssm_rep_path = "feature/psiblast/representation/representation_profile.npy"
    merge_rep_path = "feature/profile/representation.npy"

    hrep = np.load(hmm_rep_path)
    prep = np.load(pssm_rep_path)

    mrep = np.concatenate([hrep,prep],axis=1)
    np.save(merge_rep_path,mrep)

def valm_hmm_pssm():
    hmm_rep_path = "feature/hhblits/representation/val_representation_profile.npy"
    pssm_rep_path = "feature/psiblast/representation/val_representation_profile.npy"
    merge_rep_path = "feature/profile/val_representation.npy"

    hrep = np.load(hmm_rep_path)
    prep = np.load(pssm_rep_path)

    mrep = np.concatenate([hrep,prep],axis=1)
    np.save(merge_rep_path,mrep)

################################################################################################################################################
# 在独立测试集SCOPe上进行测试，用SCOPe中的每一条序列检索SCOP
################################################################################################################################################
def ind_fasta2ff():
    fasPath = "dataset/benchmark/all/independent"
    ffdataPath = "dataset/benchmark/db/tmp/independent.ffdata"
    ffindexPath = "dataset/benchmark/db/tmp/independent.ffindex"

    ffindex_from_fasta = "ffindex_from_fasta {} {} {}".format(ffdataPath,ffindexPath,fasPath)
    sp.call(ffindex_from_fasta,shell=True)

def ind_search():

    run_hhblits = HHblits()
    set_params = {
        "input":"",
        "db":"dataset/benchmark/db/all/SCOP_Experimental",
        "output":"",
        "iteration":3,
        "cpu_core":1,
        "maxfilt":500000,
        "diff":"inf",
        "id":99,
        "cov":60,
        "np":10
    }


    ffPath = "dataset/benchmark/db/tmp/independent"
    outputPath = "feature/hhblits/searched/independent.hhr"
    set_params["input"] = ffPath
    set_params["output"] = outputPath
    run_hhblits.search(set_params)

def ind_parsing_hhblits():
    from Bio.SeqIO import parse

    fasPath = "dataset/benchmark/all/independent"
    with open(fasPath,"r") as h:
        seqName_l = [r.name for r in parse(h,"fasta")]
    val_df = pd.DataFrame(seqName_l,columns=["template"])

    searchedPath = "feature/hhblits/searched/independent.csv"

    hhrPath = "feature/hhblits/searched/independent.hhr.ffdata"
    hhrIndexPath = "feature/hhblits/searched/independent.hhr.ffindex"

    buf_l = []
    run_hhblits = HHblits()
    with open(hhrIndexPath,"r") as h:
        hhrIAry = np.loadtxt(h,dtype=str)
    hhrI_df = pd.DataFrame(hhrIAry,columns=["query","num 1","num 2"])
    diff_ss = val_df.loc[~val_df.loc[:,"template"].isin(hhrI_df.loc[:,"query"]),"template"]
    m = diff_ss.shape[0]
    buf_l.append(run_hhblits.parsing_searched_result(hhrPath))
    res_buf = []
    if m > 1:
        dss1 = diff_ss.loc[~pd.isna(diff_ss)]
        for x in dss1:
            res_buf.append([x] + [None]*5)
    buf_l.append(res_buf)

    buffer = ft.reduce(lambda x,y: x+y,buf_l)
    cols = ["query","template","prob", "evalue", "pvalue", "score"]
    df = pd.DataFrame(buffer,columns=cols)
    df = df.astype({"query":str,"template":str,"prob":float, "evalue":float, "pvalue":float, "score":float})

    df.to_csv(searchedPath,index=False)  

def ind_fasta2a3mAndhhm():
    ffPath = "dataset/benchmark/db/tmp/independent"
    dbPath = "dataset/db/uniprot20_2016_02/uniprot20_2016_02"
    a3mPath = "dataset/benchmark/db/independent/independent_a3m"
    hhmPath = "dataset/benchmark/db/independent/independent_hhm"

    cmd = "mpirun -np 11 \
        hhblits_mpi -i {} -d {} -oa3m {} -ohhm {} -n 2 -cpu 1 -maxfilt 500000 -diff inf -id 99 -cov 60".format(
            ffPath,dbPath,a3mPath,hhmPath
        )
    # print(cmd)
    sp.call(cmd,shell=True)
    
def ind_rm_repetitive():
    searchedFilePath = "feature/hhblits/searched/independent.csv"
    targetFilePath = "feature/hhblits/searched/independent_nr.csv"
    run_hhblits = HHblits()
    run_hhblits.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)

def ind_splitHMMData():
    hmmPath = "dataset/benchmark/db/independent/independent_hhm.ffdata"
    targetDir = "feature/hhblits/hmm/independent"

    with open(hmmPath,"r") as h:
        spliter = genHMMFromFile(h)
        for q, content in spliter:
            querPath = os.path.join(targetDir,"{}.hmm".format(q))
            # L.append(querPath)
            with open(querPath,"w") as h1:
                h1.writelines(content)

def ind_convert_hmm2csv():
    from Bio.SeqIO import parse
    run_hhblits = HHblits()
    hmmDir = "feature/hhblits/hmm/independent"
    fasPath = "dataset/benchmark/all/independent"
    with open(fasPath,"r") as h:
        seq_list = [
            r.name for r in parse(h,"fasta")
        ]
    for name in seq_list:
        hmmName = "{}.hmm".format(name)
        hmmFilePath = os.path.join(hmmDir,hmmName)
        csvFilePath = os.path.join(hmmDir,"{}.csv".format(name))
        run_hhblits.hmm2csvFormat(hmmFilePath,csvFilePath)

def ind_use_acc_hmm():
    from Bio.SeqIO import parse
    hmmDir = "feature/hhblits/hmm/independent"
    sequence_name2row_num_path = "feature/hhblits/acc_hmm/ind_sequence_name2row_num.csv"
    fasPath = "dataset/benchmark/all/independent"
    forceFlag = True # 如果要强制更新就改为True
    if forceFlag or not os.path.exists(sequence_name2row_num_path):
        all_file_name_l = []

        # name_l = [getFileNameWithoutSurfix(x)[0] for x in os.listdir(hmmDir) \
        #     if getFileNameWithoutSurfix(x)[1] == "csv"]
        with open(fasPath,"r") as h:
            name_l = [
                r.name for r in parse(h,"fasta")
            ]
        name_l = sorted(name_l)
        all_file_name_l += name_l
    
        row_num_l = list(range(len(all_file_name_l)))

        sn2rN_df = pd.DataFrame(row_num_l,columns=["row num"],index=all_file_name_l)
        with open(sequence_name2row_num_path,"w",newline='') as h:
            sn2rN_df.to_csv(h)

    acc_list = []
    run_hhblits = HHblits()

    with open(fasPath,"r") as h:
        name_l = [
            "{}.csv".format(r.name) for r in parse(h,"fasta")
        ]
    name_l = sorted(name_l)
    for name in name_l:
        hmm_csvFormat_path = os.path.join(hmmDir,name)
        acc_hmm = run_hhblits.acc_hmm(hmm_csvFormat_path) # 默认LG=5
        m = acc_hmm.shape[0]
        if m != 2000:
            # print(name_l)
            print(hmm_csvFormat_path)
            break
        acc_list.append(acc_hmm)
    
    acc_hmm_mat_path = "feature/hhblits/acc_hmm/ind_representaion_profile.npy"
    acc_hmm_mat = np.vstack(acc_list)

    # try:
    np.save(acc_hmm_mat_path,acc_hmm_mat)

def ind_top_n_gram():
    from Bio.SeqIO import parse
    hmmDir = "feature/hhblits/hmm/independent"
    fasPath = "dataset/benchmark/all/independent"

    run_hhblits = HHblits()

    with open(fasPath,"r") as h:
        # name_l = [x for x in os.listdir(hmmDir) \
        #     if getFileNameWithoutSurfix(x)[1] == "csv"]
        name_l = [
            "{}.csv".format(r.name) for r in parse(h,"fasta")
        ]
    name_l = sorted(name_l)

    ngram = 1
    L = 20
    top_n_gram_list = []

    for name in name_l:
        hmm_csvFormat_path = os.path.join(hmmDir,name)
        top_n_gram_list.append(run_hhblits.top_n_gram(hmm_csvFormat_path,ngram,L))

    top_n_gram_path = "feature/hhblits/top_n_gram/top{}/ind_representation_profile.npy".format(ngram)
    top_n_gram_mat = np.vstack(top_n_gram_list)

    np.save(top_n_gram_path,top_n_gram_mat)

    ngram = 2
    L = 20
    top_n_gram_list = []

    for name in name_l:
        hmm_csvFormat_path = os.path.join(hmmDir,name)
        top_n_gram_list.append(run_hhblits.top_n_gram(hmm_csvFormat_path,ngram,L))
    
    top_n_gram_path = "feature/hhblits/top_n_gram/top{}/ind_representation_profile.npy".format(ngram)
    top_n_gram_mat = np.vstack(top_n_gram_list)

    np.save(top_n_gram_path,top_n_gram_mat)

def ind_combine_topn():
    top1_path = "feature/hhblits/top_n_gram/top1/ind_representation_profile.npy"
    top2_path = "feature/hhblits/top_n_gram/top2/ind_representation_profile.npy"
    topc_path = "feature/hhblits/top_n_gram/combine/ind_representation_profile.npy"

    top1_ary = np.load(top1_path)
    top2_ary = np.load(top2_path)

    topc_ary = np.hstack([top1_ary,top2_ary])
    np.save(topc_path,topc_ary)

def ind_acc_topn():
    acc_path = "feature/hhblits/acc_hmm/ind_representation_profile.npy"
    topn_path = "feature/hhblits/top_n_gram/combine/ind_representation_profile.npy"
    comb_path = "feature/hhblits/representation/ind_representation_profile.npy"
    
    acc_ary = np.load(acc_path)
    topn_ary = np.load(topn_path)

    cary = np.hstack([acc_ary,topn_ary])
    np.save(comb_path,cary)


def ind_hhsearch():
    run_hhblits = HHblits()
    set_params = {
        "input":"dataset/benchmark/db/tmp/independent",
        "db":"dataset/benchmark/db/all/SCOP_Experimental",
        "output":"feature/hhsearch/searched/independent.hhr",
        "cpu_core":1,
        "diff":"inf",
        "id":99,
        "cov":60,
        "np":11
    }

    run_hhblits.hhsearch(set_params)

def ind_parsing_hhsearch():
    from Bio.SeqIO import parse

    fasPath = "dataset/benchmark/all/independent"
    with open(fasPath,"r") as h:
        seqName_l = [r.name for r in parse(h,"fasta")]
    val_df = pd.DataFrame(seqName_l,columns=["template"])

    searchedPath = "feature/hhsearch/searched/independent.csv"

    hhrPath = "feature/hhsearch/searched/independent.hhr.ffdata"
    hhrIndexPath = "feature/hhsearch/searched/independent.hhr.ffindex"

    buf_l = []
    run_hhblits = HHblits()
    with open(hhrIndexPath,"r") as h:
        hhrIAry = np.loadtxt(h,dtype=str)
    hhrI_df = pd.DataFrame(hhrIAry,columns=["query","num 1","num 2"])
    diff_ss = val_df.loc[~val_df.loc[:,"template"].isin(hhrI_df.loc[:,"query"]),"template"]
    m = diff_ss.shape[0]
    buf_l.append(run_hhblits.parsing_searched_result(hhrPath))
    res_buf = []
    if m > 1:
        dss1 = diff_ss.loc[~pd.isna(diff_ss)]
        for x in dss1:
            res_buf.append([x] + [None]*5)
    buf_l.append(res_buf)

    buffer = ft.reduce(lambda x,y: x+y,buf_l)
    cols = ["query","template","prob", "evalue", "pvalue", "score"]
    df = pd.DataFrame(buffer,columns=cols)
    df = df.astype({"query":str,"template":str,"prob":float, "evalue":float, "pvalue":float, "score":float})

    df.to_csv(searchedPath,index=False)

def ind_hhsearch_rep():
    searchedFilePath = "feature/hhsearch/searched/independent.csv"
    targetFilePath = "feature/hhsearch/searched/independent_nr.csv"
    run_hhblits = HHblits()
    run_hhblits.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)


def indm_hmm_pssm():
    hmm_rep_path = "feature/hhblits/representation/ind_representation_profile.npy"
    pssm_rep_path = "feature/psiblast/representation/ind_representation_profile.npy"
    merge_rep_path = "feature/profile/ind_representation.npy"

    hrep = np.load(hmm_rep_path)
    prep = np.load(pssm_rep_path)

    mrep = np.concatenate([hrep,prep],axis=1)
    np.save(merge_rep_path,mrep)

def ind_srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    ind_kv_path = "dataset/SCOPe/csv/sequence_superfamily.csv"
    # searched_path = "feature/hhblits/searched/independent_nr.csv"
    searched_path = "feature/hhsearch/searched/independent_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    dkv_df = pd.read_csv(ind_kv_path)
    srch_df = pd.read_csv(searched_path)

    # 要把kv_df, dkv_df的sf组合起来
    m_df = pd.concat([kv_df,dkv_df])
    mg = m_df.groupby("template")
    idx = [x[0] for x in mg.groups.values()]
    m_df = m_df.loc[idx,["template","sf"]]
    m_df = m_df.reset_index(drop=True)
    mg = m_df.groupby("sf")
    idx = [x[0] for x in mg.groups.values()]
    sf_df = m_df.loc[idx, ["sf"]].reset_index(drop=True)
    sf_df = sf_df.reset_index().rename(columns={"index":"label"})
    m_df = m_df.join(sf_df.set_index("sf"),on="sf")

    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = False # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    each_flag = False # 这个标志控制是否输出每个序列的评估结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        
        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)

if __name__ == "__main__":
    import os
    import subprocess as sp
    import pandas as pd
    import numpy as np
    import tensorflow as tf
    from six.moves import cPickle
    import functools as ft
    import re
    from src.utils.feature_extraction import HHblits
    from src.evaluation.cross_validation import Run

    # fasta2ffFile()
    # fasta2a3m()
    # fasta2a3mAndhhm()
    # validation_fasta2a3mAndhhm()
    # splitHMMData()
    # validation_splitHMMData()
    # a3m2hhm()
    # a3m2cs219()
    # use_hhblits_to_search()
    # parsing_searched_result()
    # validation_search()
    # parsing_validation_result()
    # use_hhsearch()
    # parsing_hhsearch_result()
    # val_hhsearch()
    # val_parsing_hhsearch()
    # remove_redundancy_pairwise()
    # remove_repetitive_pairwise()
    # val_rm_repetitive()
    # hhsearch_rm_rep_pairwise()
    # hhsearch_rm_red_pairwise()
    # val_hhsearch_rm_rep()
    # convert_hmm2csv()
    # validation_convert_hmm2csv()
    # use_acc_hmm()
    # validation_use_acc_hmm()
    # use_top_n_gram()
    # val_top_n_gram()
    # combine_top_n_gram()
    # val_combine_topn()
    # comb_acc_topn()
    # val_acc_topn()
    # use_native()
    # test_native()
    # val_native()
    # merge_hmm_pssm()
    # valm_hmm_pssm()

    ind_srch_roc_at()

##############################################################################################################################################
# 独立测试集
##############################################################################################################################################
    # ind_fasta2ff()
    # ind_search()
    # ind_parsing_hhblits()
    # ind_fasta2a3mAndhhm()
    # ind_rm_repetitive()
    # ind_hhsearch()
    # ind_parsing_hhsearch()
    # ind_hhsearch_rep()
    # indm_hmm_pssm()