def search_by_hmm():
    n = 5

    run_hhblits = HHblits()
    set_params = {
        "input":"dataset/benchmark/db/all/SCOP_Experimental_hhm",
        "db":"dataset/benchmark/db/all/SCOP_Experimental",
        "output":"feature/hhblitsexb/searched/scop_hhblits_hhr",
        "evalue":1e-3,
        "iteration":5,
        "cpu_core":1,
        "maxfilt":500000,
        "diff":"inf",
        "id":99,
        "cov":60,
        "np":20
    }

    run_hhblits.search_by_hmm(set_params)

def vsearch_by_hmm():
    n = 5

    run_hhblits = HHblits()
    set_params = {
        "input":"dataset/benchmark/db/validation/validation_hhm",
        "db":"dataset/benchmark/db/all/SCOP_Experimental",
        "output":"feature/hhblitsexb/searched/val_hhblits_hhr",
        "evalue":1e-3,
        "iteration":5,
        "cpu_core":1,
        "maxfilt":500000,
        "diff":"inf",
        "id":99,
        "cov":60,
        "np":20
    }

    run_hhblits.search_by_hmm(set_params)

def isearch_by_hmm():
    n = 5

    run_hhblits = HHblits()
    set_params = {
        "input":"dataset/benchmark/db/independent/independent_hhm",
        "db":"dataset/benchmark/db/all/SCOP_Experimental",
        "output":"feature/hhblitsexb/searched/ind_hhblits_hhr",
        "evalue":1e-3,
        "iteration":5,
        "cpu_core":1,
        "maxfilt":500000,
        "diff":"inf",
        "id":99,
        "cov":60,
        "np":21
    }

    run_hhblits.search_by_hmm(set_params)

def parsing_searched_result():
    hhrPath = "/home/shaojiangyi/source/C2C-DFG-LTR/feature/hhblitsexb/searched/scop_hhblits_hhr.ffdata"
    hhrIndexPath = "feature/hhblitsexb/searched/scop_hhblits_hhr.ffindex"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    cv_df = pd.read_csv(cross_validation_path)

    searchedPath = "feature/hhblitsexb/searched/searched.csv"

    run_hhblits = HHblits()
    
    with open(hhrIndexPath,"r") as h:
        hhrIAry = np.loadtxt(h,dtype=str)

    buffer = run_hhblits.parsing_searched_result(hhrPath)

    cols = ["query","template","prob", "evalue", "pvalue", "score"]
    df = pd.DataFrame(buffer,columns=cols)
    df = df.astype({"query":str,"template":str,"prob":float, "evalue":float, "pvalue":float, "score":float})
    with open(searchedPath,"w",newline='') as h:
        df.to_csv(h,index=False)

def val_parsing_result():
    hhrPath = "/home/shaojiangyi/source/C2C-DFG-LTR/feature/hhblitsexb/searched/val_hhblits_hhr.ffdata"
    hhrIndexPath = "feature/hhblitsexb/searched/val_hhblits_hhr.ffindex"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    cv_df = pd.read_csv(cross_validation_path)

    searchedPath = "feature/hhblitsexb/searched/validation.csv"

    run_hhblits = HHblits()
    
    with open(hhrIndexPath,"r") as h:
        hhrIAry = np.loadtxt(h,dtype=str)

    buffer = run_hhblits.parsing_searched_result(hhrPath)

    cols = ["query","template","prob", "evalue", "pvalue", "score"]
    df = pd.DataFrame(buffer,columns=cols)
    df = df.astype({"query":str,"template":str,"prob":float, "evalue":float, "pvalue":float, "score":float})
    with open(searchedPath,"w",newline='') as h:
        df.to_csv(h,index=False)


def ind_parsing_result():
    hhrPath = "/home/shaojiangyi/source/C2C-DFG-LTR/feature/hhblitsexb/searched/ind_hhblits_hhr.ffdata"
    hhrIndexPath = "feature/hhblitsexb/searched/ind_hhblits_hhr.ffindex"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    cv_df = pd.read_csv(cross_validation_path)

    searchedPath = "feature/hhblitsexb/searched/independent.csv"

    run_hhblits = HHblits()
    
    with open(hhrIndexPath,"r") as h:
        hhrIAry = np.loadtxt(h,dtype=str)

    buffer = run_hhblits.parsing_searched_result(hhrPath)

    cols = ["query","template","prob", "evalue", "pvalue", "score"]
    df = pd.DataFrame(buffer,columns=cols)
    df = df.astype({"query":str,"template":str,"prob":float, "evalue":float, "pvalue":float, "score":float})
    with open(searchedPath,"w",newline='') as h:
        df.to_csv(h,index=False)


def remove_repetitive_pairwise():
    searchedFilePath = "feature/hhblitsexb/searched/searched.csv"
    targetFilePath = "feature/hhblitsexb/searched/searched_nr.csv"
    run_hhblits = HHblits()
    run_hhblits.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)

def val_rm_repetitive():
    searchedFilePath = "feature/hhblitsexb/searched/validation.csv"
    targetFilePath = "feature/hhblitsexb/searched/validation_nr.csv"
    run_hhblits = HHblits()
    run_hhblits.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)

def ind_rm_repetitive():
    searchedFilePath = "feature/hhblitsexb/searched/independent.csv"
    targetFilePath = "feature/hhblitsexb/searched/independent_nr.csv"
    run_hhblits = HHblits()
    run_hhblits.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)

def srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    searched_path = "feature/hhblitsexb/searched/searched_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    srch_df = pd.read_csv(searched_path)

    each_flag = False # 控制输出每个序列的评估结果

    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = True # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[srch_df.loc[:,"query"].isin(cv_df.loc[:,fold_num])]
        pairwise_df = pairwise_df.loc[~pairwise_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])
            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)

def ind_srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    ind_kv_path = "dataset/SCOPe/csv/sequence_superfamily.csv"
    searched_path = "feature/hhblitsexb/searched/independent_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    dkv_df = pd.read_csv(ind_kv_path)
    srch_df = pd.read_csv(searched_path)

    # 要把kv_df, dkv_df的sf组合起来
    m_df = pd.concat([kv_df,dkv_df])
    mg = m_df.groupby("template")
    idx = [x[0] for x in mg.groups.values()]
    m_df = m_df.loc[idx,["template","sf"]]
    m_df = m_df.reset_index(drop=True)
    mg = m_df.groupby("sf")
    idx = [x[0] for x in mg.groups.values()]
    sf_df = m_df.loc[idx, ["sf"]].reset_index(drop=True)
    sf_df = sf_df.reset_index().rename(columns={"index":"label"})
    m_df = m_df.join(sf_df.set_index("sf"),on="sf")

    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = False # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    each_flag = False # 这个标志控制是否输出每个序列的评估结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        
        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)


def val_srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    searched_path = "feature/hhblitsexb/searched/validation_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    srch_df = pd.read_csv(searched_path)

    each_flag = False # 控制输出每个序列的评估结果

    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = True # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)


if __name__ == "__main__":
    import os
    import subprocess as sp
    import pandas as pd
    import numpy as np
    import tensorflow as tf
    from six.moves import cPickle
    import functools as ft
    import re
    from src.utils.feature_extraction import HHblits
    from src.evaluation.cross_validation import Run

    # search_by_hmm()
    # vsearch_by_hmm()
    # isearch_by_hmm()
    # parsing_searched_result()
    # val_parsing_result()
    # ind_parsing_result()
    # remove_repetitive_pairwise()
    # val_rm_repetitive()
    # ind_rm_repetitive()
    # srch_roc_at()
    # ind_srch_roc_at()
    val_srch_roc_at()