def training_ltr():
    run_lambdamart = LambdaMART()

    
    # boosting_type = "dart" # dart 的目的是提高模型的泛化能力, 但是early_stopping会失效
    '''
    max_bin过大也可能引起过拟合
    参考朱山风老师的论文，max_depth设置为4，因此，leaves<2**max_depth,设置为11
    但是这样不如max_depth=9, leaves=255（并不）
    但是如果此时增加max_bin呢？
    对于测试集而言roc1会增加，但对应roc50减少
    对验证集而言roc1, roc50都会下降
    目前在SCOP1.75和SCOPe2.07上综合表现最好的是num_leaves: 11, max_depth:4, max_bin:1023
    改变训练集的特征后，num_boost_round: 67, num_leaves: 11, max_depth:4, max_bin:255表现最好
    20201002-10:30:44, leaves: 11, max_depth: 4, max_bin: 255, learning_rate: 0.07表现最好
    '''
    params = {
        'boosting_type': boosting_type,
        'objective': "lambdarank",
        'metric': 'ndcg',
        'num_leaves':num_leaves,
        'max_depth':max_depth,
        'learning_rate': learning_rate,
        'feature_fraction': 1.0,
        'bagging_fraction': 0.9,
        'bagging_freq': 1,
        "max_bin":max_bin,
        "min_data_in_leaf":50,
        "min_sum_hessian_in_leaf":5.0,
        "is_enable_sparse":"true",
        "force_row_wise":"true",
        "lambda_l1":5.7,
        "lambda_l2":32.,
        "ndcg_eval_at":"50"
    }

    # # 为了方便得到label还要对kv_df处理一下
    # use_eval_flag = True
    # use_test_flag = False # 用测试集做验证集
    # norm_flag = False
    # eval_norm = True
    # test_first = False # 只测试第一折
    # use_time_stamp = True # 模型命名加上时间后缀
    # merge_flag = True # 多分类方法合成一个结果，同时也让排序方法合成一个排序结果

    # 因为发现tree少点的话，可以有效防止过拟合
    if use_test_flag or use_eval_flag:
        train_args = {
            "num_boost_round":num_boost_round,
            "early_stopping_rounds":early_stopping_rounds,
            "verbose_eval":5
        }
    else:
        train_args = {
            "num_boost_round":num_boost_round,
            "verbose_eval":5
        }

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    vspecific_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(vspecific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    vtemplate_df = vspec_df.reset_index().rename(columns={"index":"template"})

    # representation_dirs = [
    #     "feature/multiclassification/training/hhblits/representation",
    #     "feature/multiclassification/training/psiblast/representation",
    #     "feature/S2C/training_cluster/hhblitsexb",
    #     "feature/S2C/training_cluster/hhsearchexb",
    #     "feature/S2C/training_cluster/psiblastexb",
    #     "feature/S2C/training_cluster/deltablast"
    # ]

    # trepresentation_dirs = [
    #     "feature/multiclassification/hhblits/representation",
    #     "feature/multiclassification/psiblast/representation",
    #     "feature/S2C/test/hhblitsexb",
    #     "feature/S2C/test/hhblitsexb",
    #     "feature/S2C/test/psiblastexb",
    #     "feature/S2C/test/deltablast"
    # ]
    representation_dirs = [
        "feature/multiclassification/training/hhblits/representation",
        "feature/multiclassification/training/psiblastexb/representation",
        "feature/S2C/training_cluster/hhblitsexb",
        "feature/S2C/training_cluster/hhsearchexb",
        "feature/S2C/training_cluster/psiblastexb",
        "feature/S2C/training_cluster/deltablast"
    ]

    trepresentation_dirs = [
        "feature/multiclassification/hhblits/representation",
        "feature/multiclassification/psiblastexb/representation",
        "feature/S2C/test/hhblitsexb",
        "feature/S2C/test/hhblitsexb",
        "feature/S2C/test/psiblastexb",
        "feature/S2C/test/deltablast"
    ]


    # 去除某些特征
    feature_sel = np.array([True]*len(representation_dirs))
    elmask = []
    if not (elmask == [] or elmask is None):
        feature_sel[elmask] = False
        representation_dirs = np.array(representation_dirs)[feature_sel].tolist()
        trepresentation_dirs = np.array(trepresentation_dirs)[feature_sel].tolist()
    

    # if test_first:
    #     n = 1 # 用于测试第一折
    # else:
    #     n = 5

    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"cv0{}.npy".format(i)) \
                for x in representation_dirs
        ]

    vrepresentation_dict = {}
    for i in range(n):
        vrepresentation_dict[i] = [
            os.path.join(x,"val0{}.npy".format(i)) \
                for x in representation_dirs
        ]

    trepresentation_dict = {}
    for i in range(n):
        trepresentation_dict[i] = [
            os.path.join(x,"cv0{}.npy".format(i)) \
                for x in trepresentation_dirs
        ]


    k_df = template_df.join(kv_df.set_index("template"),on="template").loc[:,["template","sf","label"]]
    for i in range(n):
        fn_col = str(i)
        t_i_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = k_df.loc[~k_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = kv_i_df.sort_values(by="label")
    
        representation_l = representation_dict[i]
        vrepresentation_l = vrepresentation_dict[i]
        trepresentation_l = trepresentation_dict[i]

        query_df = template_df.loc[template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]

        save_path = save_booster_l[i]
        con = run_lambdamart.get_training_set(representation_l)
        # k_df不按交叉验证的划分结果去处理，是因为这里不仅仅处理训练集和验证集，还会处理测试集
        label = run_lambdamart.get_label(kv_df,kv_i_df, t_i_df,True)

        if merge_flag:
            con = run_lambdamart.merge_methods(con,[[0],[1],[1,2,3,4]])

        # # 进行行归一化
        if norm_flag:
            con = run_lambdamart.normalization(con,2)

        # 目前con还是n_sample * n_class * k大小
        # 这为了方便得到group
        group = con.shape[1]*np.ones(con.shape[0])
        # 构造dataset前对con和vcon进行reshape
        con = tf.reshape(con,(-1,con.shape[-1]))
        # label和vlabel目前也是n_sample*n_class大小，需要reshape
        label = tf.reshape(label,(-1,))
        
        train_set = lgb.Dataset(con.numpy(),label.numpy(),group=group)
        train_args["train_set"] = train_set

        if use_test_flag:
            tcon = run_lambdamart.get_training_set(trepresentation_l)
            tlabel = run_lambdamart.get_label(kv_df, kv_i_df, query_df,True)

            if merge_flag:
                tcon = run_lambdamart.merge_methods(tcon,[[0],[1],[1,2,3,4]])
            
            # 归一化
            if eval_norm:
                tcon = run_lambdamart.normalization(tcon,2)
            # 同理
            tgroup = tcon.shape[1]*np.ones(tcon.shape[0])
            tlabel = tf.reshape(tlabel,(-1,))
            tcon = tf.reshape(tcon,(-1,tcon.shape[-1]))
            test_set = lgb.Dataset(tcon.numpy(),tlabel.numpy(),group=tgroup)
            train_args["valid_sets"] = [test_set]

        elif use_eval_flag:
            vcon = run_lambdamart.get_training_set(vrepresentation_l)
            vlabel = run_lambdamart.get_label(kv_df, kv_i_df, vtemplate_df,True)

            if merge_flag:
                vcon = run_lambdamart.merge_methods(vcon,[[0],[1],[1,2,3,4]])

            # 归一化
            # 验证集也加上归一化试试
            if eval_norm:
                vcon = run_lambdamart.normalization(vcon,2)

            # 同理
            vgroup = vcon.shape[1]*np.ones(vcon.shape[0])
            vlabel = tf.reshape(vlabel,(-1,))
            vcon = tf.reshape(vcon,(-1,vcon.shape[-1]))
            val_set = lgb.Dataset(vcon.numpy(),vlabel.numpy(),group=vgroup)
            train_args["valid_sets"] = [val_set]

        booster = run_lambdamart.train(params,**train_args)
        
        # 保存训练好的模型
        booster.save_model(save_path)

# 在test_ltr进行准备
def pre_test_ltr():
    run_lambdamart = LambdaMART()
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"

    cv_df = pd.read_csv(cross_validation_path)
    
    searched_l = [
        "feature/mmseqs2/searched/searched_nr.csv",
        "feature/psiblast/searched/searched_nr.csv"
    ]

    n = 5
    # representation_dirs = [
    #     "feature/S2C/mmseqs2",
    #     "feature/S2C/psiblast"
    # ]
    representation_dirs = [
        "feature/native/mmseqs2",
        "feature/native/psiblast"
    ]

    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"cv0{}.npy".format(i))\
                for x in representation_dirs
        ]

    
    for i in range(n):
        fold_num = str(i)
        representation_l = representation_dict[i]
        query_ser = cv_df.loc[:,fold_num].sort_values()
        # 去掉na值
        query_ser = query_ser.loc[~pd.isna(query_ser)]
        # print(query_ser)
        for j, searched_path in enumerate(searched_l):
            representation_path = representation_l[j]
            srch_df = pd.read_csv(searched_path)
            pairwise_df = srch_df.loc[srch_df.loc[:,"query"].isin(query_ser)]
            pairwise_df = pairwise_df.loc[~pairwise_df.loc[:,"template"].isin(query_ser)]

            con = tf.constant(np.load(representation_path),tf.float32)
            print(con.shape)
            con = run_lambdamart.completement_test_set(query_ser,pairwise_df,con)
            print(con.shape)
            np.save(representation_path,con) #把这句话注释掉可以观察输出结果


def test_ltr():
    run_lambdamart = LambdaMART()
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    save_output_flag = True

    template_df = spec_df.reset_index().rename(columns={"index":"template"})

    representation_dirs = [
        "feature/multiclassification/hhblits/representation",
        "feature/multiclassification/psiblastexb/representation",
        "feature/S2C/test/hhblitsexb",
        "feature/S2C/test/hhblitsexb",
        "feature/S2C/test/psiblastexb",
        "feature/S2C/test/deltablast"
    ]


    # 去除某些特征
    feature_sel = np.array([True]*len(representation_dirs))
    elmask = []
    if not (elmask == [] or elmask is None):
        feature_sel[elmask] = False
        representation_dirs = np.array(representation_dirs)[feature_sel].tolist()


    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"cv0{}.npy".format(i)) \
                for x in representation_dirs
        ]

    save_l = [
        "feature/LTR/representation/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    output_file_path = "evaluation/roc_at/lightgbm/lambdarank/representation/eval_seq_rocat.txt"

    # 为了方便得到label还要对kv_df处理一下
    k_df = template_df.join(kv_df.set_index("template"),on="template").loc[:,["template","sf","label"]]
    roc_score_list = []
    for i in range(n):
        fn_col = str(i)
        query_df = template_df.loc[template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        # print(query_df)
        representation_l = representation_dict[i]
        load_path = save_booster_l[i]
        booster = lgb.Booster(model_file=load_path)

        # 构造测试集，不同方法的测试结果，对于某些序列可能缺失，因此要进行补全
        # 在进行测试之前调用run_lambdamart.completement_test_set进行补全
        # 参考pre_test_ltr()程序
        kv_i_df = k_df.loc[~k_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = kv_i_df.sort_values(by="label")

        con = run_lambdamart.get_training_set(representation_l)
        label = run_lambdamart.get_label(kv_df, kv_i_df, query_df,keepdims=True)

        if merge_flag:
            con = run_lambdamart.merge_methods(con,[[0],[1],[1,2,3,4]])

        # 行归一化
        # 因为con是n_sample*n_class*k大小的tensor
        # 要对k个特征进行行归一化
        if eval_norm:
            con = run_lambdamart.normalization(con,2)

        # print(con.shape)
        # print(label.shape)
        X = con.numpy()
        y = label.numpy()

        cv_list = []
        for j in range(X.shape[0]):
            X_test = X[j] # n_class * k
            y_test = y[j] # n_class

            y_pred = booster.predict(X_test, raw_score=True)
            indices = tf.argsort(y_pred,axis=0,direction="DESCENDING").numpy()
            # indices = np.flip(np.argsort(y_pred,axis=0),0)
            # print(indices.shape)
            # print(indices)
            # print(y.shape)
            yt = y_test[indices]
            score1 = run_cv.cal_roc_mu_at(1,yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)
            try:
                ascore = roc_auc_score(y_test,y_pred)
            except:
                ascore = 0.0
            if each_flag:
                cli_print = "printf '{} {} {}\n'".format(score1,score50,ascore)
                sp.call(cli_print,shell=True) 
            roc_score_list.append([score1,score50,ascore])
            cv_list.append(y_pred)

        if save_flag:
            save_path = save_l[i]
            np.save(save_path,np.array(cv_list))
    
    roc_ary = np.array(roc_score_list)
    score = roc_ary.mean(0)

    if save_output_flag:
        np.savetxt(output_file_path,roc_ary,"%.16f")
    
    # cli_print = "printf '{}\n'".format(score)
    # sp.call(cli_print,shell=True)
    print(score)

def pre_val_ltr():
    run_lambdamart = LambdaMART()
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    
    searched_l = [
        "feature/hhsearch/searched/validation_nr.csv"
    ]

    n = 5
    representation_dirs = [
        "feature/S2C/training_cluster/hhsearch"
    ]

    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"val0{}.npy".format(i))\
                for x in representation_dirs
        ]

    ind_ser = pd.Series(spec_df.index)
    for i in range(n):
        fold_num = str(i)
        representation_l = representation_dict[i]

        # print(query_ser)
        for j, searched_path in enumerate(searched_l):
            representation_path = representation_l[j]
            srch_df = pd.read_csv(searched_path)
            srch_df = srch_df.loc[~pd.isna(srch_df.loc[:,"template"])]
            pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

            con = tf.constant(np.load(representation_path),tf.float32)
            print(con.shape)
            con = run_lambdamart.completement_test_set(ind_ser,pairwise_df,con)
            print(con.shape)
            # np.save(representation_path,con) #把这句话注释掉可以观察输出结果


def val_ltr():
    run_lambdamart = LambdaMART()
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    vspecific_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(vspecific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    vtemplate_df = vspec_df.reset_index().rename(columns={"index":"template"})

    representation_dirs = [
        "feature/multiclassification/training/hhblits/representation",
        "feature/multiclassification/training/psiblastexb/representation",
        "feature/S2C/training_cluster/hhblitsexb",
        "feature/S2C/training_cluster/hhsearchexb",
        "feature/S2C/training_cluster/psiblastexb",
        "feature/S2C/training_cluster/deltablast"
    ]

    # 去除某些特征
    feature_sel = np.array([True]*len(representation_dirs))
    elmask = []
    if not (elmask == [] or elmask is None):
        feature_sel[elmask] = False
        representation_dirs = np.array(representation_dirs)[feature_sel].tolist()
        
    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"val0{}.npy".format(i)) \
                for x in representation_dirs
        ]
    
    if save_flag:
        save_l = [
            "feature/LTR/training/representation/val0{}.npy".format(x) \
                for x in range(n)
        ]

    # 为了方便得到label还要对kv_df处理一下
    k_df = template_df.join(kv_df.set_index("template"),on="template").loc[:,["template","sf","label"]]
    roc_score_list = []
    for i in range(n):
        fn_col = str(i)
        # print(query_df)
        representation_l = representation_dict[i]
        load_path = save_booster_l[i]
        booster = lgb.Booster(model_file=load_path)

        # 构造测试集，不同方法的测试结果，对于某些序列可能缺失，因此要进行补全
        # 在进行测试之前调用run_lambdamart.completement_test_set进行补全
        # 参考pre_test_ltr()程序
        kv_i_df = k_df.loc[~k_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = kv_i_df.sort_values(by="label")

        con = run_lambdamart.get_training_set(representation_l)
        label = run_lambdamart.get_label(kv_df,kv_i_df, vtemplate_df,keepdims=True)

        if merge_flag:
            con = run_lambdamart.merge_methods(con,[[0],[1],[1,2,3,4]])

        # 行归一化
        # 因为con是n_sample*n_class*k大小的tensor
        # 要对k个特征进行行归一化
        if eval_norm:
            con = run_lambdamart.normalization(con,2)

        # print(con.shape)
        # print(label.shape)
        X = con.numpy()
        y = label.numpy()

        cv_list = []
        for j in range(X.shape[0]):
            X_test = X[j] # n_class * k
            y_test = y[j] # n_class

            y_pred = booster.predict(X_test, raw_score=True)
            indices = tf.argsort(y_pred,axis=0,direction="DESCENDING").numpy()
            # indices = np.flip(np.argsort(y_pred,axis=0),0)
            # print(indices.shape)
            # print(indices)
            # print(y.shape)
            yt = y_test[indices]
            score1 = run_cv.cal_roc_mu_at(1,yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)
            try:
                ascore = roc_auc_score(y_test,y_pred)
            except:
                ascore = 0.0
            if each_flag:
                cli_print = "printf '{} {} {}\n'".format(score1,score50,ascore)
                sp.call(cli_print,shell=True) 
            roc_score_list.append([score1,score50,ascore])
            cv_list.append(y_pred)

        if save_flag:
            save_path = save_l[i]
            np.save(save_path,np.array(cv_list))

    score = np.array(roc_score_list).mean(0)
    # cli_print = "printf '{}\n'".format(score)
    # sp.call(cli_print,shell=True)
    print(score)

def pre_ind_ltr():
    run_lambdamart = LambdaMART()
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/ind_sequence_name2row_num.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    
    searched_l = [
        "feature/mmseqs2/searched/independent_nr.csv"
    ]

    n = 5
    representation_dirs = [
        "feature/S2C/training_cluster/mmseqs2"
    ]

    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"ind0{}.npy".format(i))\
                for x in representation_dirs
        ]

    ind_ser = pd.Series(spec_df.index)
    for i in range(n):
        fold_num = str(i)
        representation_l = representation_dict[i]

        # print(query_ser)
        for j, searched_path in enumerate(searched_l):
            representation_path = representation_l[j]
            srch_df = pd.read_csv(searched_path)
            srch_df = srch_df.loc[~pd.isna(srch_df.loc[:,"template"])]
            pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

            con = tf.constant(np.load(representation_path),tf.float32)
            print(con.shape)
            con = run_lambdamart.completement_test_set(ind_ser,pairwise_df,con)
            print(con.shape)
            np.save(representation_path,con) #把这句话注释掉可以观察输出结果


def ind_ltr():
    run_lambdamart = LambdaMART()
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    # key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    ikey2value_path = "dataset/scop_scope/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    ispecific_path = "feature/hhblits/acc_hmm/ind_sequence_name2row_num.csv"
    output_file_path = "evaluation/roc_at/lightgbm/lambdarank/representation/ind_seq_rocat.txt"

    cv_df = pd.read_csv(cross_validation_path)
    # kv_df = pd.read_csv(key2value_path)
    ikv_df = pd.read_csv(ikey2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    ispec_df = pd.read_csv(ispecific_path,index_col=0)


    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    itemplate_df = ispec_df.reset_index().rename(columns={"index":"template"})

    representation_dirs = [
        "feature/multiclassification/training/hhblits/representation",
        "feature/multiclassification/training/psiblastexb/representation",
        "feature/S2C/training_cluster/hhblitsexb",
        "feature/S2C/training_cluster/hhsearchexb",
        "feature/S2C/training_cluster/psiblastexb",
        "feature/S2C/training_cluster/deltablast"
    ]

    # 去除某些特征
    feature_sel = np.array([True]*len(representation_dirs))
    elmask = []
    if not (elmask == [] or elmask is None):
        feature_sel[elmask] = False
        representation_dirs = np.array(representation_dirs)[feature_sel].tolist()

        
    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"ind0{}.npy".format(i)) \
                for x in representation_dirs
        ]
    
    if save_flag:
        save_l = [
            "feature/LTR/training/representation/ind0{}.npy".format(x) \
                for x in range(n)
        ]
    save_output_flag = True

    # 为了方便得到label还要对kv_df处理一下
    # 这里使用ikv_df是为了保证后面能正确生成label
    ik_df = template_df.join(ikv_df.set_index("template"),on="template").loc[:,["template","sf","label"]]
    roc_score_list = []
    for i in range(n):
        fn_col = str(i)
        # print(query_df)
        representation_l = representation_dict[i]
        load_path = save_booster_l[i]
        booster = lgb.Booster(model_file=load_path)

        # 构造测试集，不同方法的测试结果，对于某些序列可能缺失，因此要进行补全
        # 在进行测试之前调用run_lambdamart.completement_test_set进行补全
        # 参考pre_test_ltr()程序
        kv_i_df = ik_df.loc[~ik_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = kv_i_df.sort_values(by="label")

        con = run_lambdamart.get_training_set(representation_l)
        label = run_lambdamart.get_label(ikv_df,kv_i_df, itemplate_df,keepdims=True)

        if merge_flag:
            con = run_lambdamart.merge_methods(con,[[0],[1],[1,2,3,4]])

        # 行归一化
        # 因为con是n_sample*n_class*k大小的tensor
        # 要对k个特征进行行归一化
        if eval_norm:
            con = run_lambdamart.normalization(con,2)

        # print(con.shape)
        # print(label.shape)
        X = con.numpy()
        y = label.numpy()

        cv_list = []
        for j in range(X.shape[0]):
            X_test = X[j] # n_class * k
            y_test = y[j] # n_class

            y_pred = booster.predict(X_test, raw_score=True)
            indices = tf.argsort(y_pred,axis=0,direction="DESCENDING").numpy()
            # indices = np.flip(np.argsort(y_pred,axis=0),0)
            # print(indices.shape)
            # print(indices)
            # print(y.shape)
            yt = y_test[indices]
            score1 = run_cv.cal_roc_mu_at(1,yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)
            try:
                ascore = roc_auc_score(y_test,y_pred)
            except:
                ascore = 0.0
            if each_flag:
                cli_print = "printf '{} {} {}\n'".format(score1,score50,ascore)
                sp.call(cli_print,shell=True) 
            roc_score_list.append([score1,score50,ascore])
            cv_list.append(y_pred)

        if save_flag:
            save_path = save_l[i]
            np.save(save_path,np.array(cv_list))

    roc_ary = np.array(roc_score_list)
    score = roc_ary.mean(0)
    if save_output_flag:
        np.savetxt(output_file_path,roc_ary,"%.16f")
    # cli_print = "printf '{}\n'".format(score)
    # sp.call(cli_print,shell=True)
    print(score)


def get_ltr_result():
    run_lambdamart = LambdaMART()
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    template_df = spec_df.reset_index().rename(columns={"index":"template"})

    representation_dirs = [
        "feature/multiclassification/training/hhblits/representation",
        "feature/multiclassification/training/psiblastexb/representation",
        "feature/S2C/training_cluster/hhblitsexb",
        "feature/S2C/training_cluster/hhsearchexb",
        "feature/S2C/training_cluster/psiblastexb",
        "feature/S2C/training_cluster/deltablast"
    ]

    # test_first = False # 只测试第一折
    # each_flag = False # 输出每个序列的roc1, roc50值
    # save_flag = True # 用于保存预测结果

    # if test_first:
    #     n = 1 # 用于测试第一折
    # else:
    #     n = 5
    # save_booster_l = [
    #     "model/all/fine_tunning/lightgbm/lambdarank/representation/cv0{}.txt".format(x)\
    #         for x in range(n)
    # ]

    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"cv0{}.npy".format(i)) \
                for x in representation_dirs
        ]
    
    if save_flag:
        save_l = [
            "feature/LTR/training/representation/cv0{}.npy".format(x) \
                for x in range(n)
        ]

    # 为了方便得到label还要对kv_df处理一下
    k_df = template_df.join(kv_df.set_index("template"),on="template").loc[:,["template","sf","label"]]
    roc_score_list = []
    for i in range(n):
        fn_col = str(i)
        t_i_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = k_df.loc[~k_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        kv_i_df = kv_i_df.sort_values(by="label")
        # print(query_df)
        representation_l = representation_dict[i]
        load_path = save_booster_l[i]
        booster = lgb.Booster(model_file=load_path)

        # 构造测试集，不同方法的测试结果，对于某些序列可能缺失，因此要进行补全
        # 在进行测试之前调用run_lambdamart.completement_test_set进行补全
        # 参考pre_test_ltr()程序
        con = run_lambdamart.get_training_set(representation_l)
        label = run_lambdamart.get_label(kv_df,kv_i_df, t_i_df,keepdims=True)

        # 行归一化
        # 因为con是n_sample*n_class*k大小的tensor
        # 要对k个特征进行行归一化
        con = run_lambdamart.normalization(con,2)

        # print(con.shape)
        # print(label.shape)
        X = con.numpy()
        y = label.numpy()

        cv_list = []
        for j in range(X.shape[0]):
            X_test = X[j] # n_class * k
            y_test = y[j] # n_class

            y_pred = booster.predict(X_test, raw_score=True)
            indices = tf.argsort(y_pred,axis=0,direction="DESCENDING").numpy()
            # indices = np.flip(np.argsort(y_pred,axis=0),0)
            # print(indices.shape)
            # print(indices)
            # print(y.shape)
            yt = y_test[indices]
            score1 = run_cv.cal_roc_mu_at(1,yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)
            try:
                ascore = roc_auc_score(y_test,y_pred)
            except:
                ascore = 0.0
            if each_flag:
                cli_print = "printf '{} {} {}\n'".format(score1,score50,ascore)
                sp.call(cli_print,shell=True) 
            roc_score_list.append([score1,score50,ascore])
            cv_list.append(y_pred)

        if save_flag:
            save_path = save_l[i]
            np.save(save_path,np.array(cv_list))

    score = np.array(roc_score_list).mean(0)
    # cli_print = "printf '{}\n'".format(score)
    # sp.call(cli_print,shell=True)
    print("{}\n".format(score))


# 只用于评估结果
def eval_ltr_ind():
    run_cv = Run()

    n = 5

    ind_representation_l = [
        "feature/LTR/training/representation/ind0{}.npy".format(x) \
            for x in range(n)
    ]
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/scop_scope/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    ispecific_path = "feature/hhblits/acc_hmm/ind_sequence_name2row_num.csv"

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    ispec_df = pd.read_csv(ispecific_path,index_col=0)

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    itemplate_df = ispec_df.reset_index().rename(columns={"index":"template"})

    roc_list = []
    for i in range(n):
        fn = i
        fn_col = str(fn)

        ind_representation_path = ind_representation_l[fn]
        irep = np.load(ind_representation_path)


        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        ks = list(train_df.groupby("sf").groups.keys())
        labels = list(range(len(ks)))
        k_df = pd.DataFrame({"sf":ks,"index":labels})
        train_df = train_df.join(k_df.set_index("sf"),on="sf")
        train_df = train_df.rename(columns={"index":"new label"})
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能

        # 使用validation的label
        i_df = itemplate_df.join(kv_df.set_index("template"),on="template")
        iks = list(i_df.groupby("sf").groups.keys())
        ilabels = list(range(len(iks)))
        ik_df = pd.DataFrame({"sf":iks,"index":ilabels})
        i_df = i_df.join(ik_df.set_index("sf"),on="sf")
        i_df = i_df.rename(columns={"index":"new label"})

        ilabel = i_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(ilabel,classes=classes)

        idx = i_df.loc[:, "row num"].to_numpy(int)

        y_pred = irep

        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()

        for j in range(indices.shape[0]):
            idx = indices[j]
            yt = y_true[j][idx]
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            # cli_print = "printf '{} {}\n'".format(score1,score50)
            # sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)

    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)


        
if __name__ == "__main__":
    import lightgbm as lgb
    import numpy as np
    import pandas as pd
    import time
    import os
    import subprocess as sp
    import tensorflow as tf
    from src.model.learningtorank import LambdaMART
    from src.evaluation.cross_validation import Run
    from sklearn.metrics import roc_auc_score
    from sklearn.preprocessing import label_binarize
    import mpi4py.MPI as MPI

    boosting_type = "gbdt"
    # boosting_type = "dart"

    num_leaves = 11
    max_depth = 4
    # learning_rate = 0.07 # 在使用psiblastexb情况下
    # 改变特征后发现0.059的学习率使得训练集的拟合度不及原来
    # 但是，感觉继续改变LinearSVM(HMM)的话效果又会恢复
    # 因为，跟之前的变化在于，更换LinearSVM(PSSM)后，该特征的feature importance为1st
    # 把学习率调高，更换特征后，较低的学习率可能达到的并不是全局最优
    learning_rate = 0.11  # 在使用使用hhblitsexb, hhsearchexb情况下
    max_bin = 127 # 减小以防止过拟合,但太小模型的性能也会不好
    early_stopping_rounds = 100
    num_boost_round = 107 # 控制最大tree的个数

    auto_timestamp = True # 自动生成一个时间戳
    exb_flag = True # 结果保存到exb目录下
    # 为了方便得到label还要对kv_df处理一下
    use_eval_flag = True # 用验证集找最优tree, 结果测试的时候可以用False
    use_test_flag = False # 用测试集做验证集
    norm_flag = False # 训练集归一化，这里不需要因为LTR训练中包含了归一化
    eval_norm = False # 验证集或测试集归一化
    test_first = False # 只测试第一折
    use_time_stamp = True # 模型命名加上时间后缀
    merge_flag = False # 多分类方法合成一个结果，同时也让排序方法合成一个排序结果
    each_flag = False # 输出每个序列的roc1, roc50值
    save_flag = True # 用于保存预测结果

    if test_first:
        n = 1 # 用于测试第一折
    else:
        n = 5

    if auto_timestamp:
        time_suffix = time.strftime("%Y%m%d-%H:%M:%S",time.localtime())
    else:
        time_suffix = "20201018-09:34:55"

    if boosting_type == "dart":
        dir_name = "dart"
    else:
        dir_name = "lambdarank"

    if not exb_flag and auto_timestamp:
        save_booster_l = [
            "model/all/fine_tunning/lightgbm/{}/representation/cv0{}-{}.txt".format(dir_name,x,time_suffix)\
                for x in range(n)
        ]
    elif exb_flag:
        save_booster_l = [
            "model/exb/lightgbm/{}/representation/cv0{}-{}.txt".format(dir_name,x,time_suffix)\
                for x in range(n)
        ]        
    else:
        save_booster_l = [
            "model/all/fine_tunning/lightgbm/{}/representation/cv0{}.txt".format(dir_name,x)\
                for x in range(n)
        ]


    # comm = MPI.COMM_WORLD
    # comm_rank = comm.Get_rank()
    # comm_size = comm.Get_size()

    # if comm_rank > 0:
    #     ind_ltr()

    # elif comm_rank == 0:
    #     test_ltr()

    training_ltr()
    # pre_test_ltr()
    test_ltr()
    val_ltr()
    # pre_val_ltr()
    ind_ltr()
    get_ltr_result()
    # eval_ltr_ind()