
# > 通过psiblast对template查询，一边查询就一边进行解析，解析结果存放为csv文件

def getFileNameWithoutSurfix(psName):
    rv_psN = psName[::-1]
    name_size = len(psName)
    surfixParser = re.compile(r"\.")
    surfix = ""
    s_r = surfixParser.search(rv_psN)
    if s_r is not None:
        surfix_start = s_r.start()
        name = psName[:name_size-surfix_start-1]
        surfix = psName[name_size-surfix_start:]
    else:
        name = psName
    return name, surfix

def splitFasta():
    fasPath = "dataset/benchmark/all/validation"
    seqDir = "dataset/benchmark/seqs/validation"

    tool_a = Assembly()

    tool_a.splitFasta2seqs(fasPath,seqDir)

def makeblastdb():
    fasPath = "dataset/benchmark/all/SCOP_Experimental"
    dbPath = "dataset/benchmark/db/all/SCOP_Experimental_psiblast"
    run_psiblast = PsiBlast()
    set_params = {
        "infile":fasPath, 
        "input_type":"fasta", 
        "dbtype":"prot", 
        "out":dbPath
    }
    run_psiblast.use_makeblastdb(set_params)

# 用validation数据集检索SCOP_Experimental数据集
def psiblast_search():
    run_psiblast = PsiBlast()

    fastaDir = "dataset/benchmark/seqs/validation"
    dbPath = "dataset/benchmark/db/all/SCOP_Experimental_psiblast"
    outPath = "feature/tmp/searched.psi"

    parsing_dict = {"query":[],"template":[],
        "percentage of identical matches":[],
        "expect value":[],"bit score":[]}

    for fastaName in os.listdir(fastaDir):
        fastaFilePath = os.path.join(fastaDir,fastaName)
        params = {
            "db": dbPath,
            "query": fastaFilePath,
            "out": outPath,
            "evalue": 1e-4,
            "outfmt": "'7 qaccver saccver pident evalue bitscore'",
            "num_threads": 10
        }
        run_psiblast.use_psiblast(params)
        # print(fastaFilePath)
        parsing_dict = run_psiblast.parsing_searched_result(outPath,parsing_dict)

    # parsing_df = pd.DataFrame(parsing_dict)
    # parsing_df
    parsing_df = md.DataFrame(parsing_dict)
    # parsing_df.execute()

    csvPath = "feature/psiblast/searched/validation.csv"

    r = parsing_df.to_csv(csvPath,index=False).execute()
    print(r)

    parsing_df = md.read_csv(csvPath)
    print(parsing_df.execute())

# one 检索 all
def psiblast_search_ova():
    n = 5
    run_psiblast = PsiBlast()

    seq_l = ["dataset/benchmark/seqs/SCOP_Experimental_foldNo{}".format(x) \
        for x in range(n)]
    dbPath = "dataset/benchmark/db/all/SCOP_Experimental_psiblast"
    outPath = "feature/tmp/searched.psi"

    parsing_dict = {"query":[],"template":[],
        "percentage of identical matches":[],
        "expect value":[],"bit score":[]}
    limit = 5 #用于简单测试
    testFlag = False
    mask_l = [False,False,False,False,False]
    mask_ary = np.array(mask_l)
    selected_l = [0,1,2,3,4]
    mask_ary[selected_l] = True
    mask_l = mask_ary.tolist()

    for i, fastaDir in enumerate(seq_l):
        if not mask_l[i]:
            continue

        limit = 5
        for fastaName in os.listdir(fastaDir):
            if testFlag and limit == 0:
                break
            fastaFilePath = os.path.join(fastaDir,fastaName)
            params = {
                "db": dbPath,
                "query": fastaFilePath,
                "out": outPath,
                "evalue": 1e-3, # 为了和hhblits参数尽量一致，这里也改成1e-3
                "outfmt": "'7 qaccver saccver pident evalue bitscore'",
                "num_threads": 10
            }
            run_psiblast.use_psiblast(params)
            # print(fastaFilePath)
            parsing_dict = run_psiblast.parsing_searched_result(outPath,parsing_dict)
            if testFlag:
                limit -= 1

    # parsing_df = pd.DataFrame(parsing_dict)
    # parsing_df
    parsing_df = md.DataFrame(parsing_dict)
    # parsing_df.execute()

    csvPath = "feature/psiblast/searched/searched_ref.csv"

    r = parsing_df.to_csv(csvPath,index=False).execute()
    print(r)

    parsing_df = md.read_csv(csvPath)
    print(parsing_df.execute())


def val_search_ova():
    run_psiblast = PsiBlast()

    seqDir = "dataset/benchmark/seqs/validation"
    dbPath = "dataset/benchmark/db/scop_experimental_psiblast"
    outPath = "feature/tmp/searched.psi"

    parsing_dict = {"query":[],"template":[],
        "percentage of identical matches":[],
        "expect value":[],"bit score":[]}

    fasPath = "dataset/benchmark/all/validation"
    with open(fasPath,"r") as h:
        seq_list = [
            r.name for r in parse(h,"fasta")
        ]

    for name in seq_list:
        seqPath = os.path.join(seqDir,"{}.seq".format(name))
        params = {
            "db": dbPath,
            "query": seqPath,
            "out": outPath,
            "evalue": 10, # 为了得到更多反馈结果
            "outfmt": "'7 qaccver saccver pident evalue bitscore'",
            "num_threads": 5,
            "num_iterations":5,
        }
        run_psiblast.use_psiblast(params)
        parsing_dict = run_psiblast.parsing_searched_result(outPath,parsing_dict)

    # parsing_df = pd.DataFrame(parsing_dict)
    # parsing_df
    parsing_df = pd.DataFrame(parsing_dict)

    csvPath = "feature/psiblast/searched/searched.csv"

    r = parsing_df.to_csv(csvPath,index=False)
    print(r)

    parsing_df = pd.read_csv(csvPath)
    print(parsing_df)

def extract_pssm():
    n = 5

    seq_l = ["dataset/benchmark/seqs/SCOP_Experimental_foldNo{}".format(x) \
        for x in range(n)]
    # db_l = ["dataset/benchmark/db/template/scop_{}_psiblast".format(x) \
    #     for x in range(n)]
    dbPath = "/mnt/d/Users/altriasjy31x/sources/lab/C2C-DFG-LTR/dataset/db/nrdb/nrdb90"
    pssm_l = ["feature/psiblast/pssm/scop_{}".format(x) \
        for x in range(n)]

    evalue = 1e-3
    num_iterations = 3
    num_threads = 10

    count = 5
    testFlag = False

    run_psiblast = PsiBlast()

    for i, seqDir in enumerate(seq_l):
        # dbPath = db_l[i]
        pssmDir =pssm_l[i]
        count = 5
        for seqName in os.listdir(seqDir):
            seqPath = os.path.join(seqDir,seqName)
            queryName,_ = getFileNameWithoutSurfix(seqName)
            
            pssmPath = os.path.join(pssmDir,"{}.pssm".format(queryName))
            set_params = {
                "query":seqPath,
                "db":dbPath,
                "num_iteration":num_iterations,
                "evalue":evalue,
                "out_ascii_pssm":pssmPath,
                "num_threads": num_threads
            }
            
            run_psiblast.extract_pssm(set_params)
            if testFlag:
                count -= 1

def validation_extract_pssm():
    seqDir = "dataset/benchmark/seqs/validation"
    pssmDir = "feature/psiblast/pssm/validation"
    dbPath = "/mnt/d/Users/altriasjy31x/sources/lab/C2C-DFG-LTR/dataset/db/nrdb/nrdb90"

    evalue = 1e-3
    num_iterations = 3
    num_threads = 10

    run_psiblast = PsiBlast()

    for seqName in os.listdir(seqDir):
        seqPath = os.path.join(seqDir,seqName)
        queryName,_ = getFileNameWithoutSurfix(seqName)
        
        pssmPath = os.path.join(pssmDir,"{}.pssm".format(queryName))
        set_params = {
            "query":seqPath,
            "db":dbPath,
            "num_iteration":num_iterations,
            "evalue":evalue,
            "out_ascii_pssm":pssmPath,
            "num_threads": num_threads
        }
        
        run_psiblast.extract_pssm(set_params)

def val_fas2pssm():
    run_psiblast = PsiBlast()
    pssmDir = "feature/psiblast/pssm/validation"
    name_l = [getFileNameWithoutSurfix(x)[0] \
        for x in os.listdir(pssmDir) \
        if getFileNameWithoutSurfix(x)[1] == "csv"]
    # name_l
    crt_df = pd.DataFrame(name_l,columns=["validation"])
    # crt_df
    fasPath = "dataset/benchmark/all/validation"
    with open(fasPath,"r") as h:
        seqName_l = [record.name for record in parse(h,"fasta")]

    val_df = pd.DataFrame(seqName_l,columns=["validation"])

    diff_ss = val_df.loc[~val_df.loc[:,"validation"].isin(crt_df.loc[:,"validation"]),"validation"]
    # diff_ss
    # print(diff_ss)
    blosum62_path = "dataset/db/BLOSUM62.csv"
    seqDir = "dataset/benchmark/seqs/validation"
    for name in diff_ss: 
        seqFilePath = os.path.join(seqDir,"{}.seq".format(name))
        pssmFilePath = os.path.join(pssmDir,"{}.csv".format(name))
        if os.path.exists(pssmFilePath):
            print(pssmFilePath)
            continue
        run_psiblast.fasta2pssm(seqFilePath,blosum62_path,pssmFilePath)

def single_pssm2csv():
    pssm_path = "feature/tmp/test.pssm"
    run_psiblast = PsiBlast()

    csvPath = "feature/tmp/test.csv"
    run_psiblast.convert_oriPSSM2csvFromat(pssm_path,csvPath)

def pssm2csvFormat():
    n = 5
    pssm_l = ["feature/psiblast/pssm/scop_{}".format(x)\
        for x in range(n)]
    run_psiblast = PsiBlast()
    # L = []
    for pssmDir in pssm_l:
        for fileName in os.listdir(pssmDir):
            name, surfix = getFileNameWithoutSurfix(fileName)
            if surfix == "pssm":
                pssmFilePath = os.path.join(pssmDir,fileName)
                csvPath = os.path.join(pssmDir,"{}.csv".format(name))
                # L.append((pssmFilePath,csvPath))
                run_psiblast.convert_oriPSSM2csvFromat(pssmFilePath,csvPath)
    # print(L[:10],len(L))

def validation_pssm2csvFormat():
    run_psiblast = PsiBlast()
    pssmDir = "feature/psiblast/pssm/validation"
    for fileName in os.listdir(pssmDir):
        name, surfix = getFileNameWithoutSurfix(fileName)
        if surfix == "pssm":
            pssmFilePath = os.path.join(pssmDir,fileName)
            csvPath = os.path.join(pssmDir,"{}.csv".format(name))
            # L.append((pssmFilePath,csvPath))
            run_psiblast.convert_oriPSSM2csvFromat(pssmFilePath,csvPath)

def remove_redundancy_pairwise():
    searchedFilePath = "feature/psiblast/searched/searched_ref.csv"
    depandentFilePath = "dataset/benchmark/cross/sequence_name2fold_num"
    targetFilePath = "feature/psiblast/searched/searched.csv"

    run_psiblast = PsiBlast()

    run_psiblast.remove_redundancy_pairwise(searchedFilePath,depandentFilePath,targetFilePath)

def remove_repetitive_pairwise():
    searchedFilePath = "feature/psiblast/searched/searched_ref.csv"
    targetFilePath = "feature/psiblast/searched/searched_nr.csv"

    run_psiblast = PsiBlast()

    run_psiblast.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)

def use_acc_pssm():
    # 先按照字典顺序，将pssm文件按顺序编号，这个编号对应着处理顺序，也对应着特征向量在矩阵中的位置
    n = 5
    pssm_l = ["feature/psiblast/pssm/scop_{}".format(x) \
        for x in range(n)]

    sequence_name2row_num_path = "feature/psiblast/acc_pssm/sequence_name2row_num.csv"
    forceFlag = False # 如果要强制更新就改为True
    if forceFlag or not os.path.exists(sequence_name2row_num_path):
        all_file_name_l = []
        for pssmDir in pssm_l:
            # name_l = [x for x in os.listdir(pssmDir) \
            #     if getFileNameWithoutSurfix(x)[1] == "csv"]
            def genNameList(pssmDir):
                for x in os.listdir(pssmDir):
                    name, surfix = getFileNameWithoutSurfix(x)
                    if surfix == "csv":
                        yield name
            name_l = list(genNameList(pssmDir))
            name_l = sorted(name_l)
            all_file_name_l += name_l
        
        row_num_l = list(range(len(all_file_name_l)))

        sn2rN_df = pd.DataFrame(row_num_l,columns=["row num"],index=all_file_name_l)
        with open(sequence_name2row_num_path,"w",newline='') as h:
            sn2rN_df.to_csv(h)
    # LG = 1
    # LG = 4
    LG = 5 # 根据acc_fold论文LG=5效果比较好
    acc_pssm_list = []
    run_psiblast = PsiBlast()
    for pssmDir in pssm_l:
        name_l = [x for x in os.listdir(pssmDir) \
            if getFileNameWithoutSurfix(x)[1] == "csv"]
        name_l = sorted(name_l)
        for name in name_l:
            pssm_csvFormat_path = os.path.join(pssmDir,name)
            acc_pssm_list.append(run_psiblast.acc_pssm(pssm_csvFormat_path,LG))
    
    acc_pssm_mat_path = "feature/psiblast/acc_pssm/representation_profile.npy"
    acc_pssm_mat = np.vstack(acc_pssm_list)

    np.save(acc_pssm_mat_path,acc_pssm_mat)

def validation_use_acc_pssm():
    pssmDir = "feature/psiblast/pssm/validation"
    sequence_name2row_num_path = "feature/psiblast/acc_pssm/val_sequence_name2row_num.csv"
    forceFlag = False # 如果要强制更新就改为True
    if forceFlag or not os.path.exists(sequence_name2row_num_path):
        all_file_name_l = []

        # name_l = [x for x in os.listdir(pssmDir) \
        #     if getFileNameWithoutSurfix(x)[1] == "csv"]
        def genNameList(pssmDir):
            for x in os.listdir(pssmDir):
                name, surfix = getFileNameWithoutSurfix(x)
                if surfix == "csv":
                    yield name
        name_l = list(genNameList(pssmDir))
        name_l = sorted(name_l)
        all_file_name_l += name_l
    
        row_num_l = list(range(len(all_file_name_l)))

        sn2rN_df = pd.DataFrame(row_num_l,columns=["row num"],index=all_file_name_l)
        with open(sequence_name2row_num_path,"w",newline='') as h:
            sn2rN_df.to_csv(h)
    # LG = 4
    LG = 5
    acc_pssm_list = []
    run_psiblast = PsiBlast()

    name_l = [x for x in os.listdir(pssmDir) \
        if getFileNameWithoutSurfix(x)[1] == "csv"]
    name_l = sorted(name_l)
    for name in name_l:
        pssm_csvFormat_path = os.path.join(pssmDir,name)
        acc_pssm_list.append(run_psiblast.acc_pssm(pssm_csvFormat_path,LG))  

    acc_pssm_mat_path = "feature/psiblast/acc_pssm/val_representation_profile.npy"
    acc_pssm_mat = np.vstack(acc_pssm_list)

    np.save(acc_pssm_mat_path,acc_pssm_mat)   

def use_top_n_gram():
    n = 5
    pssm_l = ["feature/psiblast/pssm/scop_{}".format(x) \
        for x in range(n)]

    run_psiblast = PsiBlast()
    ngram = 2
    L = 20
    top_n_gram_list = []
    for pssmDir in pssm_l:
        name_l = [x for x in os.listdir(pssmDir) \
            if getFileNameWithoutSurfix(x)[1] == "csv"]
        name_l = sorted(name_l)

        for name in name_l:
            pssm_csvFormat_path = os.path.join(pssmDir,name)
            top_n_gram_list.append(run_psiblast.top_n_gram(pssm_csvFormat_path,ngram,L))
    
    top_n_gram_path = "feature/psiblast/top_n_gram/top{}/representation_profile.npy".format(ngram)
    top_n_gram_mat = np.vstack(top_n_gram_list)

    np.save(top_n_gram_path,top_n_gram_mat)


def validation_top_n_gram():
    pssmDir = "feature/psiblast/pssm/validation"
    run_psiblast = PsiBlast()
    ngram = 2
    L = 20
    top_n_gram_list = []

    name_l = [x for x in os.listdir(pssmDir) \
        if getFileNameWithoutSurfix(x)[1] == "csv"]
    name_l = sorted(name_l)

    for name in name_l:
        pssm_csvFormat_path = os.path.join(pssmDir,name)
        top_n_gram_list.append(run_psiblast.top_n_gram(pssm_csvFormat_path,ngram,L))
    
    top_n_gram_path = "feature/psiblast/top_n_gram/top{}/val_representation_profile.npy".format(ngram)
    top_n_gram_mat = np.vstack(top_n_gram_list)

    np.save(top_n_gram_path,top_n_gram_mat)

def combine_top_n_gram():
    top1_path = "feature/psiblast/top_n_gram/top1/representation_profile.npy"
    top2_path = "feature/psiblast/top_n_gram/top2/representation_profile.npy"
    topc_path = "feature/psiblast/top_n_gram/combine/representation_profile.npy"

    top1_ary = np.load(top1_path)
    top2_ary = np.load(top2_path)

    topc_ary = np.hstack([top1_ary,top2_ary])
    np.save(topc_path,topc_ary)

def val_combine_topn():
    top1_path = "feature/psiblast/top_n_gram/top1/val_representation_profile.npy"
    top2_path = "feature/psiblast/top_n_gram/top2/val_representation_profile.npy"
    topc_path = "feature/psiblast/top_n_gram/combine/val_representation_profile.npy"

    top1_ary = np.load(top1_path)
    top2_ary = np.load(top2_path)

    topc_ary = np.hstack([top1_ary,top2_ary])
    np.save(topc_path,topc_ary)

def comb_acc_topn():
    acc_path = "feature/psiblast/acc_pssm/representation_profile.npy"
    topn_path = "feature/psiblast/top_n_gram/combine/representation_profile.npy"
    comb_path = "feature/psiblast/representation/representation_profile.npy"
    
    acc_ary = np.load(acc_path)
    topn_ary = np.load(topn_path)

    cary = np.hstack([acc_ary,topn_ary])
    np.save(comb_path,cary)

def val_acc_topn():
    acc_path = "feature/psiblast/acc_pssm/val_representation_profile.npy"
    topn_path = "feature/psiblast/top_n_gram/combine/val_representation_profile.npy"
    comb_path = "feature/psiblast/representation/val_representation_profile.npy"
    
    acc_ary = np.load(acc_path)
    topn_ary = np.load(topn_path)

    cary = np.hstack([acc_ary,topn_ary])
    np.save(comb_path,cary)

def use_native():
    run_psiblast = PsiBlast()

    searched_path = "feature/psiblast/searched/searched_nr.csv"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    srch_df = pd.read_csv(searched_path)
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    save_l = [
        "feature/native/training/psiblast/cv0{}.npy".format(x)\
            for x in range(n)
    ]
    
    for i in range(n):
        fold_num = str(i)
        save_path = save_l[i]

        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_df = template_df.join(kv_df.set_index("template"),on="template")
        t_i_df = t_df.loc[~t_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        h_df = srch_df.loc[~srch_df.loc[:,"query"].isin(cv_df.loc[:,fold_num])]
        h_df = h_df.loc[~h_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        con = run_psiblast.native(h_df,t_i_df)

        np.save(save_path,con)
        cli_print = "printf '{}\n'".format(save_path)
        sp.call(cli_print,shell=True)

def test_native():
    run_psiblast = PsiBlast()

    searched_path = "feature/psiblast/searched/searched_nr.csv"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    srch_df = pd.read_csv(searched_path)
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    save_l = [
        "feature/native/psiblast/cv0{}.npy".format(x)\
            for x in range(n)
    ]
    
    for i in range(n):
        fold_num = str(i)
        save_path = save_l[i]

        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_df = template_df.join(kv_df.set_index("template"),on="template")
        t_i_df = t_df.loc[~t_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        h_df = srch_df.loc[srch_df.loc[:,"query"].isin(cv_df.loc[:,fold_num])]
        h_df = h_df.loc[~h_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        con = run_psiblast.native(h_df,t_i_df)

        np.save(save_path,con)
        cli_print = "printf '{}\n'".format(save_path)
        sp.call(cli_print,shell=True)

################################################################################################################################################
# 在独立测试集SCOPe上进行测试，用SCOPe中的每一条序列检索SCOP
################################################################################################################################################
def ind_splitFasta():
    fasPath = "dataset/benchmark/all/SCOPe_TEST"
    seqDir = "dataset/benchmark/seqs/SCOPe"

    tool_a = Assembly()

    tool_a.splitFasta2seqs(fasPath,seqDir)


def ind_search_ova():
    n = 5
    run_psiblast = PsiBlast()

    dbPath = "dataset/benchmark/db/all/SCOP_Experimental_psiblast"
    outPath = "feature/tmp/searched.psi"

    parsing_dict = {"query":[],"template":[],
        "percentage of identical matches":[],
        "expect value":[],"bit score":[]}
    limit = 5 #用于简单测试
    testFlag = False

    fastaDir = "dataset/benchmark/seqs/independent"

    limit = 5
    for fastaName in os.listdir(fastaDir):
        if testFlag and limit == 0:
            break
        fastaFilePath = os.path.join(fastaDir,fastaName)
        params = {
            "db": dbPath,
            "query": fastaFilePath,
            "out": outPath,
            "evalue": 1e-3, # 为了和hhblits参数尽量一致，这里也改成1e-3
            "outfmt": "'7 qaccver saccver pident evalue bitscore'",
            "num_threads": 10
        }
        run_psiblast.use_psiblast(params)
        # print(fastaFilePath)
        parsing_dict = run_psiblast.parsing_searched_result(outPath,parsing_dict)
        if testFlag:
            limit -= 1

    # parsing_df = pd.DataFrame(parsing_dict)
    # parsing_df
    parsing_df = md.DataFrame(parsing_dict)
    # parsing_df.execute()

    csvPath = "feature/psiblast/searched/independent.csv"

    r = parsing_df.to_csv(csvPath,index=False).execute()
    print(r)

    parsing_df = md.read_csv(csvPath)
    print(parsing_df.execute())

def ind_extract_pssm():
    seqDir = "dataset/benchmark/seqs/independent"
    fasPath = "dataset/benchmark/all/independent"
    
    sel_db = "uniref"

    if sel_db == "nrdb":
        dbPath = "/mnt/d/Users/altriasjy31x/sources/lab/C2C-DFG-LTR/dataset/db/nrdb/nrdb90" # 使用nrdb90进行检索
        pssmDir = "feature/psiblast/pssm/ind"
    else:
        dbPath = "/mnt/d/Users/altriasjy31x/sources/lab/C2C-DFG-LTR/dataset/db/uniref50/uniref50" # 使用uniref50进行检索
        pssmDir = "feature/psiblast/uniref/pssm/ind"

    evalue = 1e-3
    num_iterations = 3
    num_threads = 3

    run_psiblast = PsiBlast()

    with open(fasPath,"r") as h:
        seq_list = [
            r.name for r in parse(h,"fasta")
        ]

    for seqName in seq_list:
        seqPath = os.path.join(seqDir,"{}.seq".format(seqName))
        
        pssmPath = os.path.join(pssmDir,"{}.pssm".format(seqName))
        if os.path.exists(pssmPath):
            continue
        set_params = {
            "query":seqPath,
            "db":dbPath,
            "num_iteration":num_iterations,
            "evalue":evalue,
            "out_ascii_pssm":pssmPath,
            "num_threads": num_threads
        }
        
        run_psiblast.extract_pssm(set_params)

def ind_compl_pssm_file():

    def get_pssm_from_blosum62(sequenceFilePath):
        blosum62_path = "dataset/db/BLOSUM62.csv"
        with open(blosum62_path,"r") as h:
            b62_df = pd.read_csv(h,index_col=0)
        with open(sequenceFilePath,"r") as h:
            for record in parse(h,"fasta"):
                seq = record.seq
                sidx = [s for s in seq.upper()]
                sub_df = b62_df.loc[sidx]
                return sub_df
    seqDir = "dataset/benchmark/seqs/independent"
    fasPath = "dataset/benchmark/all/independent"
    with open(fasPath,"r") as h:
        seq_l = [r.name for r in parse(h,"fasta")]
    seq_ser = pd.Series(seq_l,name="template")
    spliter = re.compile(r"\s+")
    selected_amino_acid = "A   R   N   D   C   Q   E   G   H   I   L   K   M   F   P   S   T   W   Y   V"
    saa = spliter.split(selected_amino_acid)

    pssmDir = "feature/psiblast/pssm/ind"
    pssmFile_l = [getFileNameWithoutSurfix(x)[0] for x in os.listdir(pssmDir)]
    pn_ser = pd.Series(pssmFile_l)
    # print(pn_ser.shape) # 检查
    # print(pn_ser) # 检查
    diff_r = seq_ser.loc[~seq_ser.isin(pn_ser)]
    print(seq_ser)
    print(pn_ser)
    print(diff_r) # 检查
    # 通过splitfasta生成的结果中，序列的名称中的"."被替换成了_因此，这一部分要注意

    for name in diff_r:
        if pd.isna(name) or name == "":
            continue
        pssmFilePath = os.path.join(pssmDir,"{}.csv".format(name))
        # print(seqDir) # 检查
        seqFilePath = os.path.join(seqDir,"{}.seq".format(name))
        tmp_df = get_pssm_from_blosum62(seqFilePath)
        pssm_df = tmp_df.loc[:,saa]
        # print(seqFilePath) # 检查
        
        pssm_df.to_csv(pssmFilePath)

def ind_pssm2csvFormat():
    run_psiblast = PsiBlast()
    pssmDir = "feature/psiblast/pssm/ind"
    for fileName in os.listdir(pssmDir):
        name, surfix = getFileNameWithoutSurfix(fileName)
        if surfix == "pssm":
            pssmFilePath = os.path.join(pssmDir,fileName)
            csvPath = os.path.join(pssmDir,"{}.csv".format(name))
            # L.append((pssmFilePath,csvPath))
            run_psiblast.convert_oriPSSM2csvFromat(pssmFilePath,csvPath)

def ind_use_acc_pssm():
    pssmDir = "feature/psiblast/pssm/ind"
    sequence_name2row_num_path = "feature/psiblast/acc_pssm/ind_sequence_name2row_num.csv"
    forceFlag = True # 如果要强制更新就改为True
    if forceFlag or not os.path.exists(sequence_name2row_num_path):
        all_file_name_l = []

        # name_l = [x for x in os.listdir(pssmDir) \
        #     if getFileNameWithoutSurfix(x)[1] == "csv"]
        def genNameList(pssmDir):
            for x in os.listdir(pssmDir):
                name, surfix = getFileNameWithoutSurfix(x)
                if surfix == "csv":
                    yield name
        name_l = list(genNameList(pssmDir))
        name_l = sorted(name_l) # 按字典序，得到row num
        all_file_name_l += name_l
    
        row_num_l = list(range(len(all_file_name_l)))

        sn2rN_df = pd.DataFrame(row_num_l,columns=["row num"],index=all_file_name_l)
        with open(sequence_name2row_num_path,"w",newline='') as h:
            sn2rN_df.to_csv(h)
    # LG = 4
    LG = 5
    acc_pssm_list = []
    run_psiblast = PsiBlast()

    name_l = [x for x in os.listdir(pssmDir) \
        if getFileNameWithoutSurfix(x)[1] == "csv"]
    name_l = sorted(name_l)
    for name in name_l:
        pssm_csvFormat_path = os.path.join(pssmDir,name)
        acc_pssm_list.append(run_psiblast.acc_pssm(pssm_csvFormat_path,LG))  

    acc_pssm_mat_path = "feature/psiblast/acc_pssm/ind_representation_profile.npy"
    acc_pssm_mat = np.vstack(acc_pssm_list)

    np.save(acc_pssm_mat_path,acc_pssm_mat)

def ind_top_n_gram():
    pssmDir = "feature/psiblast/pssm/ind"
    run_psiblast = PsiBlast()
    # top_1_gram
    ngram = 1
    L = 20
    top_n_gram_list = []

    name_l = [x for x in os.listdir(pssmDir) \
        if getFileNameWithoutSurfix(x)[1] == "csv"]
    name_l = sorted(name_l)

    for name in name_l:
        pssm_csvFormat_path = os.path.join(pssmDir,name)
        top_n_gram_list.append(run_psiblast.top_n_gram(pssm_csvFormat_path,ngram,L))

    top_n_gram_path = "feature/psiblast/top_n_gram/top{}/ind_representation_profile.npy".format(ngram)
    top_n_gram_mat = np.vstack(top_n_gram_list)

    np.save(top_n_gram_path,top_n_gram_mat)

    # top_2_gram
    ngram = 2
    L = 20
    top_n_gram_list = []

    name_l = [x for x in os.listdir(pssmDir) \
        if getFileNameWithoutSurfix(x)[1] == "csv"]
    name_l = sorted(name_l)

    for name in name_l:
        pssm_csvFormat_path = os.path.join(pssmDir,name)
        top_n_gram_list.append(run_psiblast.top_n_gram(pssm_csvFormat_path,ngram,L))

    top_n_gram_path = "feature/psiblast/top_n_gram/top{}/ind_representation_profile.npy".format(ngram)
    top_n_gram_mat = np.vstack(top_n_gram_list)

    np.save(top_n_gram_path,top_n_gram_mat)


def ind_combine_topn():
    top1_path = "feature/psiblast/top_n_gram/top1/ind_representation_profile.npy"
    top2_path = "feature/psiblast/top_n_gram/top2/ind_representation_profile.npy"
    topc_path = "feature/psiblast/top_n_gram/combine/ind_representation_profile.npy"

    top1_ary = np.load(top1_path)
    top2_ary = np.load(top2_path)

    topc_ary = np.hstack([top1_ary,top2_ary])
    np.save(topc_path,topc_ary)


def ind_acc_topn():
    acc_path = "feature/psiblast/acc_pssm/ind_representation_profile.npy"
    topn_path = "feature/psiblast/top_n_gram/combine/ind_representation_profile.npy"
    comb_path = "feature/psiblast/representation/ind_representation_profile.npy"

    acc_ary = np.load(acc_path)
    topn_ary = np.load(topn_path)

    cary = np.hstack([acc_ary,topn_ary])
    np.save(comb_path,cary)


def ind_rm_repetive():
    searchedFilePath = "feature/psiblast/searched/independent.csv"
    targetFilePath = "feature/psiblast/searched/independent_nr.csv"

    run_psiblast = PsiBlast()

    run_psiblast.remove_redundancy_pairwise(searchedFilePath,targetFilePath=targetFilePath)

def ind_srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    ind_kv_path = "dataset/SCOPe/csv/sequence_superfamily.csv"
    searched_path = "feature/psiblast/searched/independent_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    dkv_df = pd.read_csv(ind_kv_path)
    srch_df = pd.read_csv(searched_path)

    # 要把kv_df, dkv_df的sf组合起来
    m_df = pd.concat([kv_df,dkv_df])
    mg = m_df.groupby("template")
    idx = [x[0] for x in mg.groups.values()]
    m_df = m_df.loc[idx,["template","sf"]]
    m_df = m_df.reset_index(drop=True)
    mg = m_df.groupby("sf")
    idx = [x[0] for x in mg.groups.values()]
    sf_df = m_df.loc[idx, ["sf"]].reset_index(drop=True)
    sf_df = sf_df.reset_index().rename(columns={"index":"label"})
    m_df = m_df.join(sf_df.set_index("sf"),on="sf")

    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = True # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    each_flag = False # 这个标志控制是否输出每个序列的评估结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        
        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)


if __name__ == "__main__":
    from src.utils.feature_extraction import PsiBlast
    from src.evaluation.cross_validation import Run
    from src.utils.tools import Assembly
    from mars import dataframe as md
    import os
    import numpy as np
    import re
    import pandas as pd
    from Bio.SeqIO import parse
    import subprocess as sp

    # splitFasta()
    # makeblastdb()
    # psiblast_search()
    # psiblast_search_ova()
    # extract_pssm()
    # validation_extract_pssm()
    # val_fas2pssm()
    # pssm2csvFormat()
    # validation_pssm2csvFormat()
    # remove_redundancy_pairwise()
    # remove_repetitive_pairwise()
    # use_acc_pssm()
    # validation_use_acc_pssm()
    # single_pssm2csv()
    # use_top_n_gram()
    # validation_top_n_gram()
    # combine_top_n_gram()
    # val_combine_topn()
    # comb_acc_topn()
    # val_acc_topn()
    # use_native()
    # test_native()
##############################################################################################################################################
# 独立测试集
##############################################################################################################################################
    # ind_splitFasta()
    # ind_search_ova()
    # ind_extract_pssm()
    # ind_compl_pssm_file()
    # ind_pssm2csvFormat()
    # ind_use_acc_pssm()
    # ind_top_n_gram()
    # ind_combine_topn()
    # ind_acc_topn()
    # ind_rm_repetive()
    ind_srch_roc_at()