def srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    searched_path = "feature/psiblast/uniref/searched/searched_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    srch_df = pd.read_csv(searched_path)

    each_flag = False # 控制是否输出所有序列的评估结果
    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = True # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[srch_df.loc[:,"query"].isin(cv_df.loc[:,fold_num])]
        pairwise_df = pairwise_df.loc[~pairwise_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])
            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)

def val_srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    searched_path = "feature/psiblast/uniref/searched/validation_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    srch_df = pd.read_csv(searched_path)

    each_flag = False # 控制是否输出所有序列的评估结果
    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = True # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, kv_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])
            
            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)


def ind_srch_roc_at():
    run_cv = Run()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    ind_kv_path = "dataset/SCOPe/csv/sequence_superfamily.csv"
    searched_path = "feature/psiblast/uniref/searched/independent_nr.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)
    dkv_df = pd.read_csv(ind_kv_path)
    srch_df = pd.read_csv(searched_path)

    
    # 要把kv_df, dkv_df的sf组合起来
    m_df = pd.concat([kv_df,dkv_df])
    mg = m_df.groupby("template")
    idx = [x[0] for x in mg.groups.values()]
    m_df = m_df.loc[idx,["template","sf"]]
    m_df = m_df.reset_index(drop=True)
    mg = m_df.groupby("sf")
    idx = [x[0] for x in mg.groups.values()]
    sf_df = m_df.loc[idx, ["sf"]].reset_index(drop=True)
    sf_df = sf_df.reset_index().rename(columns={"index":"label"})
    m_df = m_df.join(sf_df.set_index("sf"),on="sf")

    each_flag = False # 控制输出每个序列的评估结果
    n = 5
    # roc_at_list = []
    expand_flag = False # 这个标志控制是否拓展排序列表来评估结果
    query_flag = True # 这个标志表示是否所有query都会用来评估，因为，通过5折交叉验证把排序结果划分后，部分query会没有排序结果
    for i in range(n):
        # vrep = None
        fold_num = str(i)
           
        roc_at_list = []
        pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

        kv_i_df = spec_df.join(kv_df.set_index("template")).reset_index().rename(columns={"index":"template"})
        kv_i_df = kv_i_df.loc[~kv_i_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        kv_i_df = kv_i_df.loc[:,["template","sf","label"]]
        

        if query_flag:
            # 要保证每一折中所有的query都包含在内
            # 如果有缺失，那么最终结果要加上对应个0
            diff_ser = cv_df.loc[~cv_df.loc[:, fold_num].isin(pairwise_df.loc[:,"query"]), fold_num]
            # 去掉NA值
            diff_ser = diff_ser.loc[~pd.isna(diff_ser)]
            m = diff_ser.shape[0]

        
        for queryName, p_df in pairwise_df.groupby("query"):
            level = 1  
            score1 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            level = 50
            score50 = run_cv.srch_roc_at(level, m_df, kv_i_df, p_df,expand_flag=expand_flag)
            roc_at_list.append([score1,score50])
            if each_flag:
                cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
                sp.call(cli_print,shell=True)
        if query_flag and m > 0:
            roc_at_list += [[0,0]]*m
    roc_at_ary = np.array(roc_at_list)
    cli_print = "printf 'ROC score\t{}\n'".format(roc_at_ary.mean(axis=0))
    sp.call(cli_print,shell=True)


if __name__ == "__main__":
    from src.utils.feature_extraction import PsiBlast
    from src.evaluation.cross_validation import Run
    from src.utils.tools import Assembly
    from mars import dataframe as md
    import os
    import numpy as np
    import re
    import pandas as pd
    from Bio.SeqIO import parse
    import subprocess as sp

    # splitFasta()
    # makeblastdb()
    # psiblast_search()
    # psiblast_search_ova()
    # search_by_pssm()
    # vsesarch_by_pssm()
    # extract_pssm()
    # compl_pssm_file()
    # validation_extract_pssm()
    # val_compl_pssm_file()
    # pssm2csvFormat()
    # validation_pssm2csvFormat()
    # remove_redundancy_pairwise()
    # remove_repetitive_pairwise()
    # val_rm_repetitive()
    # use_acc_pssm()
    # validation_use_acc_pssm()
    # single_pssm2csv()
    # use_top_n_gram()
    # validation_top_n_gram()
    # combine_top_n_gram()
    # val_combine_topn()
    # comb_acc_topn()
    # val_acc_topn()
    # use_native()
    # test_native()
    srch_roc_at()
    val_srch_roc_at()
##############################################################################################################################################
# 独立测试集
##############################################################################################################################################
    # ind_splitFasta()
    # ind_search_ova()
    # isesarch_by_pssm()
    # ind_rm_repetive()
    # ind_extract_pssm()
    # ind_compl_pssm_file()
    # ind_pssm2csvFormat()
    # ind_use_acc_pssm()
    # ind_top_n_gram()
    # ind_combine_topn()
    # ind_acc_topn()
    ind_srch_roc_at()
