# 本程序用于制作S2C训练集
# clustering.py以及use_reranker.py，则是生成测试集
def ranking_roc_at(y_pred, m_df, selQuery):
    run_cv = Run()
    # print(selQuery)
    # 获取query的superfamily
    # q_temp_idx = kv_df.index[kv_df.loc[:,"template"] == selQuery]
    # 因为现在基于row num排序了，参数selQuery实际上是query对应的row num
    print(m_df.columns)
    # q_temp_idx = m_df.index[m_df.loc[:,"query"] == selQuery]
    q_temp_idx = m_df.index[m_df.loc[:,"row num_query"] == selQuery]
    # print(q_temp_idx)
    # qt = kv_df.loc[q_temp_idx[0],"sf"]
    qt = m_df.loc[q_temp_idx[0],"sf_query"]
    # print(qt)

    y_true = (m_df.loc[:,"sf_template"] == qt).to_numpy(int)
    # print(y_true.shape)
    # print(y_true)

    sidx = np.flip(np.argsort(tf.reshape(y_pred,(-1,)).numpy()))
    level = 1
    score1 = run_cv.cal_roc_mu_at(level, y_true[sidx])
    level = 50
    score50 = run_cv.cal_roc_mu_at(level,y_true[sidx])
    # print(score)
    cli_print = "printf '{}\t{}\t{}\n'".format(selQuery,score1,score50)
    sp.call(cli_print,shell=True)


def s2c_roc_at(newr, queryName, m_df, kv_df):
    run_cv = Run()

    qidx = kv_df.loc[kv_df.loc[:, "template"] == queryName].index
    query_sf = kv_df.loc[qidx[0],"sf"]
    # print(query_sf)

    label = (query_sf == m_df.loc[:,"sf"]).to_numpy(int)
    # print(label)
    idx = tf.argsort(newr,direction="DESCENDING").numpy()

    y_true = label[idx]

    level = 1
    score1 = run_cv.cal_roc_mu_at(level,y_true)
    level = 50
    score50 = run_cv.cal_roc_mu_at(level,y_true)
    cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
    sp.call(cli_print,shell=True)

# 为了节省存储空间本程序直接生成s2c结果，不保存中间DFG的结果
# 与clustering.py生成的结果不同，本程序直接生成n_sample * n_class的矩阵
# 用于将y_pred这种序列对序列的排序转为序列对class的排序，因为此时属于同一class的序列打分一致
def save_s2c(rs, m_df):
    idx_list = []
    for _, g in m_df.groupby("sf"):
        idx = g.loc[:,"new_row_num"].to_numpy(int)[0]
        idx = idx.reshape((-1,1))
        idx_list.append(idx)

    indices = np.vstack(idx_list)
    
    s2c = tf.transpose(tf.gather_nd(tf.transpose(rs), indices))
    return s2c

def use_pr_s2c():
    run_reranker = ReRanker()
    run_cluster = ClusterPairwise()
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    searched_path = "feature/hhblits/searched/searched_nr.csv"
    # searched_path = "feature/hhsearch/searched/searched_nr.csv"
    specific_path = "feature/physicochemical/representation/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5

    reranking_l = [
        "feature/S2C/training/hhblits/cv0{}.npy".format(x) \
            for x in range(n)
    ]
    # reranking_l = ["feature/S2C/training/hhsearch/cv0{}".format(x) \
    #         for x in range(n)]

    # cli_print = "printf 'template\tROC1\tROC50\n'"
    # sp.call(cli_print,shell=True)
    
    for i in range(n):
        fold_num = str(i)
        reranking_path = reranking_l[i]
        # pairwise_df = run_reranker.get_pairwise_df(srch_df,fold_num,cv_df)
        # 做成训练集时query和template都不能属于对应fold_num下的序列
        pairwise_df = srch_df.loc[~srch_df.loc[:,"query"].isin(cv_df.loc[:, fold_num])]
        pairwise_df = pairwise_df.loc[~srch_df.loc[:, "template"].isin(cv_df.loc[:,fold_num])]
        # 这里要额外处理kv_df
        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
        r_list = []

        m, n = pairwise_df.shape
        cli_print = "printf 'pairwise_df shape {} {}\n'".format(int(m),int(n))
        sp.call(cli_print,shell=True)
        pairwise_df = run_reranker.expand_query(pairwise_df,kv_df)
        # 这一步实际上已经让每一折的query, 依照字典序来排序了
        # 但是按字典序排序，训练集构造的顺序会有问题，因此，最好根据row num排序
        merge_df = pairwise_df.join(spec_df,on="query")
        mg = merge_df.groupby("row num")
        # for queryName, p_df in merge_df.groupby("query"):
        for queryName, indices in mg.groups.items():
            s = time.time()
            p_df = pairwise_df.loc[indices]
            m_df = run_reranker.expand_template(p_df,kv_i_df)
            R = run_reranker.pagerank(m_df, spec_df)
            # y_pred = ranking_roc_at(R, m_df, queryName)
            y_pred = R[:-1]

            # 这里要对m_df重新命名，把sf_template改为sf
            m_df1 = m_df.rename(columns={"sf_template":"sf"})
            # 重新给template编号，这一编号方法与pagerank内部一致
            m_df1 = m_df1.join(spec_df, on="template")
            m_df1 = run_cluster.renumber(m_df1)

            # 调整y_pred的shape为(-1,)
            y_pred = tf.reshape(y_pred,(-1,))
            y_pred = run_cluster.S2C_transform(y_pred,m_df1)
            m_df1 = m_df.rename(columns={"sf":"sf_template"})
            # ranking_roc_at(y_pred, m_df1, queryName)

            # cli_print = "printf '{}\n'".format(queryName)
            # sp.call(cli_print,shell=True)
            r_list.append(y_pred)
            e = time.time()
            cli_print = "printf 'time: {}\n'".format(e-s)
            sp.call(cli_print,shell=True)

        # rs = tf.transpose(tf.concat(r_list,axis=1))
        rs = tf.stack(r_list,axis=0) # 原本这里是[r_list]，正确的方法应该是去掉[]，不然shape会变成1*n_sample*n_sample

        # 这里之所以可以选择m_df1，是因为，m_df1种包含的template的个数以及顺序都是一致的
        # 直接用m_df1会出错
        # s2c = save_s2c(rs,m_df1)
        np.save(reranking_path,rs)

def val_pagearank():
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    searched_path = "feature/hhblits/searched/validation_nr.csv"
    specific_path = "feature/physicochemical/representation/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5

    reranking_l = ["feature/DFG/hhblits/val0{}.npy".format(x)\
        for x in range(n)]

    cli_print = "printf 'template\tROC1\tROC50\n'"
    sp.call(cli_print,shell=True)
    
    for i in range(n):
        fold_num = str(i)
        reranking_path = reranking_l[i]
        pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        # 这里要额外处理kv_df
        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
        r_list = []

        pairwise_df = run_reranker.expand_query(pairwise_df,kv_df)
        # 这一步实际上已经让每一折的query, 依照字典序来排序了
        for queryName, p_df in pairwise_df.groupby("query"):
            m_df = run_reranker.expand_template(p_df,kv_i_df)
            R = run_reranker.pagerank(m_df, spec_df)
            y_pred = R[:-1]
            ranking_roc_at(y_pred, m_df, queryName)
            r_list.append(y_pred)
        
        rs = tf.transpose(tf.concat(r_list,axis=1))
        np.save(reranking_path,rs)

def val_s2c():
    run_cluster = ClusterPairwise()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    val_sepcific_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(val_sepcific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    searched_l = [
        "feature/DFG/hhblits/val0{}.npy".format(x) \
            for x in range(n)
    ]
    save_l = [
        "feature/S2C/hhblits/val0{}.npy".format(x) \
            for x in range(n)
    ]


    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    vtemplate_df = vspec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        searched_path = searched_l[i]
        rankings = tf.constant(np.load(searched_path),tf.float32)

        fold_num = str(i)

        t_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        q_ser = vtemplate_df.sort_values(by="template").loc[:,"template"]
        m_df = run_cluster.expand_template(t_df,kv_df)
        m_df = run_cluster.renumber(m_df)

        reranking_list = []
        for j in range(rankings.shape[0]):
            R = rankings[j]
            queryName = q_ser.loc[j]
            newr = run_cluster.S2C_transform(R,m_df)
            s2c_roc_at(newr,queryName,m_df,kv_df)
            reranking_list.append(newr)
        
        indices = tf.constant(list(range(rankings.shape[0])))
        indices = tf.reshape(indices,(-1,1))

        rankings = tf.tensor_scatter_nd_update(rankings, indices, reranking_list)

        save_path = save_l[i]

        np.save(save_path,rankings)

# 把s2c的结果从n_sameple*n_sample变到n_sample*n_class
def format_s2c():
    run_cluster = ClusterPairwise()
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    seq2cluster_l = [
        "feature/S2C/training_cluster/hhblits/cv0{}.npy".format(x) \
            for x in range(n)
    ]
    format_l = [
        "feature/S2C/training_cluster/hhblits/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        seq2cluster_path = seq2cluster_l[i]
        format_path = format_l[i]
        rs = np.load(seq2cluster_path)
        print(rs.shape)

        fold_num = str(i)

        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)

        m_df = kv_i_df.join(template_df.set_index("template"),on="template")
        m_df = run_cluster.renumber(m_df)

        s2c_ary = save_s2c(rs,m_df)
        print(s2c_ary.shape)
        np.save(format_path,s2c_ary)

    
def val_format_s2c():
    run_cluster = ClusterPairwise()
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    seq2cluster_l = [
        "feature/S2C/hhblits/val0{}.npy".format(x) \
            for x in range(n)
    ]
    format_l = [
        "feature/S2C/training/hhblits/val0{}.npy".format(x) \
            for x in range(n)
    ]

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        seq2cluster_path = seq2cluster_l[i]
        format_path = format_l[i]
        rs = np.load(seq2cluster_path)
        print(rs.shape)

        fold_num = str(i)

        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)

        m_df = kv_i_df.join(template_df.set_index("template"),on="template")
        m_df = run_cluster.renumber(m_df)

        s2c_ary = save_s2c(rs,m_df)
        print(s2c_ary.shape)
        np.save(format_path,s2c_ary)

def test_format_s2c():
    run_cluster = ClusterPairwise()
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    seq2cluster_l = [
        "feature/S2C/hhblits/cv0{}.npy".format(x) \
            for x in range(n)
    ]
    format_l = [
        "feature/S2C/test/hhblits/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        seq2cluster_path = seq2cluster_l[i]
        format_path = format_l[i]
        rs = np.load(seq2cluster_path)
        print(rs.shape)

        fold_num = str(i)

        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)

        m_df = kv_i_df.join(template_df.set_index("template"),on="template")
        m_df = run_cluster.renumber(m_df)

        s2c_ary = save_s2c(rs,m_df)
        print(s2c_ary.shape)
        np.save(format_path,s2c_ary)

def ind_format_s2c():
    run_cluster = ClusterPairwise()
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    seq2cluster_l = [
        "feature/S2C/training_cluster/hhblits/ind0{}.npy".format(x) \
            for x in range(n)
    ]
    format_l = [
        "feature/S2C/training_cluster/hhblits/ind0{}.npy".format(x) \
            for x in range(n)
    ]

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        seq2cluster_path = seq2cluster_l[i]
        format_path = format_l[i]
        rs = np.load(seq2cluster_path)
        print(rs.shape)

        fold_num = str(i)

        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)

        m_df = kv_i_df.join(template_df.set_index("template"),on="template")
        m_df = run_cluster.renumber(m_df)

        s2c_ary = save_s2c(rs,m_df)
        print(s2c_ary.shape)
        np.save(format_path,s2c_ary)

# 基于top-n-gram，hmm, pssm训练分类器
# 现在尝试把acc, top-n-gram结合来训练分类器
def representation_training():
    run_ltr = Ranker()
    tunning = True
    kernel = False

    # 减小C，虽然，SVM的性能下降，但是不会引起后续LTR的过拟合
    # 1.7太小了,21.7也达不到
    # 目前32最合适
    if not kernel:
        # 用于LinearSVM的参数
        params = {
            "C": 31.3
        }
    else:
        # 用于kernel SVM的参数
        params = {
            "gamma": 0.0625,
            "C": 32,
            "decision_function_shape":'ovr'
        }
    representaion_l = ["feature/hhblits/representation/representation_profile.npy"]
    val_representaion_l = ["feature/hhblits/representation/val_representation_profile.npy"]
    specific_l = ["feature/hhblits/acc_hmm/sequence_name2row_num.csv"]
    val_specific_l = ["feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"]
    if tunning:
        save_l = ["model/all/fine_tunning/svm/hhblits/representation"]
    else:
        save_l = ["model/all/all/svm/hhblits/representation"]
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    conf_path = "src/model/multiclass/train.conf"
    
    sequence_supefamily_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    kv_df = pd.read_csv(sequence_supefamily_path)

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_l[0],index_col=0)
    vspec_df = pd.read_csv(val_specific_l[0],index_col=0)

    time_suffix = time.strftime("%Y%m%d-%H:%M:%S",time.localtime())
    run_ltr.cli_cv_training(params,cv_df, spec_df, vspec_df, kv_df, conf_path,
        representaion_l, val_representaion_l,save_l,time_suffix,kernel)

def get_multiclass_prob():
    run_cv = Run()

    # classifier_l = [
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_00_20200819-12:11:23",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_01_20200819-14:52:13",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_02_20200819-17:35:34",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_03_20200819-20:12:01",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_04_20200819-22:42:42"
    # ]
    classifier_l = [
        "model/all/fine_tunning/svm/hhblits/representation/cv_00_20200824-20:58:16",
        "model/all/fine_tunning/svm/hhblits/representation/cv_01_20200824-22:57:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_02_20200825-00:46:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_03_20200825-02:36:22",
        "model/all/fine_tunning/svm/hhblits/representation/cv_04_20200825-04:27:26"
    ]
    # classifier_l = [
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_00_20200915-22:03:16",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_01_20200915-23:07:19",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_02_20200916-00:07:37",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_03_20200916-01:08:07",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_04_20200916-02:08:57"
    # ]
    # classifier_l = [
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_00_20200918-08:09:00",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_01_20200918-08:09:00",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_02_20200918-08:09:00",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_03_20200918-08:09:00",
    #     "model/all/fine_tunning/svm/hhblits/representation/cv_04_20200918-08:09:00"
    # ]


    n = 5

    prob_save_l = [
        "feature/multiclassification/training/hhblits/representation/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    representation_path = "feature/hhblits/representation/representation_profile.npy"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"

    fold_num_parser = re.compile(r"cv_(?P<fold_num>[0-9]+)_")

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    rep = np.load(representation_path)

    # 进行归一化
    rnomrs = run_cv.norms(rep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    rep /= rnorm

    template_df = spec_df.reset_index().rename(columns={"index":"template"})

    roc_list = []
    for i, classifier_path in enumerate(classifier_l):
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)
        
        # fn = int(fold_num_parser.search(classifier_path).group("fold_num")) # 这一步是为了去除数字前面的0
        fn = i
        fn_col = str(fn)

        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        ks = list(train_df.groupby("sf").groups.keys())
        labels = list(range(len(ks)))
        k_df = pd.DataFrame({"sf":ks,"index":labels})
        train_df = train_df.join(k_df.set_index("sf"),on="sf")
        train_df = train_df.rename(columns={"index":"new label"})
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能
        label = train_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(label,classes=classes)

        idx = train_df.loc[:, "row num"].to_numpy(int)

        X = rep[idx]
        y_pred = clf.decision_function(X)

        prob_path = prob_save_l[fn]
        np.save(prob_path,y_pred)

        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()

        for i in range(indices.shape[0]):
            idx = indices[i]
            yt = y_true[i][idx]
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            # cli_print = "printf '{} {}\n'".format(score1,score50)
            # sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)

    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)

# 通过训练好的linearsvm得到每条序列对不同类的打分
def val_multiclass_prob():
    run_cv = Run()

    classifier_l = [
        "model/all/fine_tunning/svm/hhblits/representation/cv_00_20200824-20:58:16",
        "model/all/fine_tunning/svm/hhblits/representation/cv_01_20200824-22:57:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_02_20200825-00:46:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_03_20200825-02:36:22",
        "model/all/fine_tunning/svm/hhblits/representation/cv_04_20200825-04:27:26"
    ]
    n = 5

    prob_save_l = [
        "feature/multiclassification/training/hhblits/representation/val0{}.npy".format(x) \
            for x in range(n)
    ]

    val_representation_path = "feature/hhblits/representation/val_representation_profile.npy"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    vspecific_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"

    fold_num_parser = re.compile(r"cv_(?P<fold_num>[0-9]+)_")

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(vspecific_path,index_col=0)
    vrep = np.load(val_representation_path)

    # 进行归一化
    # 这里之前貌似没有进行归一化
    rnomrs = run_cv.norms(vrep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    vrep /= rnorm

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    vtemplate_df = vspec_df.reset_index().rename(columns={"index":"template"})

    roc_list = []
    for i, classifier_path in enumerate(classifier_l):
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)

        # fn = int(fold_num_parser.search(classifier_path).group("fold_num")) # 这一步是为了去除数字前面的0
        fn = i
        fn_col = str(fn)

        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        ks = list(train_df.groupby("sf").groups.keys())
        labels = list(range(len(ks)))
        k_df = pd.DataFrame({"sf":ks,"index":labels})
        train_df = train_df.join(k_df.set_index("sf"),on="sf")
        train_df = train_df.rename(columns={"index":"new label"})
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能

        # 使用validation的label
        v_df = vtemplate_df.join(kv_df.set_index("template"),on="template")
        vks = list(v_df.groupby("sf").groups.keys())
        vlabels = list(range(len(vks)))
        vk_df = pd.DataFrame({"sf":vks,"index":vlabels})
        v_df = v_df.join(vk_df.set_index("sf"),on="sf")
        v_df = v_df.rename(columns={"index":"new label"})

        vlabel = v_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(vlabel,classes=classes)

        idx = v_df.loc[:, "row num"].to_numpy(int)

        X = vrep[idx]
        y_pred = clf.decision_function(X)

        prob_path = prob_save_l[fn]
        np.save(prob_path,y_pred)

        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()

        for i in range(indices.shape[0]):
            idx = indices[i]
            yt = y_true[i][idx]
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            # cli_print = "printf '{} {}\n'".format(score1,score50)
            # sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)

    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)

def test_multiclass_prob():
    run_cv = Run()

    classifier_l = [
        "model/all/fine_tunning/svm/hhblits/representation/cv_00_20200824-20:58:16",
        "model/all/fine_tunning/svm/hhblits/representation/cv_01_20200824-22:57:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_02_20200825-00:46:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_03_20200825-02:36:22",
        "model/all/fine_tunning/svm/hhblits/representation/cv_04_20200825-04:27:26"
    ]


    n = 5

    prob_save_l = [
        "feature/multiclassification/hhblits/representation/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    representation_path = "feature/hhblits/representation/representation_profile.npy"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"

    fold_num_parser = re.compile(r"cv_(?P<fold_num>[0-9]+)_")

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    rep = np.load(representation_path)

    # 进行归一化
    rnomrs = run_cv.norms(rep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    rep /= rnorm

    template_df = spec_df.reset_index().rename(columns={"index":"template"})

    roc_list = []
    for i, classifier_path in enumerate(classifier_l):
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)
        
        # fn = int(fold_num_parser.search(classifier_path).group("fold_num")) # 这一步是为了去除数字前面的0
        fn = i
        fn_col = str(fn)

        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能

        # 使用test_df的label
        test_df = template_df.loc[template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        test_df = test_df.join(kv_df.set_index("template"),on="template")
        tlabel = test_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(tlabel,classes=classes)

        idx = test_df.loc[:, "row num"].to_numpy(int)

        X = rep[idx]
        y_pred = clf.decision_function(X)

        prob_path = prob_save_l[fn]
        np.save(prob_path,y_pred)

        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()
        # indices = np.argsort(y_pred,axis=1)
        # print(y_pred.shape)
        for i in range(indices.shape[0]):
            idx = indices[i]
            yt = y_true[i][idx]
            # yt = np.flip(y_true[i, indices[i]])
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            # cli_print = "printf '{} {}\n'".format(score1,score50)
            # sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)

    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)


# 原本训练集的行是基于template的字典序的
# 要改成基于row num
def reconstruct():
    # run_reranker = ReRanker()
    # run_cluster = ClusterPairwise()

    n = 5
    # representation_path = "feature/S2C/training_cluster/hhblits/cv00.npy"
    representation_l = [
        "feature/S2C/training_cluster/hhblits/cv0{}.npy".format(x)\
            for x in range(n)
    ]

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/physicochemical/representation/sequence_name2row_num.csv"
    # key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    # kv_df = pd.read_csv(key2value_path)

    
    for i in range(n):
        fold_num = str(i)
        representation_path = representation_l[i]
        rep = tf.constant(np.load(representation_path),tf.float32)
        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_i_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        #原本是按template字典序
        t_i_df = t_i_df.sort_values(by="template")
        t_i_df = t_i_df.assign(new_row_num=list(range(t_i_df.shape[0])))
        t_df = t_i_df.sort_values(by="row num")
        # t_df
        indices = tf.reshape(tf.constant(t_df.loc[:,"new_row_num"]),(-1,1))
        rr = tf.gather_nd(rep,indices)
        np.save(representation_path,rr)


def ind_multiclass_prob():
    run_cv = Run()

    classifier_l = [
        "model/all/fine_tunning/svm/hhblits/representation/cv_00_20200824-20:58:16",
        "model/all/fine_tunning/svm/hhblits/representation/cv_01_20200824-22:57:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_02_20200825-00:46:11",
        "model/all/fine_tunning/svm/hhblits/representation/cv_03_20200825-02:36:22",
        "model/all/fine_tunning/svm/hhblits/representation/cv_04_20200825-04:27:26"
    ]

    n = 5

    prob_save_l = [
        "feature/multiclassification/training/hhblits/representation/ind0{}.npy".format(x) \
            for x in range(n)
    ]

    ind_representation_path = "feature/hhblits/representation/ind_representation_profile.npy"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/scop_scope/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    ispecific_path = "feature/hhblits/acc_hmm/ind_sequence_name2row_num.csv"

    fold_num_parser = re.compile(r"cv_(?P<fold_num>[0-9]+)_")

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    ispec_df = pd.read_csv(ispecific_path,index_col=0)
    irep = np.load(ind_representation_path)

    # 进行归一化
    rnomrs = run_cv.norms(irep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    irep /= rnorm

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    itemplate_df = ispec_df.reset_index().rename(columns={"index":"template"})

    roc_list = []
    for classifier_path in classifier_l:
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)

        fn = int(fold_num_parser.search(classifier_path).group("fold_num")) # 这一步是为了去除数字前面的0
        fn_col = str(fn)

        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        ks = list(train_df.groupby("sf").groups.keys())
        labels = list(range(len(ks)))
        k_df = pd.DataFrame({"sf":ks,"index":labels})
        train_df = train_df.join(k_df.set_index("sf"),on="sf")
        train_df = train_df.rename(columns={"index":"new label"})
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能

        # 使用validation的label
        i_df = itemplate_df.join(kv_df.set_index("template"),on="template")
        iks = list(i_df.groupby("sf").groups.keys())
        ilabels = list(range(len(iks)))
        ik_df = pd.DataFrame({"sf":iks,"index":ilabels})
        i_df = i_df.join(ik_df.set_index("sf"),on="sf")
        i_df = i_df.rename(columns={"index":"new label"})

        ilabel = i_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(ilabel,classes=classes)

        idx = i_df.loc[:, "row num"].to_numpy(int)

        X = irep[idx]
        y_pred = clf.decision_function(X)

        prob_path = prob_save_l[fn]
        np.save(prob_path,y_pred)

        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()

        for i in range(indices.shape[0]):
            idx = indices[i]
            yt = y_true[i][idx]
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            # cli_print = "printf '{} {}\n'".format(score1,score50)
            # sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)

    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)


def ind_pr_s2c():
    run_reranker = ReRanker()
    run_cluster = ClusterPairwise()
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    searched_path = "feature/hhblits/searched/independent_nr.csv"
    # searched_path = "feature/hhsearch/searched/searched_nr.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    ispecific_path = "feature/hhblits/acc_hmm/ind_sequence_name2row_num.csv"
    ikey2value_path = "dataset/scop_scope/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    ispec_df = pd.read_csv(ispecific_path,index_col=0)
    ikv_df = pd.read_csv(ikey2value_path)
    roc_at_flag = False # 控制是否输出对每一条序列的排序结果的评估

    n = 5

    reranking_l = [
        "feature/S2C/training_cluster/hhblits/ind0{}.npy".format(x) \
            for x in range(n)
    ]
    # reranking_l = ["feature/S2C/training/hhsearch/cv0{}".format(x) \
    #         for x in range(n)]

    # cli_print = "printf 'template\tROC1\tROC50\n'"
    # sp.call(cli_print,shell=True)
    # 这里的template_df也包含了对应的sf, label
    template_df = spec_df.join(ikv_df.set_index("template"))
    template_df = template_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        fold_num = str(i)
        reranking_path = reranking_l[i]
        # pairwise_df = run_reranker.get_pairwise_df(srch_df,fold_num,cv_df)
        # 做成训练集时query和template都不能属于对应fold_num下的序列
        pairwise_df = srch_df.loc[~srch_df.loc[:,"query"].isin(cv_df.loc[:, fold_num])]
        pairwise_df = pairwise_df.loc[~srch_df.loc[:, "template"].isin(cv_df.loc[:,fold_num])]
        # 这里要额外处理kv_df
        # 这里改成处理template_df
        # 因为，这里的template_df的格式类似于kv_df
        # kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
        t_i_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        r_list = []

        m, n = pairwise_df.shape
        cli_print = "printf 'pairwise_df shape {} {}\n'".format(int(m),int(n))
        sp.call(cli_print,shell=True)
        pairwise_df = run_reranker.expand_query(pairwise_df,ikv_df)
        # 这一步实际上已经让每一折的query, 依照字典序来排序了
        # 但是按字典序排序，训练集构造的顺序会有问题，因此，最好根据row num排序
        # 由于merge_df是基于pairwise_df和ikv_df，这样sf的label就和t_i_df一致了
        merge_df = pairwise_df.join(ispec_df,on="query")
        # for queryName, p_df in merge_df.groupby("query"):
        for queryName, p_df in merge_df.groupby("row num"):
            s = time.time()
            # 这里要注意，m_df结果是基于kv_i_df来拓展的，所以kv_i_df表示训练集
            # 这里的训练集符合交叉验证的划分
            # 但因为，query和template属于不同的数据集（scope和scope)，所以，同时还得保证sf的label是一致的
            # 所以这里改为通过t_i_df（包含训练集名称的dataframe)
            # m_df = run_reranker.expand_template(p_df,kv_i_df) # 原本的方法
            m_df = run_reranker.expand_template(p_df,t_i_df)
            R = run_reranker.pagerank(m_df, spec_df)
            # y_pred = ranking_roc_at(R, m_df, queryName)
            y_pred = R[:-1]

            # 这里要对m_df重新命名，把sf_template改为sf
            m_df1 = m_df.rename(columns={"sf_template":"sf"})
            # 重新给template编号，这一编号方法与pagerank内部一致
            m_df1 = m_df1.join(spec_df, on="template")
            m_df1 = run_cluster.renumber(m_df1)

            # 调整y_pred的shape为(-1,)
            y_pred = tf.reshape(y_pred,(-1,))
            y_pred = run_cluster.S2C_transform(y_pred,m_df1)
            m_df1 = m_df.rename(columns={"sf":"sf_template"})

            if roc_at_flag:
                ranking_roc_at(y_pred, m_df1, queryName)

            # cli_print = "printf '{}\n'".format(queryName)
            # sp.call(cli_print,shell=True)
            r_list.append(y_pred)
            e = time.time()
            cli_print = "printf 'time: {}\n'".format(e-s)
            sp.call(cli_print,shell=True)

        # rs = tf.transpose(tf.concat(r_list,axis=1))
        rs = tf.stack(r_list,axis=0) # 原本这里是[r_list]，正确的方法应该是去掉[]，不然shape会变成1*n_sample*n_sample

        # 这里之所以可以选择m_df1，是因为，m_df1种包含的template的个数以及顺序都是一致的
        # 直接用m_df1会出错
        # rs = save_s2c(rs,m_df1)
        np.save(reranking_path,rs)


if __name__ == "__main__":
    import numpy as np
    import tensorflow as tf
    import pandas as pd
    import time
    from six.moves import cPickle
    import os
    import re
    import time
    from src.model.randomwalk import ReRanker
    from src.model.cluster import Ranker
    from src.model.cluster import ClusterPairwise
    from src.evaluation.cross_validation import Run
    import subprocess as sp
    from sklearn.preprocessing import label_binarize

    # use_pr_s2c()
    # representation_training()
    # val_pagearank()
    # val_s2c()
    # format_s2c()
    # val_format_s2c()
    get_multiclass_prob()
    test_multiclass_prob()
    val_multiclass_prob()
    ind_multiclass_prob()
    # test_format_s2c()
    # reconstruct()
    # ind_pr_s2c()

    # ind_format_s2c()

