def representation_training():
    run_ltr = Ranker()
    kernel = False

    # 减小C，虽然，SVM的性能下降，但是不会引起后续LTR的过拟合
    # 1.7太小了,21.7也达不到
    # 目前32最合适

    # 重新生成了hmm
    # 观察32这个参数的效果
    if not kernel:
        # 用于LinearSVM的参数
        params = {
            "C": 11
        }
    else:
        # 用于kernel SVM的参数
        params = {
            "gamma": 0.0625,
            "C": 32,
            "decision_function_shape":'ovr'
        }

    representaion_l = ["feature/hhblitsexb/representation/representation_profile.npy"]
    val_representaion_l = ["feature/hhblitsexb/representation/val_representation_profile.npy"]
    specific_l = ["feature/hhblitsexb/acc_hmm/sequence_name2row_num.csv"]
    val_specific_l = ["feature/hhblitsexb/acc_hmm/val_sequence_name2row_num.csv"]

    save_l = ["model/exb/svm/hhblitsexb/representation"] # 用于psiblast通过uniref生成的pssm
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    conf_path = "src/model/multiclass/train.conf"
    
    sequence_supefamily_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    kv_df = pd.read_csv(sequence_supefamily_path)

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_l[0],index_col=0)
    vspec_df = pd.read_csv(val_specific_l[0],index_col=0)

    time_suffix = time.strftime("%Y%m%d-%H:%M:%S",time.localtime())
    run_ltr.cli_cv_training(params,cv_df, spec_df, vspec_df, kv_df, conf_path,
        representaion_l, val_representaion_l,save_l,time_suffix,kernel)


def ranking_roc_at(y_pred, m_df, selQuery):
    # print(selQuery)
    # 获取query的superfamily
    # q_temp_idx = kv_df.index[kv_df.loc[:,"template"] == selQuery]
    # 因为现在基于row num排序了，参数selQuery实际上是query对应的row num
    # print(m_df.columns)
    try:
        q_temp_idx = m_df.index[m_df.loc[:,"query"] == selQuery]
        # print(q_temp_idx)
        # qt = kv_df.loc[q_temp_idx[0],"sf"]
        qt = m_df.loc[q_temp_idx[0],"sf_query"]
        # print(qt)
    except:
        q_temp_idx = m_df.index[m_df.loc[:,"row num_query"] == selQuery]
        qt = m_df.loc[q_temp_idx[0],"sf_query"]


    y_true = (m_df.loc[:,"sf_template"] == qt).to_numpy(int)
    # print(y_true.shape)
    # print(y_true)

    sidx = np.flip(np.argsort(tf.reshape(y_pred,(-1,)).numpy()))
    level = 1
    score1 = run_cv.cal_roc_mu_at(level, y_true[sidx])
    level = 50
    score50 = run_cv.cal_roc_mu_at(level,y_true[sidx])
    # print(score)
    cli_print = "printf '{}\t{}\t{}\n'".format(selQuery,score1,score50)
    sp.call(cli_print,shell=True)

# 为了节省存储空间本程序直接生成s2c结果，不保存中间DFG的结果
# 与clustering.py生成的结果不同，本程序直接生成n_sample * n_class的矩阵
# 用于将y_pred这种序列对序列的排序转为序列对class的排序，因为此时属于同一class的序列打分一致
def save_s2c(rs, m_df):
    idx_list = []
    for _, g in m_df.groupby("sf"):
        idx = g.loc[:,"new_row_num"].to_numpy(int)[0]
        idx = idx.reshape((-1,1))
        idx_list.append(idx)

    indices = np.vstack(idx_list)
    
    s2c = tf.transpose(tf.gather_nd(tf.transpose(rs), indices))
    return s2c

def use_pr_s2c():
    run_reranker = ReRanker()
    run_cluster = ClusterPairwise()
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    searched_path = "feature/psiblast/uniref/searched/searched_nr.csv"
    specific_path = "feature/psiblast/acc_pssm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5

    reranking_l = [
        "feature/S2C/training_cluster/psiblastexb/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    # cli_print = "printf 'template\tROC1\tROC50\n'"
    # sp.call(cli_print,shell=True)

    for i in range(n):
        fold_num = str(i)
        reranking_path = reranking_l[i]
        # pairwise_df = run_reranker.get_pairwise_df(srch_df,fold_num,cv_df)
        # 做成训练集时query和template都不能属于对应fold_num下的序列
        pairwise_df = srch_df.loc[~srch_df.loc[:,"query"].isin(cv_df.loc[:, fold_num])]
        pairwise_df = pairwise_df.loc[~srch_df.loc[:, "template"].isin(cv_df.loc[:,fold_num])]
        # 这里要额外处理kv_df
        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
        r_list = []

        m, n = pairwise_df.shape
        cli_print = "printf 'pairwise_df shape {} {}\n'".format(int(m),int(n))
        sp.call(cli_print,shell=True)
        pairwise_df = run_reranker.expand_query(pairwise_df,kv_df)
        # 这一步实际上已经让每一折的query, 依照字典序来排序了
        # 但是按字典序排序，训练集构造的顺序会有问题，因此，最好根据row num排序
        merge_df = pairwise_df.join(spec_df,on="query")
        mg = merge_df.groupby("row num")
        # for queryName, p_df in merge_df.groupby("query"):
        for query_num, indices in mg.groups.items():
            s = time.time()
            p_df = pairwise_df.loc[indices]
            m_df = run_reranker.expand_template(p_df,kv_i_df)
            R = run_reranker.pagerank(m_df, spec_df)
            # y_pred = ranking_roc_at(R, m_df, queryName)
            y_pred = R[:-1]

            # 这里要对m_df重新命名，把sf_template改为sf
            m_df1 = m_df.rename(columns={"sf_template":"sf"})
            # 重新给template编号，这一编号程序与pagerank内部一致
            m_df1 = m_df1.join(spec_df, on="template")
            m_df1 = run_cluster.renumber(m_df1)

            # 调整y_pred的shape为(-1,)
            y_pred = tf.reshape(y_pred,(-1,))
            y_pred = run_cluster.S2C_transform(y_pred,m_df1)
            m_df1 = m_df.rename(columns={"sf":"sf_template"})
            # qn = spec_df.index[int(query_num)]
            # ranking_roc_at(y_pred, m_df1, qn)

            # cli_print = "printf '{}\n'".format(queryName)
            # sp.call(cli_print,shell=True)
            r_list.append(y_pred)
            e = time.time()
            cli_print = "printf 'time: {}\n'".format(e-s)
            sp.call(cli_print,shell=True)

        # rs = tf.transpose(tf.concat(r_list,axis=1))
        rs = tf.stack(r_list,axis=0)

        # s2c = save_s2c(rs,m_df1)
        np.save(reranking_path,rs)

def test_pr_s2c():
    run_reranker = ReRanker()
    run_cluster = ClusterPairwise()
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    searched_path = "feature/hhblitsexb/searched/searched_nr.csv"
    specific_path = "feature/psiblast/acc_pssm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5

    reranking_l = [
        "feature/S2C/test/hhblitsexb/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    # cli_print = "printf 'template\tROC1\tROC50\n'"
    # sp.call(cli_print,shell=True)
    
    for i in range(n):
        fold_num = str(i)
        reranking_path = reranking_l[i]
        # pairwise_df = run_reranker.get_pairwise_df(srch_df,fold_num,cv_df)
        # 做成测试集时template不能属于对应fold_num下的序列
        pairwise_df = srch_df.loc[srch_df.loc[:,"query"].isin(cv_df.loc[:, fold_num])]
        pairwise_df = pairwise_df.loc[~srch_df.loc[:, "template"].isin(cv_df.loc[:,fold_num])]
        # 这里要额外处理kv_df
        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
        r_list = []

        m, n = pairwise_df.shape
        cli_print = "printf 'pairwise_df shape {} {}\n'".format(int(m),int(n))
        sp.call(cli_print,shell=True)
        pairwise_df = run_reranker.expand_query(pairwise_df,kv_df)
        # 这一步实际上已经让每一折的query, 依照字典序来排序了
        # 但是按字典序排序，训练集构造的顺序会有问题，因此，最好根据row num排序
        merge_df = pairwise_df.join(spec_df,on="query")
        mg = merge_df.groupby("row num")
        # for queryName, p_df in merge_df.groupby("query"):
        for query_num, indices in mg.groups.items():
            s = time.time()
            p_df = pairwise_df.loc[indices]
            m_df = run_reranker.expand_template(p_df,kv_i_df)
            R = run_reranker.pagerank(m_df, spec_df)
            # y_pred = ranking_roc_at(R, m_df, queryName)
            y_pred = R[:-1]

            # 这里要对m_df重新命名，把sf_template改为sf
            m_df1 = m_df.rename(columns={"sf_template":"sf"})
            # 重新给template编号，这一编号程序与pagerank内部一致
            m_df1 = m_df1.join(spec_df, on="template")
            m_df1 = run_cluster.renumber(m_df1)

            # 调整y_pred的shape为(-1,)
            y_pred = tf.reshape(y_pred,(-1,))
            y_pred = run_cluster.S2C_transform(y_pred,m_df1)
            m_df1 = m_df.rename(columns={"sf":"sf_template"})
            qn = spec_df.index[int(query_num)]
            ranking_roc_at(y_pred, m_df1, qn)

            # cli_print = "printf '{}\n'".format(queryName)
            # sp.call(cli_print,shell=True)
            r_list.append(y_pred)
            e = time.time()
            cli_print = "printf 'time: {}\n'".format(e-s)
            sp.call(cli_print,shell=True)
        

        # rs = tf.transpose(tf.concat(r_list,axis=1))
        rs = tf.stack(r_list,axis=0)

        # s2c = save_s2c(rs,m_df1)
        np.save(reranking_path,rs)


def val_pr_s2c():
    run_reranker = ReRanker()
    run_cluster = ClusterPairwise()
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    searched_path = "feature/hhblitsexb/searched/validation_nr.csv"
    specific_path = "feature/psiblast/acc_pssm/sequence_name2row_num.csv"
    vspecific_path = "feature/psiblast/acc_pssm/val_sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(vspecific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5

    reranking_l = [
        "feature/S2C/training_cluster/hhblitsexb/val0{}.npy".format(x) \
            for x in range(n)
    ]

    srch_df = srch_df.loc[~pd.isna(srch_df.loc[:,"template"])]
    # cli_print = "printf 'template\tROC1\tROC50\n'"
    # sp.call(cli_print,shell=True)
    
    for i in range(n):
        fold_num = str(i)
        reranking_path = reranking_l[i]
        # pairwise_df = run_reranker.get_pairwise_df(srch_df,fold_num,cv_df)
        # 做成验证集集时template不能属于对应fold_num下的序列
        pairwise_df = srch_df.loc[~srch_df.loc[:, "template"].isin(cv_df.loc[:,fold_num])]
        # 这里要额外处理kv_df
        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
        r_list = []

        m, n = pairwise_df.shape
        cli_print = "printf 'pairwise_df shape {} {}\n'".format(int(m),int(n))
        sp.call(cli_print,shell=True)
        pairwise_df = run_reranker.expand_query(pairwise_df,kv_df)
        # 这一步实际上已经让每一折的query, 依照字典序来排序了
        # 但是按字典序排序，训练集构造的顺序会有问题，因此，最好根据row num排序
        merge_df = pairwise_df.join(vspec_df,on="query")
        mg = merge_df.groupby("row num")
        # for queryName, p_df in merge_df.groupby("query"):
        for query_num, indices in mg.groups.items():
            s = time.time()
            p_df = pairwise_df.loc[indices]
            m_df = run_reranker.expand_template(p_df,kv_i_df)
            R = run_reranker.pagerank(m_df, spec_df)
            # y_pred = ranking_roc_at(R, m_df, queryName)
            y_pred = R[:-1]

            # 这里要对m_df重新命名，把sf_template改为sf
            m_df1 = m_df.rename(columns={"sf_template":"sf"})
            # 重新给template编号，这一编号程序与pagerank内部一致
            m_df1 = m_df1.join(spec_df, on="template")
            m_df1 = run_cluster.renumber(m_df1)

            # 调整y_pred的shape为(-1,)
            y_pred = tf.reshape(y_pred,(-1,))
            y_pred = run_cluster.S2C_transform(y_pred,m_df1)
            m_df1 = m_df.rename(columns={"sf":"sf_template"})
            # qn = vspec_df.index[int(query_num)]
            # ranking_roc_at(y_pred, m_df1, qn)

            # cli_print = "printf '{}\n'".format(queryName)
            # sp.call(cli_print,shell=True)
            r_list.append(y_pred)
            e = time.time()
            cli_print = "printf 'time: {}\n'".format(e-s)
            sp.call(cli_print,shell=True)
        
        
        # rs = tf.transpose(tf.concat(r_list,axis=1))
        rs = tf.stack(r_list,axis=0)

        # s2c = save_s2c(rs,m_df1)
        np.save(reranking_path,rs)

def ind_pr_s2c():
    run_reranker = ReRanker()
    run_cluster = ClusterPairwise()
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    searched_path = "feature/psiblast/uniref/searched/independent_nr.csv"
    # searched_path = "feature/hhsearch/searched/searched_nr.csv"
    specific_path = "feature/psiblast/acc_pssm/sequence_name2row_num.csv"
    ispecific_path = "feature/psiblast/acc_pssm/ind_sequence_name2row_num.csv"
    ikey2value_path = "dataset/scop_scope/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    ispec_df = pd.read_csv(ispecific_path,index_col=0)
    ikv_df = pd.read_csv(ikey2value_path)
    roc_at_flag = False # 控制是否输出对每一条序列的排序结果的评估

    n = 5

    reranking_l = [
        "feature/S2C/training_cluster/psiblastexb/ind0{}.npy".format(x) \
            for x in range(n)
    ]
    # reranking_l = ["feature/S2C/training/hhsearch/cv0{}".format(x) \
    #         for x in range(n)]

    # 处理srch_df
    # 保证没有na值
    srch_df = srch_df.loc[~pd.isna(srch_df.loc[:,"template"])]

    # cli_print = "printf 'template\tROC1\tROC50\n'"
    # sp.call(cli_print,shell=True)
    # 这里的template_df也包含了对应的sf, label
    template_df = spec_df.join(ikv_df.set_index("template"))
    template_df = template_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        fold_num = str(i)
        reranking_path = reranking_l[i]
        # pairwise_df = run_reranker.get_pairwise_df(srch_df,fold_num,cv_df)
        # 做成训练集时query和template都不能属于对应fold_num下的序列
        pairwise_df = srch_df.loc[~srch_df.loc[:, "template"].isin(cv_df.loc[:,fold_num])]
        # 这里要额外处理kv_df
        # 这里改成处理template_df
        # 因为，这里的template_df的格式类似于kv_df
        # kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
        t_i_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        r_list = []

        m, n = pairwise_df.shape
        cli_print = "printf 'pairwise_df shape {} {}\n'".format(int(m),int(n))
        sp.call(cli_print,shell=True)
        pairwise_df = run_reranker.expand_query(pairwise_df,ikv_df)
        # 这一步实际上已经让每一折的query, 依照字典序来排序了
        # 但是按字典序排序，训练集构造的顺序会有问题，因此，最好根据row num排序
        # 由于merge_df是基于pairwise_df和ikv_df，这样sf的label就和t_i_df一致了
        merge_df = pairwise_df.join(ispec_df,on="query")
        # for queryName, p_df in merge_df.groupby("query"):
        for queryName, p_df in merge_df.groupby("row num"):
            s = time.time()
            # 这里要注意，m_df结果是基于kv_i_df来拓展的，所以kv_i_df表示训练集
            # 这里的训练集符合交叉验证的划分
            # 但因为，query和template属于不同的数据集（scope和scope)，所以，同时还得保证sf的label是一致的
            # 所以这里改为通过t_i_df（包含训练集名称的dataframe)
            # m_df = run_reranker.expand_template(p_df,kv_i_df) # 原本的方法
            m_df = run_reranker.expand_template(p_df,t_i_df)
            R = run_reranker.pagerank(m_df, spec_df)
            # y_pred = ranking_roc_at(R, m_df, queryName)
            y_pred = R[:-1]

            # 这里要对m_df重新命名，把sf_template改为sf
            m_df1 = m_df.rename(columns={"sf_template":"sf"})
            # 重新给template编号，这一编号方法与pagerank内部一致
            m_df1 = m_df1.join(spec_df, on="template")
            m_df1 = run_cluster.renumber(m_df1)

            # 调整y_pred的shape为(-1,)
            y_pred = tf.reshape(y_pred,(-1,))
            y_pred = run_cluster.S2C_transform(y_pred,m_df1)
            

            if roc_at_flag:
                m_df1 = m_df.rename(columns={"sf":"sf_template"})
                ranking_roc_at(y_pred, m_df1, queryName)

            # cli_print = "printf '{}\n'".format(queryName)
            # sp.call(cli_print,shell=True)
            r_list.append(y_pred)
            e = time.time()
            cli_print = "printf 'time: {}\n'".format(e-s)
            sp.call(cli_print,shell=True)

        # rs = tf.transpose(tf.concat(r_list,axis=1))
        rs = tf.stack(r_list,axis=0) # 原本这里是[r_list]，正确的方法应该是去掉[]，不然shape会变成1*n_sample*n_sample

        # 这里之所以可以选择m_df1，是因为，m_df1种包含的template的个数以及顺序都是一致的
        # 直接用m_df1会出错
        # rs = save_s2c(rs,m_df1)
        np.save(reranking_path,rs)

def pre_val_ltr():
    run_lambdamart = LambdaMART()
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    
    searched_l = [
        "feature/psiblast/uniref/searched/validation_nr.csv"
    ]

    n = 5
    representation_dirs = [
        "feature/S2C/training_cluster/psiblastexb"
    ]

    representation_dict = {}
    for i in range(n):
        representation_dict[i] = [
            os.path.join(x,"val0{}.npy".format(i))\
                for x in representation_dirs
        ]

    ind_ser = pd.Series(spec_df.index)
    for i in range(n):
        fold_num = str(i)
        representation_l = representation_dict[i]

        # print(query_ser)
        for j, searched_path in enumerate(searched_l):
            representation_path = representation_l[j]
            srch_df = pd.read_csv(searched_path)
            srch_df = srch_df.loc[~pd.isna(srch_df.loc[:,"template"])]
            pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]

            con = tf.constant(np.load(representation_path),tf.float32)
            print(con.shape)
            con = run_lambdamart.completement_test_set(ind_ser,pairwise_df,con)
            print(con.shape)
            np.save(representation_path,con) #把这句话注释掉可以观察输出结果


def val_format_s2c():
    run_cluster = ClusterPairwise()
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    seq2cluster_l = [
        "feature/S2C/training_cluster/hhblitsexb/val0{}.npy".format(x) \
            for x in range(n)
    ]
    format_l = [
        "feature/S2C/training_cluster/hhblitsexb/val0{}.npy".format(x) \
            for x in range(n)
    ]

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        seq2cluster_path = seq2cluster_l[i]
        format_path = format_l[i]
        rs = np.load(seq2cluster_path)
        print(rs.shape)

        fold_num = str(i)

        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)

        m_df = kv_i_df.join(template_df.set_index("template"),on="template")
        m_df = run_cluster.renumber(m_df)

        s2c_ary = save_s2c(rs,m_df)
        print(s2c_ary.shape)
        np.save(format_path,s2c_ary)
    
def ind_eval_prs2c():
    n = 5
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/scop_scope/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblitsexb/acc_hmm/sequence_name2row_num.csv"
    ispecific_path = "feature/hhblitsexb/acc_hmm/ind_sequence_name2row_num.csv"
    output_file_path = "evaluation/roc_at/ori/s2c/hhblitsexb/ind_seq_rocat.txt"

    pred_dir = "feature/S2C/training_cluster/hhblitsexb"
    pred_paths = list(map(lambda x:os.path.join(pred_dir,"ind0{}.npy".format(x)),range(n)))

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    ispec_df = pd.read_csv(ispecific_path,index_col=0)


    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    itemplate_df = ispec_df.reset_index().rename(columns={"index":"template"})
    each_flag =False
    save_output_flag =True

    roc_list = []
    for i in range(n):
        # fn = int(fold_num_parser.search(classifier_path).group("fold_num")) # 这一步是为了去除数字前面的0
        fn = i
        fn_col = str(fn)

        pred_path = pred_paths[i]        

        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        ks = list(train_df.groupby("sf").groups.keys())
        labels = list(range(len(ks)))
        k_df = pd.DataFrame({"sf":ks,"index":labels})
        train_df = train_df.join(k_df.set_index("sf"),on="sf")
        train_df = train_df.rename(columns={"index":"new label"})
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能

        # 使用validation的label
        i_df = itemplate_df.join(kv_df.set_index("template"),on="template")
        iks = list(i_df.groupby("sf").groups.keys())
        ilabels = list(range(len(iks)))
        ik_df = pd.DataFrame({"sf":iks,"index":ilabels})
        i_df = i_df.join(ik_df.set_index("sf"),on="sf")
        i_df = i_df.rename(columns={"index":"new label"})

        ilabel = i_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(ilabel,classes=classes)

        idx = i_df.loc[:, "row num"].to_numpy(int)

        # y_pred = clf.decision_function(X)
        y_pred = np.load(pred_path)


        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()

        for i in range(indices.shape[0]):
            idx = indices[i]
            yt = y_true[i][idx]
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{} {}\n'".format(score1,score50)
                sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)

    if save_output_flag:
        np.savetxt(output_file_path,roc_ary,"%.16f")
    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)


def get_multiclass_prob():

    classifier_l = [
        "model/exb/svm/hhblitsexb/representation/cv_00_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_01_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_02_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_03_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_04_20201026-10:10:32"
    ]

    n = 5

    prob_save_l = [
        "feature/multiclassification/training/hhblitsexb/representation/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    representation_path = "feature/hhblitsexb/representation/representation_profile.npy"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblitsexb/acc_hmm/sequence_name2row_num.csv"
    output_file_path = "evaluation/roc_at/ori/multiclassification/hhblitsexb/train_seq_rocat.txt"

    fold_num_parser = re.compile(r"cv_(?P<fold_num>[0-9]+)_")

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    rep = np.load(representation_path)

    # 进行归一化
    rnomrs = run_cv.norms(rep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    rep /= rnorm

    template_df = spec_df.reset_index().rename(columns={"index":"template"})

    each_flag = False
    save_output_flag = True

    roc_list = []
    for i, classifier_path in enumerate(classifier_l):
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)
        
        # fn = int(fold_num_parser.search(classifier_path).group("fold_num")) # 这一步是为了去除数字前面的0
        fn = i
        fn_col = str(fn)

        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        ks = list(train_df.groupby("sf").groups.keys())
        labels = list(range(len(ks)))
        k_df = pd.DataFrame({"sf":ks,"index":labels})
        train_df = train_df.join(k_df.set_index("sf"),on="sf")
        train_df = train_df.rename(columns={"index":"new label"})
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能
        label = train_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(label,classes=classes)

        idx = train_df.loc[:, "row num"].to_numpy(int)

        X = rep[idx]
        y_pred = clf.decision_function(X)

        prob_path = prob_save_l[fn]
        np.save(prob_path,y_pred)

        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()

        for i in range(indices.shape[0]):
            idx = indices[i]
            yt = y_true[i][idx]
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{} {}\n'".format(score1,score50)
                sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)
    if save_output_flag:
        np.savetxt(output_file_path,roc_ary,"%.16f")
    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)


def test_multiclass_prob():

    classifier_l = [
        "model/exb/svm/hhblitsexb/representation/cv_00_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_01_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_02_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_03_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_04_20201026-10:10:32"
    ]


    n = 5

    prob_save_l = [
        "feature/multiclassification/hhblitsexb/representation/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    representation_path = "feature/hhblitsexb/representation/representation_profile.npy"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblitsexb/acc_hmm/sequence_name2row_num.csv"
    output_filt_path = "evaluation/roc_at/ori/multiclassification/hhblitsexb/eval_seq_rocat.txt"

    fold_num_parser = re.compile(r"cv_(?P<fold_num>[0-9]+)_")

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    rep = np.load(representation_path)

    # 进行归一化
    rnomrs = run_cv.norms(rep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    rep /= rnorm

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    each_flag = False
    save_output_file = True

    roc_list = []
    for i, classifier_path in enumerate(classifier_l):
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)
        
        # fn = int(fold_num_parser.search(classifier_path).group("fold_num")) # 这一步是为了去除数字前面的0
        fn = i
        fn_col = str(fn)

        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能

        # 使用test_df的label
        test_df = template_df.loc[template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        test_df = test_df.join(kv_df.set_index("template"),on="template")
        tlabel = test_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(tlabel,classes=classes)

        idx = test_df.loc[:, "row num"].to_numpy(int)

        X = rep[idx]
        y_pred = clf.decision_function(X)

        prob_path = prob_save_l[fn]
        np.save(prob_path,y_pred)

        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()
        # indices = np.argsort(y_pred,axis=1)
        # print(y_pred.shape)
        for i in range(indices.shape[0]):
            idx = indices[i]
            yt = y_true[i][idx]
            # yt = np.flip(y_true[i, indices[i]])
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{} {}\n'".format(score1,score50)
                sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)
    if save_output_file:
        np.savetxt(output_filt_path,roc_ary,"%.16f")
    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)

def val_multiclass_prob():

    classifier_l = [
        "model/exb/svm/hhblitsexb/representation/cv_00_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_01_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_02_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_03_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_04_20201026-10:10:32"
    ]
    n = 5

    prob_save_l = [
        "feature/multiclassification/training/hhblitsexb/representation/val0{}.npy".format(x) \
            for x in range(n)
    ]

    val_representation_path = "feature/hhblitsexb/representation/val_representation_profile.npy"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblitsexb/acc_hmm/sequence_name2row_num.csv"
    vspecific_path = "feature/hhblitsexb/acc_hmm/val_sequence_name2row_num.csv"

    fold_num_parser = re.compile(r"cv_(?P<fold_num>[0-9]+)_")

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(vspecific_path,index_col=0)
    vrep = np.load(val_representation_path)

    # 进行归一化
    # 这里之前貌似没有进行归一化
    rnomrs = run_cv.norms(vrep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    vrep /= rnorm

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    vtemplate_df = vspec_df.reset_index().rename(columns={"index":"template"})

    roc_list = []
    for i, classifier_path in enumerate(classifier_l):
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)

        # fn = int(fold_num_parser.search(classifier_path).group("fold_num")) # 这一步是为了去除数字前面的0
        fn = i
        fn_col = str(fn)

        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        ks = list(train_df.groupby("sf").groups.keys())
        labels = list(range(len(ks)))
        k_df = pd.DataFrame({"sf":ks,"index":labels})
        train_df = train_df.join(k_df.set_index("sf"),on="sf")
        train_df = train_df.rename(columns={"index":"new label"})
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能

        # 使用validation的label
        v_df = vtemplate_df.join(kv_df.set_index("template"),on="template")
        vks = list(v_df.groupby("sf").groups.keys())
        vlabels = list(range(len(vks)))
        vk_df = pd.DataFrame({"sf":vks,"index":vlabels})
        v_df = v_df.join(vk_df.set_index("sf"),on="sf")
        v_df = v_df.rename(columns={"index":"new label"})

        vlabel = v_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(vlabel,classes=classes)

        idx = v_df.loc[:, "row num"].to_numpy(int)

        X = vrep[idx]
        y_pred = clf.decision_function(X)

        prob_path = prob_save_l[fn]
        np.save(prob_path,y_pred)

        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()

        for i in range(indices.shape[0]):
            idx = indices[i]
            yt = y_true[i][idx]
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            # cli_print = "printf '{} {}\n'".format(score1,score50)
            # sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)

    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)

def ind_multiclass_prob():

    classifier_l = [
        "model/exb/svm/hhblitsexb/representation/cv_00_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_01_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_02_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_03_20201026-10:10:32",
        "model/exb/svm/hhblitsexb/representation/cv_04_20201026-10:10:32"
    ]

    n = 5

    prob_save_l = [
        "feature/multiclassification/training/hhblitsexb/representation/ind0{}.npy".format(x) \
            for x in range(n)
    ]

    ind_representation_path = "feature/hhblitsexb/representation/ind_representation_profile.npy"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    key2value_path = "dataset/scop_scope/csv/sequence_superfamily.csv"
    specific_path = "feature/hhblitsexb/acc_hmm/sequence_name2row_num.csv"
    ispecific_path = "feature/hhblitsexb/acc_hmm/ind_sequence_name2row_num.csv"
    output_file_path = "evaluation/roc_at/ori/multiclassification/hhblitsexb/ind_seq_rocat.txt"

    fold_num_parser = re.compile(r"cv_(?P<fold_num>[0-9]+)_")

    cv_df = pd.read_csv(cross_validation_path)
    kv_df = pd.read_csv(key2value_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    ispec_df = pd.read_csv(ispecific_path,index_col=0)
    irep = np.load(ind_representation_path)

    # 进行归一化
    rnomrs = run_cv.norms(irep,[1,2,np.inf],1)
    rnorm = np.mean(rnomrs,axis=1,keepdims=True)
    irep /= rnorm

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    itemplate_df = ispec_df.reset_index().rename(columns={"index":"template"})
    each_flag =False
    save_output_flag =True

    roc_list = []
    for classifier_path in classifier_l:
        with open(classifier_path,"rb") as h:
            clf = cPickle.load(h)

        fn = int(fold_num_parser.search(classifier_path).group("fold_num")) # 这一步是为了去除数字前面的0
        fn_col = str(fn)

        train_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fn_col])]
        train_df = train_df.join(kv_df.set_index("template"),on="template")
        ks = list(train_df.groupby("sf").groups.keys())
        labels = list(range(len(ks)))
        k_df = pd.DataFrame({"sf":ks,"index":labels})
        train_df = train_df.join(k_df.set_index("sf"),on="sf")
        train_df = train_df.rename(columns={"index":"new label"})
        classes = list(train_df.groupby("label").groups.keys()) # classes还是用原来的标签，方便评估模型性能

        # 使用validation的label
        i_df = itemplate_df.join(kv_df.set_index("template"),on="template")
        iks = list(i_df.groupby("sf").groups.keys())
        ilabels = list(range(len(iks)))
        ik_df = pd.DataFrame({"sf":iks,"index":ilabels})
        i_df = i_df.join(ik_df.set_index("sf"),on="sf")
        i_df = i_df.rename(columns={"index":"new label"})

        ilabel = i_df.loc[:,"label"].to_numpy(int)
        y_true = label_binarize(ilabel,classes=classes)

        idx = i_df.loc[:, "row num"].to_numpy(int)

        X = irep[idx]
        y_pred = clf.decision_function(X)

        prob_path = prob_save_l[fn]
        np.save(prob_path,y_pred)

        indices = tf.argsort(y_pred,axis=1,direction="DESCENDING").numpy()

        for i in range(indices.shape[0]):
            idx = indices[i]
            yt = y_true[i][idx]
            score1 = run_cv.cal_roc_mu_at(1, yt)
            score50 = run_cv.cal_roc_mu_at(50,yt)

            roc_list.append([score1,score50])

            if each_flag:
                cli_print = "printf '{} {}\n'".format(score1,score50)
                sp.call(cli_print,shell=True)

    roc_ary = np.array(roc_list)
    s = roc_ary.mean(0)

    if save_output_flag:
        np.savetxt(output_file_path,roc_ary,"%.16f")
    cli_print = "printf '{}\n'".format(s)
    sp.call(cli_print,shell=True)



if __name__ == "__main__":
    import pandas as pd
    import numpy as np
    from six.moves import cPickle
    from src.model.cluster import Ranker
    from src.model.randomwalk import ReRanker
    import tensorflow as tf
    from src.evaluation.cross_validation import Run
    import subprocess as sp
    import re
    import time
    import os
    from src.model.cluster import ClusterPairwise
    from sklearn.preprocessing import label_binarize
    from src.model.learningtorank import LambdaMART

    run_cv = Run()

    # representation_training()
    # use_pr_s2c()
    # test_pr_s2c()
    # val_pr_s2c()
    # ind_pr_s2c()
    # pre_val_ltr()
    # val_format_s2c()

    ind_eval_prs2c()

    # get_multiclass_prob()
    # test_multiclass_prob()
    # val_multiclass_prob()
    # ind_multiclass_prob()
    
