# 本程序用于制作S2C训练集
# clustering.py以及use_reranker.py，则是生成测试集

def ranking_roc_at(y_pred, m_df, selQuery):
    run_cv = Run()
    # print(selQuery)
    # 获取query的superfamily
    # q_temp_idx = kv_df.index[kv_df.loc[:,"template"] == selQuery]
    # 因为现在基于row num排序了，参数selQuery实际上是query对应的row num
    print(m_df.columns)
    # q_temp_idx = m_df.index[m_df.loc[:,"query"] == selQuery]
    q_temp_idx = m_df.index[m_df.loc[:,"row num_query"] == selQuery]
    # print(q_temp_idx)
    # qt = kv_df.loc[q_temp_idx[0],"sf"]
    qt = m_df.loc[q_temp_idx[0],"sf_query"]
    # print(qt)

    y_true = (m_df.loc[:,"sf_template"] == qt).to_numpy(int)
    # print(y_true.shape)
    # print(y_true)

    sidx = np.flip(np.argsort(tf.reshape(y_pred,(-1,)).numpy()))
    level = 1
    score1 = run_cv.cal_roc_mu_at(level, y_true[sidx])
    level = 50
    score50 = run_cv.cal_roc_mu_at(level,y_true[sidx])
    # print(score)
    cli_print = "printf '{}\t{}\t{}\n'".format(selQuery,score1,score50)
    sp.call(cli_print,shell=True)

def s2c_roc_at(newr, queryName, m_df, kv_df):
    run_cv = Run()

    qidx = kv_df.loc[kv_df.loc[:, "template"] == queryName].index
    query_sf = kv_df.loc[qidx[0],"sf"]
    # print(query_sf)

    label = (query_sf == m_df.loc[:,"sf"]).to_numpy(int)
    # print(label)
    idx = tf.argsort(newr,direction="DESCENDING").numpy()

    y_true = label[idx]

    level = 1
    score1 = run_cv.cal_roc_mu_at(level,y_true)
    level = 50
    score50 = run_cv.cal_roc_mu_at(level,y_true)
    cli_print = "printf '{}\t{}\t{}\n'".format(queryName,score1,score50)
    sp.call(cli_print,shell=True)

# 为了节省存储空间本程序直接生成s2c结果，不保存中间DFG的结果
# 与clustering.py生成的结果不同，本程序直接生成n_sample * n_class的矩阵
# 用于将y_pred这种序列对序列的排序转为序列对class的排序，因为此时属于同一class的序列打分一致
def save_s2c(rs, m_df):
    idx_list = []
    for _, g in m_df.groupby("sf"):
        idx = g.loc[:,"new_row_num"].to_numpy(int)[0]
        idx = idx.reshape((-1,1))
        idx_list.append(idx)

    indices = np.vstack(idx_list)
    
    s2c = tf.transpose(tf.gather_nd(tf.transpose(rs), indices))
    return s2c

def use_pr_s2c():
    run_reranker = ReRanker()
    run_cluster = ClusterPairwise()
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    # searched_path = "feature/hhblits/searched/searched_nr.csv"
    searched_path = "feature/hhsearch/searched/searched_nr.csv"
    specific_path = "feature/physicochemical/representation/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5

    # reranking_l = [
    #     "feature/S2C/training/hhblits/cv0{}.npy".format(x) \
    #         for x in range(n)
    # ]
    reranking_l = ["feature/S2C/training/hhsearch/cv0{}.npy".format(x) \
            for x in range(n)]

    # cli_print = "printf 'template\tROC1\tROC50\n'"
    # sp.call(cli_print,shell=True)
    
    client = Client(processes=False)             # create local cluster
    with joblib.parallel_backend('dask'):
        for i in range(n):
            fold_num = str(i)
            reranking_path = reranking_l[i]
            # pairwise_df = run_reranker.get_pairwise_df(srch_df,fold_num,cv_df)
            # 做成训练集时query和template都不能属于对应fold_num下的序列
            pairwise_df = srch_df.loc[~srch_df.loc[:,"query"].isin(cv_df.loc[:, fold_num])]
            pairwise_df = pairwise_df.loc[~srch_df.loc[:, "template"].isin(cv_df.loc[:,fold_num])]
            # 这里要额外处理kv_df
            kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
            r_list = []

            m, n = pairwise_df.shape
            cli_print = "printf 'pairwise_df shape {} {}\n'".format(int(m),int(n))
            sp.call(cli_print,shell=True)
            pairwise_df = run_reranker.expand_query(pairwise_df,kv_df)
            # 这一步实际上已经让每一折的query, 依照字典序来排序了
            for queryName, p_df in pairwise_df.groupby("query"):
                s = time.time()
                m_df = run_reranker.expand_template(p_df,kv_i_df)
                R = run_reranker.pagerank(m_df, spec_df)
                # y_pred = ranking_roc_at(R, m_df, queryName)
                y_pred = R[:-1]

                # 这里要对m_df重新命名，把sf_template改为sf
                m_df1 = m_df.rename(columns={"sf_template":"sf"})
                # 重新给template编号，这一编号程序与pagerank内部一致
                m_df1 = m_df1.join(spec_df, on="template")
                m_df1 = run_cluster.renumber(m_df1)

                # 调整y_pred的shape为(-1,)
                y_pred = tf.reshape(y_pred,(-1,))
                y_pred = run_cluster.S2C_transform(y_pred,m_df1)
                m_df1 = m_df.rename(columns={"sf":"sf_template"})
                # ranking_roc_at(y_pred, m_df1, queryName)

                # cli_print = "printf '{}\n'".format(queryName)
                # sp.call(cli_print,shell=True)
                r_list.append(y_pred)
                e = time.time()
                cli_print = "printf 'time: {}\n'".format(e-s)
                sp.call(cli_print,shell=True)

            # rs = tf.transpose(tf.concat(r_list,axis=1))
            rs = tf.stack([r_list],axis=0)

            # s2c = save_s2c(rs,m_df1)
            np.save(reranking_path,rs)


def val_pagearank():
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    searched_path = "feature/hhsearch/searched/validation_nr.csv"
    specific_path = "feature/physicochemical/representation/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5

    reranking_l = ["feature/DFG/hhsearch/val0{}.npy".format(x)\
        for x in range(n)]

    cli_print = "printf 'template\tROC1\tROC50\n'"
    sp.call(cli_print,shell=True)
    
    client = Client(processes=False)             # create local cluster
    with joblib.parallel_backend('dask'):
        for i in range(n):
            fold_num = str(i)
            reranking_path = reranking_l[i]
            pairwise_df = srch_df.loc[~srch_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
            # 这里要额外处理kv_df
            kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
            r_list = []

            pairwise_df = run_reranker.expand_query(pairwise_df,kv_df)
            # 这一步实际上已经让每一折的query, 依照字典序来排序了
            for queryName, p_df in pairwise_df.groupby("query"):
                m_df = run_reranker.expand_template(p_df,kv_i_df)
                R = run_reranker.pagerank(m_df, spec_df)
                y_pred = R[:-1]
                ranking_roc_at(y_pred, m_df, queryName)
                r_list.append(y_pred)
            
            rs = tf.transpose(tf.concat(r_list,axis=1))
            np.save(reranking_path,rs)

def val_s2c():
    run_cluster = ClusterPairwise()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    val_sepcific_path = "feature/hhblits/acc_hmm/val_sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    vspec_df = pd.read_csv(val_sepcific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    searched_l = [
        "feature/DFG/hhsearch/val0{}.npy".format(x) \
            for x in range(n)
    ]
    save_l = [
        "feature/S2C/hhsearch/val0{}.npy".format(x) \
            for x in range(n)
    ]


    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    vtemplate_df = vspec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        searched_path = searched_l[i]
        rankings = tf.constant(np.load(searched_path),tf.float32)

        fold_num = str(i)

        t_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        q_ser = vtemplate_df.sort_values(by="template").loc[:,"template"]
        m_df = run_cluster.expand_template(t_df,kv_df)
        m_df = run_cluster.renumber(m_df)

        reranking_list = []
        for j in range(rankings.shape[0]):
            R = rankings[j]
            queryName = q_ser.loc[j]
            newr = run_cluster.S2C_transform(R,m_df)
            s2c_roc_at(newr,queryName,m_df,kv_df)
            reranking_list.append(newr)
        
        indices = tf.constant(list(range(rankings.shape[0])))
        indices = tf.reshape(indices,(-1,1))

        rankings = tf.tensor_scatter_nd_update(rankings, indices, reranking_list)

        save_path = save_l[i]

        np.save(save_path,rankings)

# 把s2c的结果从n_sameple*n_sample变到n_sample*n_class
def format_s2c():
    run_cluster = ClusterPairwise()
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    seq2cluster_l = [
        "feature/S2C/hhsearch/val0{}.npy".format(x) \
            for x in range(n)
    ]
    format_l = [
        "feature/S2C/training/hhsearch/val0{}.npy".format(x) \
            for x in range(n)
    ]

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        seq2cluster_path = seq2cluster_l[i]
        format_path = format_l[i]
        rs = np.load(seq2cluster_path)
        print(rs.shape)

        fold_num = str(i)

        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)

        m_df = kv_i_df.join(template_df.set_index("template"),on="template")
        m_df = run_cluster.renumber(m_df)

        s2c_ary = save_s2c(rs,m_df)
        print(s2c_ary.shape)
        np.save(format_path,s2c_ary)

def test_format_s2c():
    run_cluster = ClusterPairwise()
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    seq2cluster_l = [
        "feature/S2C/hhsearch/cv0{}.npy".format(x) \
            for x in range(n)
    ]
    format_l = [
        "feature/S2C/test/hhsearch/cv0{}.npy".format(x) \
            for x in range(n)
    ]

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        seq2cluster_path = seq2cluster_l[i]
        format_path = format_l[i]
        rs = np.load(seq2cluster_path)
        print(rs.shape)

        fold_num = str(i)

        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)

        m_df = kv_i_df.join(template_df.set_index("template"),on="template")
        m_df = run_cluster.renumber(m_df)

        s2c_ary = save_s2c(rs,m_df)
        print(s2c_ary.shape)
        np.save(format_path,s2c_ary)


def ind_format_s2c():
    run_cluster = ClusterPairwise()
    run_reranker = ReRanker()

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    kv_df = pd.read_csv(key2value_path)

    n = 5
    seq2cluster_l = [
        "feature/S2C/training_cluster/hhsearch/ind0{}.npy".format(x) \
            for x in range(n)
    ]
    format_l = [
        "feature/S2C/training_cluster/hhsearch/ind0{}.npy".format(x) \
            for x in range(n)
    ]

    template_df = spec_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        seq2cluster_path = seq2cluster_l[i]
        format_path = format_l[i]
        rs = np.load(seq2cluster_path)
        print(rs.shape)

        fold_num = str(i)

        kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)

        m_df = kv_i_df.join(template_df.set_index("template"),on="template")
        m_df = run_cluster.renumber(m_df)

        s2c_ary = save_s2c(rs,m_df)
        print(s2c_ary.shape)
        np.save(format_path,s2c_ary)


# 原本训练集的行是基于template的字典序的
# 要改成基于row num
def reconstruct():
    # run_reranker = ReRanker()
    # run_cluster = ClusterPairwise()

    n = 5
    # representation_path = "feature/S2C/training_cluster/hhblits/cv00.npy"
    representation_l = [
        "feature/S2C/training_cluster/hhsearch/cv0{}.npy".format(x)\
            for x in range(n)
    ]

    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    specific_path = "feature/physicochemical/representation/sequence_name2row_num.csv"
    # key2value_path = "dataset/SCOP/csv/sequence_superfamily.csv"
    cv_df = pd.read_csv(cross_validation_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    # kv_df = pd.read_csv(key2value_path)

    
    for i in range(n):
        fold_num = str(i)
        representation_path = representation_l[i]
        rep = tf.constant(np.load(representation_path),tf.float32)
        template_df = spec_df.reset_index().rename(columns={"index":"template"})
        t_i_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        #原本是按template字典序
        t_i_df = t_i_df.sort_values(by="template")
        t_i_df = t_i_df.assign(new_row_num=list(range(t_i_df.shape[0])))
        t_df = t_i_df.sort_values(by="row num")
        # t_df
        indices = tf.reshape(tf.constant(t_df.loc[:,"new_row_num"]),(-1,1))
        rr = tf.gather_nd(rep,indices)
        np.save(representation_path,rr)


def ind_pr_s2c():
    run_reranker = ReRanker()
    run_cluster = ClusterPairwise()
    
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    searched_path = "feature/hhsearch/searched/independent_nr.csv"
    # searched_path = "feature/hhsearch/searched/searched_nr.csv"
    specific_path = "feature/hhblits/acc_hmm/sequence_name2row_num.csv"
    ispecific_path = "feature/hhblits/acc_hmm/ind_sequence_name2row_num.csv"
    ikey2value_path = "dataset/scop_scope/csv/sequence_superfamily.csv"

    cv_df = pd.read_csv(cross_validation_path)
    srch_df = pd.read_csv(searched_path)
    spec_df = pd.read_csv(specific_path,index_col=0)
    ispec_df = pd.read_csv(ispecific_path,index_col=0)
    ikv_df = pd.read_csv(ikey2value_path)
    roc_at_flag = False # 控制是否输出对每一条序列的排序结果的评估

    n = 5

    # 原本是从0到5
    # 但是运行程序出了点问题，这次从1开始
    reranking_l = [
        "feature/S2C/training_cluster/hhsearch/ind0{}.npy".format(x) \
            for x in range(1,n)
    ]
    # reranking_l = ["feature/S2C/training/hhsearch/cv0{}".format(x) \
    #         for x in range(n)]

    # cli_print = "printf 'template\tROC1\tROC50\n'"
    # sp.call(cli_print,shell=True)
    # 这里的template_df也包含了对应的sf, label
    template_df = spec_df.join(ikv_df.set_index("template"))
    template_df = template_df.reset_index().rename(columns={"index":"template"})
    for i in range(n):
        fold_num = str(i)
        reranking_path = reranking_l[i]
        # pairwise_df = run_reranker.get_pairwise_df(srch_df,fold_num,cv_df)
        # 做成训练集时query和template都不能属于对应fold_num下的序列
        pairwise_df = srch_df.loc[~srch_df.loc[:,"query"].isin(cv_df.loc[:, fold_num])]
        pairwise_df = pairwise_df.loc[~srch_df.loc[:, "template"].isin(cv_df.loc[:,fold_num])]
        # 这里要额外处理kv_df
        # 这里改成处理template_df
        # 因为，这里的template_df的格式类似于kv_df
        # kv_i_df = run_reranker.get_key2value_df(kv_df,fold_num,cv_df,spec_df)
        t_i_df = template_df.loc[~template_df.loc[:,"template"].isin(cv_df.loc[:,fold_num])]
        r_list = []

        m, n = pairwise_df.shape
        cli_print = "printf 'pairwise_df shape {} {}\n'".format(int(m),int(n))
        sp.call(cli_print,shell=True)
        pairwise_df = run_reranker.expand_query(pairwise_df,ikv_df)
        # 这一步实际上已经让每一折的query, 依照字典序来排序了
        # 但是按字典序排序，训练集构造的顺序会有问题，因此，最好根据row num排序
        # 由于merge_df是基于pairwise_df和ikv_df，这样sf的label就和t_i_df一致了
        merge_df = pairwise_df.join(ispec_df,on="query")
        # for queryName, p_df in merge_df.groupby("query"):
        for queryName, p_df in merge_df.groupby("row num"):
            s = time.time()
            # 这里要注意，m_df结果是基于kv_i_df来拓展的，所以kv_i_df表示训练集
            # 这里的训练集符合交叉验证的划分
            # 但因为，query和template属于不同的数据集（scope和scope)，所以，同时还得保证sf的label是一致的
            # 所以这里改为通过t_i_df（包含训练集名称的dataframe)
            # m_df = run_reranker.expand_template(p_df,kv_i_df) # 原本的方法
            m_df = run_reranker.expand_template(p_df,t_i_df)
            R = run_reranker.pagerank(m_df, spec_df)
            # y_pred = ranking_roc_at(R, m_df, queryName)
            y_pred = R[:-1]

            # 这里要对m_df重新命名，把sf_template改为sf
            m_df1 = m_df.rename(columns={"sf_template":"sf"})
            # 重新给template编号，这一编号方法与pagerank内部一致
            m_df1 = m_df1.join(spec_df, on="template")
            m_df1 = run_cluster.renumber(m_df1)

            # 调整y_pred的shape为(-1,)
            y_pred = tf.reshape(y_pred,(-1,))
            y_pred = run_cluster.S2C_transform(y_pred,m_df1)
            m_df1 = m_df.rename(columns={"sf":"sf_template"})

            if roc_at_flag:
                ranking_roc_at(y_pred, m_df1, queryName)

            # cli_print = "printf '{}\n'".format(queryName)
            # sp.call(cli_print,shell=True)
            r_list.append(y_pred)
            e = time.time()
            cli_print = "printf 'time: {}\n'".format(e-s)
            sp.call(cli_print,shell=True)

        # rs = tf.transpose(tf.concat(r_list,axis=1))
        rs = tf.stack(r_list,axis=0) # 原本这里是[r_list]，正确的方法应该是去掉[]，不然shape会变成1*n_sample*n_sample

        # 这里之所以可以选择m_df1，是因为，m_df1种包含的template的个数以及顺序都是一致的
        # 直接用m_df1会出错
        # rs = save_s2c(rs,m_df1)
        np.save(reranking_path,rs)


if __name__ == "__main__":
    import numpy as np
    import tensorflow as tf
    import pandas as pd
    import time
    from six.moves import cPickle
    import os
    import re
    from src.model.randomwalk import ReRanker
    from src.model.cluster import ClusterPairwise
    from src.evaluation.cross_validation import Run
    import subprocess as sp
    import joblib
    from dask.distributed import Client
    from sklearn.preprocessing import label_binarize

    # use_pr_s2c()
    # val_pagearank()
    # val_s2c()
    # format_s2c()
    # test_format_s2c()
    # reconstruct()

    # ind_pr_s2c()
    ind_format_s2c()