def getFileNameWithoutSurfix(psName):
    rv_psN = psName[::-1]
    name_size = len(psName)
    surfixParser = re.compile(r"\.")
    surfix = ""
    s_r = surfixParser.search(rv_psN)
    if s_r is not None:
        surfix_start = s_r.start()
        name = psName[:name_size-surfix_start-1]
        surfix = psName[name_size-surfix_start:]
    else:
        name = psName
    return name, surfix

def getFastaFileSize():
    n = 3
    # fasta_l = ["dataset/prepare/SCOPe/final/sub_{}".format(x) for x in range(n)]
    # fasta_l = ["dataset/prepare/SCOPe/final/mmseqs/sub_{}".format(x) for x in range(n)]
    # fasta_l = ["dataset/benchmark/final_/sub_{}".format(x) for x in range(n)]
    # fasta_l = ["dataset/prepare/SCOP/cdhit/SCOP_Experimental",
    #     "dataset/prepare/SCOP/cdhit/validation"]
    # fasta_l = ["dataset/prepare/SCOP/mmseqs/SCOP_Experimental_rep_seq.fasta",
    #     "dataset/prepare/SCOP/mmseqs/validation_rep_seq.fasta"]
    # fasta_l = ["dataset/benchmark/all/SCOP_experimental",
    #     "dataset/benchmark/all/validation"]
    # fasta_l = ["dataset/prepare/SCOPe/pre_test/SCOPe_TEST"]
    # fasta_l = ["dataset/prepare/SCOPe/cdhit/SCOPe_TEST"]
    # fasta_l = ["dataset/prepare/SCOPe/mmseqs/SCOPe_TEST_rep_seq.fasta"]
    fasta_l = ["dataset/prepare/SCOPe/pre_test/SCOPe_TEST"]
    # fasta_l = ["dataset/prepare/SCOPe/final/all/benchmark"]
    toolA = Assembly()
    for fasta_path in fasta_l:
        size = toolA.fastaFileSize(fasta_path)
        print("{}: {}".format(os.path.dirname(fasta_path),size))

def fasta2dict():
    bin = True
    level = "sf"
    # level = "fam"
    # fastaPath = "dataset/SCOP/ori/astral-scopdom-seqres-gd-sel-gs-bib-95-1.75.fa"
    # fastaPath = "dataset/SCOPe/ori/astral-scopedom-seqres-gd-sel-gs-bib-95-2.07.fa"
    fastaPath = "dataset/prepare/SCOPe/final/all/benchmark"
    # dictPath = "dataset/SCOP/dict/text/sf"
    # dictPath = "dataset/SCOPe/dict/text/sf"
    # dictPath = "dataset/SCOPe/dict/text/fam"
    # dictPath = "dataset/SCOPe/dict/bin/fam"
    dictPath = "dataset/prepare/SCOPe/final/all/dict/binary"

    toolA = Assembly()

    toolA.fasta2dict(fastaPath,dictPath,level,bin)

def subset2dict():
    n = 3
    bin = False
    if bin:
        store = "dict"
    else:
        store = "text"
    level = "fam"
    sub_l = ["dataset/prepare/SCOPe/final/sub_{}".format(x) for x in range(n)]
    dictionary_l = [os.path.join("dataset/prepare/SCOPe/final/dict/sub_{}".format(x),level,store) \
        for x in range(n)]

    toolA = Assembly()
    for i in range(n):
        sub_path = sub_l[i]
        dictionary_path = dictionary_l[i]
        toolA.fasta2dict(sub_path,dictionary_path,level,bin)


def use_changeLevel2Dict():
    level = "sf"
    ori_path = "dataset/SCOPe/dict/bin/fam/value2key"
    sup_path = "dataset/prepare/SCOPe/filter/dict/sf/binary/value2key"
    up_path = "dataset/prepare/SCOPe/filter/dict/fam/value2key"
    toolA = Assembly()
    toolA.changeLevel2Dict(ori_path,sup_path,up_path,level)

def split_n_subset():
    n = 3
    # dataset_dict_path = "dataset/prepare/SCOPe/filter/dict/sf/binary/value2key"
    fam2seq_path = "dataset/SCOPe/dict/bin/fam/value2key"
    result_dir_path = "dataset/prepare/SCOPe/pre_split"
    toolA = Assembly()
    toolA.split_n_subset(n,fam2seq_path,result_dir_path)

def split_file_by():
    scope_file = "dataset/SCOPe/ori/astral-scopedom-seqres-gd-sel-gs-bib-95-2.07.fa"
    dict_path = "dataset/prepare/SCOPe/pre_split/dict/binary/seq2no"
    result_dir = "dataset/prepare/SCOPe/split"
    toolA = Assembly()
    toolA.split_file_by(scope_file,dict_path,result_dir)

# def use_cdhit():
#     n = 3
#     subset_l = ["dataset/prepare/SCOPe/split/sub_{}".format(x) for x in range(n)]
#     result_l = ["dataset/prepare/SCOPe/cdhit/sub_{}".format(x) for x in range(n)]
#     toolA = Assembly()

#     for i in range(n):
#         subset_path = subset_l[i]
#         result_path = result_l[i]
#         toolA.use_cdhit(subset_path,result_path)

# remote
def use_cdhit():
    n = 3
    fasta_l = ["dataset/prepare/SCOPe/pre_test/SCOPe_TEST"]
    result_l = ["dataset/prepare/SCOPe/cdhit/SCOPe_TEST"]
    toolA = Assembly()

    for i, fasta_path in enumerate(fasta_l):
        result_path = result_l[i]
        toolA.use_cdhit(fasta_path,result_path)

def use_makeblastdb(fasta_file_l=None,sub_db_l=None):
    n = 3
    if fasta_file_l is None:
        # fasta_file_l = ["dataset/prepare/SCOPe/cdhit/sub_{}".format(x) for x in range(n)]
        # fasta_file_l = ["dataset/prepare/SCOP/mmseqs/SCOP_Experimental_rep_seq.fasta",
        #     "dataset/prepare/SCOP/mmseqs/validation_rep_seq.fasta"]
        fasta_file_l = ["dataset/prepare/SCOPe/ori/astral-scopedom-seqres-gd-sel-gs-bib-95-2.07.fa"]
    if sub_db_l is None:
        # sub_db_l = ["dataset/prepare/SCOPe/cdhit/db/sub_{}".format(x) for x in range(n)]
        # sub_db_l = ["dataset/prepare/SCOP/psiblast/db/SCOP_Experimental",
        #     "dataset/prepare/SCOP/psiblast/db/validation"]
        sub_db_l = ["dataset/prepare/SCOPe/db/scope_2_06"]
    toolA = Assembly()

    for i in range(len(fasta_file_l)):
        fasta_file_path = fasta_file_l[i]
        sub_db_path = sub_db_l[i]
        toolA.use_makeblastdb(fasta_file_path,sub_db_path)
    
def use_splitfasta(fasta_file_l=None,seqs_l=None):
    n = 3
    # os.environ["HHLIB"] = "/home/altriasjy31x/anaconda3/envs/py37"
    os.environ["HHLIB"] = "/home/shaojiangyi/anaconda3/envs/py37"
    os.environ["PATH"] += ":{}/scripts".format(os.environ["HHLIB"])

    if fasta_file_l is None:
        # fasta_file_l = ["dataset/prepare/SCOPe/cdhit/sub_{}".format(x) for x in range(n)]
        fasta_file_l = ["dataset/prepare/SCOP/mmseqs/SCOP_Experimental_rep_seq.fasta",
            "dataset/prepare/SCOP/mmseqs/validation_rep_seq.fasta"]
    
    if seqs_l is None:
        # seqs_l = ["dataset/prepare/SCOPe/cdhit/seqs/sub_{}".format(x) for x in range(n)]
        seqs_l = ["dataset/prepare/SCOP/psiblast/seqs/SCOP_Experimental",
            "dataset/prepare/SCOP/psiblast/seqs/validation"]

    fasta_file_l = [os.path.abspath(x) for x in fasta_file_l]
    seqs_l = [os.path.abspath(x) for x in seqs_l]
    toolA = Assembly()

    for i in range(len(fasta_file_l)):
        fasta_file_path = fasta_file_l[i]
        seqs_path = seqs_l[i]
        toolA.use_splitfasta(fasta_file_path,seqs_path)

# def use_psiblast():
#     n = 3
#     combinations = [[1,2],[0,2],[0,1]]
    
#     seqs_l = ["dataset/prepare/SCOPe/cdhit/seqs/sub_{}".format(x) for x in range(n)]
#     dbPath_l = ["dataset/prepare/SCOPe/cdhit/db/sub_{}".format(x) for x in range(n)]
#     result_l = ["dataset/prepare/SCOPe/cdhit/msa/psiblast/sub_{}".format(x) for x in range(n)]
#     toolA = Assembly()

#     for i, comb in enumerate(combinations):
#         dbPath = dbPath_l[i]
#         result_path = result_l[i]
#         for subset_no in comb:
#             seq_dir = seqs_l[subset_no]
#             for seq_name in os.listdir(seq_dir):
#                 seq_path = os.path.join(seq_dir,seq_name)
#                 m = r"\."
#                 m_r = re.search(m,seq_name)
#                 if m_r is not None:
#                     seq_name = seq_name[:m_r.start()]
#                 output_path = os.path.join(result_path,"{}.psi".format(seq_name))
#                 toolA.use_psiblast(seq_path,dbPath,output_path)

# remote
def use_psiblast():
    seqs_l = ["dataset/prepare/SCOP/psiblast/seqs/SCOP_Experimental",
        "dataset/prepare/SCOP/psiblast/seqs/validation"]
    # dbPath_l = ["dataset/prepare/SCOP/psiblast/db/validation",
    #         "dataset/prepare/SCOP/psiblast/db/SCOP_Experimental"]
    dbPath_l = ["dataset/prepare/SCOPe/db/scope_2_06"]*2
    # result_l = ["dataset/prepare/SCOP/psiblast/psi/SCOP_Experimental",
    #     "dataset/prepare/SCOP/psiblast/psi/validation"]
    result_l = ["dataset/prepare/SCOPe/psiblast/scope"]*2
    
    toolA = Assembly()
    for i, seq_dir in enumerate(seqs_l):
        dbPath = dbPath_l[i]
        result_path = result_l[i]
        for seq_name in os.listdir(seq_dir):
            seq_path = os.path.join(seq_dir,seq_name)
            rPointer = re.compile(r"\.")
            m_r = rPointer.search(seq_name)
            if m_r is not None:
                seq_name = seq_name[:m_r.start()]
            output_path = os.path.join(result_path,"{}.psi".format(seq_name))
            toolA.use_psiblast(seq_path,dbPath,output_path)


def use_psi2dict():
    n = 3
    # psiDir_l = ["dataset/prepare/SCOPe/cdhit/msa/psiblast/sub_{}".format(x) for x in range(n)]
    # psiDir_l = ["dataset/prepare/SCOP/psiblast/psi/SCOP_Experimental",
    #     "dataset/prepare/SCOP/psiblast/psi/validation"]
    psiDir_l = ["dataset/prepare/SCOPe/psiblast/scope"]
    # saveDict_l = ["dataset/prepare/SCOPe/cdhit/msa/dict/sub_{}/binary/templateSet".format(x) for x in range(n)]
    # saveDict_path = "dataset/prepare/SCOPe/cdhit/msa/dict/templateSet"
    # saveDict_path = "dataset/prepare/SCOP/psiblast/dict/binary/templateSet"
    saveDict_path = "dataset/prepare/SCOPe/psiblast/dict/binary/scopeSet"
    toolA = Assembly()
    templateSet = set()
    #设置count用于简单测试
    # count = 200
    for i, psiDir in enumerate(psiDir_l):
        # saveDict_path = saveDict_l[i]
        for psi in os.listdir(psiDir):
            # if count == 0:
            #     break
            psiPath = os.path.join(psiDir,psi)
            templateSet = toolA.psi2set(psiPath,templateSet)
            # count -= 1
        # save_path = "dataset/prepare/SCOPe/cdhit/msa/dict/sub_0/text/templateSet"
        # with open(save_path,"w") as h:
        #     for t in templateSet:
        #         item = "{} ".format(t)
        #         h.write(item)

    #binary
    with open(saveDict_path, "wb") as h:
        cPickle.dump(templateSet,h)

def use_filterDatasetBy():
    n = 3
    # dataset_l = ["dataset/prepare/SCOPe/cdhit/sub_{}".format(x) for x in range(n)]
    # dataset_l = ["dataset/prepare/SCOP/mmseqs/SCOP_Experimental_rep_seq.fasta",
    #     "dataset/prepare/SCOP/mmseqs/validation_rep_seq.fasta"]
    dataset_l = ["dataset/prepare/SCOPe/ori/astral-scopedom-seqres-gd-sel-gs-bib-95-2.07.fa"]
    # by_path = "dataset/prepare/SCOPe/cdhit/msa/dict/binary/psidict"
    # by_path = "dataset/prepare/SCOPe/cdhit/msa/dict/templateSet"
    # by_path = "dataset/prepare/SCOP/psiblast/dict/binary/templateSet"
    by_path = "dataset/prepare/SCOPe/psiblast/dict/binary/scopeSet"
    # output_l = ["dataset/prepare/SCOPe/final/sub_{}".format(x) for x in range(n)]
    # output_l = ["dataset/benchmark/all/SCOP_experimental",
    #     "dataset/benchmark/all/validation"]
    output_l = ["dataset/prepare/SCOPe/pre_test/SCOPe_TEST"]
    with open(by_path, "rb") as h:
        by = cPickle.load(h)
    
    toolA = Assembly()
    for i in range(len(dataset_l)):
        dataset_path = dataset_l[i]
        output_path = output_l[i]
        toolA.filterDatasetBy(dataset_path,by,output_path)

# def use_mmseqs_cluster():
#     n = 1
#     fasta_l = ["dataset/prepare/SCOPe/final/sub_{}".format(x) for x in range(n)]
#     result_dir = "dataset/prepare/SCOPe/final/mmseqs"
#     toolA = Assembly()
#     for fastaFilePath in fasta_l:
#         toolA.mmseqs_cluster(fastaFilePath,result_dir)

#remote
def use_mmseqs_cluster():
    n = 3
    # fasta_l = ["dataset/benchmark/ori/sub_{}".format(x) for x in range(n)]
    # fasta_l = ["dataset/prepare/SCOPe/cdhit/sub_{}".format(x) for x in range(n)]
    # fasta_l = ["dataset/prepare/SCOP/cdhit/SCOP_Experimental","dataset/prepare/SCOP/cdhit/validation"]
    fasta_l = ["dataset/prepare/SCOPe/cdhit/SCOPe_TEST"]
    # result_dir = "dataset/benchmark/final"
    # result_dir = "dataset/prepare/SCOP/mmseqs"
    result_dir = "dataset/prepare/SCOPe/mmseqs"
    toolA = Assembly()
    for fastaFilePath in fasta_l:
        toolA.mmseqs_cluster(fastaFilePath,result_dir)  
#remote
def use_filterFastaRecord():
    n = 3
    # fasta_l = ["dataset/benchmark/final/sub_{}_all_seqs.fasta".format(x) for x in range(n)]
    fasta_l = ["dataset/prepare/SCOP/mmseqs/SCOP_Experimental_all_seqs.fasta",
        "dataset/prepare/SCOP/mmseqs/validation_all_seqs.fasta"]
    # result_l = ["dataset/benchmark/final_/sub_{}".format(x) for x in range(n)]
    result_l = ["dataset/prepare/SCOP/mmseqs/SCOP_Experimental","dataset/prepare/SCOP/mmseqs/validation"]
    toolA = Assembly()
    for i, fastaFilePath in enumerate(fasta_l):
        result_path = result_l[i]
        toolA.filterFastaRecord(fastaFilePath,result_path)

# 将key2value_dict转为csv格式
def get_key2value_dict_csv():
    key2value_dict_path = "dataset/SCOPe/dict/bin/sf/key2value"
    with open(key2value_dict_path,"rb") as h:
        kv_dict = cPickle.load(h)
    
    run_tools = Assembly()
    
    kv_df = run_tools.superfamilyName2label(kv_dict)

    savePath = "dataset/SCOPe/csv/sequence_superfamily.csv"
    kv_df.to_csv(savePath,index=False)

# 根据cross validation将sf重新编号
def get_key2value_csv_newLabel():
    n = 5
    savePath = "dataset/SCOP/csv/sequence_superfamily.csv"
    cross_validation_path = "dataset/benchmark/cross/fold_num2sequence_name.csv"
    kv_df = pd.read_csv(savePath)
    cv_df = pd.read_csv(cross_validation_path)

    new_save_l = ["dataset/SCOP/csv/cv0{}_superfamily_label.csv".format(x) \
        for x in range(n)]
    run_tools = Assembly()
    train_l = run_tools.superfamilyName2newLabel(kv_df,cv_df)

    for i in range(n):
        new_save_path = new_save_l[i]
        train_df = train_l[i]
        train_df.to_csv(new_save_path,index=False)

# def remove_one_superfamily():

##############################################################################################################################################################################
# 基于SCOPe制作family, superfamily, fold三个级别的独立测试集
##############################################################################################################################################################################

# 去除scope2.07中与scop1.75重复的序列，作为SCOPe_family
def construct_scope_family():
    # 先把两个数据集转为set
    from Bio.SeqIO import parse, write

    scop_path = "dataset/SCOP/ori/astral-scopdom-seqres-gd-sel-gs-bib-95-1.75.fa"
    scope_path = "dataset/SCOPe/ori/astral-scopedom-seqres-gd-sel-gs-bib-95-2.07.fa"

    with open(scop_path,"r") as h:
        scop_list = [
            r.name for r in parse(h,"fasta")
        ]
    with open(scope_path,"r") as h:
        scope_list = [
            r.name for r in parse(h,"fasta")
        ]

    scop_set = set(scop_list)
    scope_set = set(scope_list)

    diff_set = scope_set.difference(scop_set)

    with open(scope_path,"r") as h:
        record_list = [
            r for r in parse(h,"fasta") \
                if r.name in diff_set
        ]
    
    save_path = "dataset/independent/ori/SCOPe_family_ori"
    with open(save_path,"w") as h:
        write(record_list,h,"fasta")

def scope_cdhit():
    from Bio.SeqIO import parse, write
    toolA = Assembly()
    scope_path = "dataset/independent/ori/SCOPe_family_ori"
    scop_path = "dataset/SCOP/ori/astral-scopdom-seqres-gd-sel-gs-bib-95-1.75.fa"
    merge_path = "dataset/tmp/merge.fa"

    with open(scop_path, "r") as h1,\
        open(scope_path,"r") as h2,\
        open(merge_path,"w") as h3:
        for h in [h1,h2]:
            h3.write(h.read())
    
    cdhit_path = "dataset/tmp/merge_cdhit.fa"
    toolA.use_cdhit(merge_path,cdhit_path,sequence_identity=0.95)
    
    with open(cdhit_path,"r") as h:
        seq_list = [
            r.name for r in parse(h,"fasta")
        ]
    seq_set = set(seq_list)

    with open(scop_path,"r") as h:
        scop_list = [
            r.name for r in parse(h,"fasta")
        ]
    scop_set = set(scop_list)

    diff_set = seq_set.difference(scop_set)
    print(len(diff_set))
    result_path = "dataset/independent/ori/SCOPe_family_cdhit"

    with open(scope_path,"r") as h:
        record_lsit = [
            r for r in parse(h,"fasta")\
                if r.name in diff_set
        ]
    
    with open(result_path,"w") as h:
        write(record_lsit,h,"fasta")

def scope_mmseqs2():
    toolA = Assembly()

    scope_path = "dataset/independent/SCOPe_family_cdhit"
    result_dir = "dataset/independent"
    toolA.mmseqs_cluster(scope_path,result_dir,0.25)

def scope2seqs():
    toolA = Assembly()

    scope_path = "dataset/benchmark/all/independent"
    seqs_dir = "dataset/benchmark/seqs/independent"

    toolA.splitFasta2seqs(scope_path,seqs_dir)

def ind_makeblastdb():
    toolA = Assembly()

    fas_path = "dataset/independent/ori/SCOPe_family_cdhit"
    db_path = "dataset/benchmark/db/all/ind_psiblast"
    toolA.use_makeblastdb(fas_path,db_path)

def scope_psiblast():
    toolA = Assembly()

    n = 5

    # seqs_dir = "dataset/benchmark/seqs/independent"
    scop_l = [
        "dataset/benchmark/seqs/SCOP_Experimental_foldNo{}".format(x)\
            for x in range(n)
    ]

    db_path = "dataset/benchmark/db/all/ind_psiblast"
    result_dir = "dataset/SCOPe/psiblast"
    for seqs_dir in scop_l:
        for seq_name in os.listdir(seqs_dir):
            seq_path = os.path.join(seqs_dir,seq_name)
            name,_ = getFileNameWithoutSurfix(seq_name)
            output_path = os.path.join(result_dir,"{}.psi".format(name))
            toolA.use_psiblast(seq_path,db_path,output_path)

def scope_psi2set():
    psi_dir = "dataset/SCOPe/psiblast"
    dict_path = "dataset/SCOPe/dict/bin/psiblast/scope2filter"
    toolA = Assembly()

    template_set = set()
    for psi in os.listdir(psi_dir):
        psi_path = os.path.join(psi_dir,psi)
        template_set = toolA.psi2set(psi_path,template_set)
    
    with open(dict_path,"wb") as h:
        cPickle.dump(template_set,h)


def scope_filterDatasetBy():
    fas_path = "dataset/independent/ori/SCOPe_family_cdhit"
    by_path = "dataset/SCOPe/dict/bin/psiblast/scope2filter"
    result_path = "dataset/benchmark/all/IND_FAM"

    toolA = Assembly()
    with open(by_path,"rb") as h:
        by = cPickle.load(h)

    toolA.filterDatasetBy(fas_path,by,result_path)

# 在scope_family基础构建
def construct_scope_superfamily():
    from Bio.SeqIO import parse, write

    # 根据字典文件得出
    scope_key2vval_path = "dataset/SCOPe/dict/bin/fam/key2value"
    scop_value2key_path = "dataset/SCOP/dict/bin/fam/value2key"

    with open(scope_key2vval_path,"rb") as h1,\
        open(scop_value2key_path,"rb") as h2:
        scope_kv = cPickle.load(h1)
        scop_vk = cPickle.load(h2)
    
    seq_list = []
    for k in scope_kv:
        if scop_vk.get(scope_kv[k]) is None:
            seq_list.append(k)
    
    seq_set = set(seq_list)

    scope_family_path = "dataset/benchmark/all/IND_FAM"
    with open(scope_family_path, "r") as h:
        record_list = [
            r for r in parse(h,"fasta") \
                if r.name in seq_set
        ]
    
    result_path = "dataset/benchmark/all/IND_SF"
    with open(result_path,"w") as h:
        write(record_list,h,"fasta")

# 在scope_family基础构建
def construct_scope_fold():
    from Bio.SeqIO import parse, write

    # 根据字典文件得出
    scope_key2vval_path = "dataset/SCOPe/dict/bin/sf/key2value"
    scop_value2key_path = "dataset/SCOP/dict/bin/sf/value2key"

    with open(scope_key2vval_path,"rb") as h1,\
        open(scop_value2key_path,"rb") as h2:
        scope_kv = cPickle.load(h1)
        scop_vk = cPickle.load(h2)
    
    seq_list = []
    for k in scope_kv:
        if scop_vk.get(scope_kv[k]) is None:
            seq_list.append(k)
    
    seq_set = set(seq_list)

    scope_family_path = "dataset/benchmark/all/IND_SF"
    with open(scope_family_path, "r") as h:
        record_list = [
            r for r in parse(h,"fasta") \
                if r.name in seq_set
        ]
    
    result_path = "dataset/benchmark/all/IND_FOLD"
    with open(result_path,"w") as h:
        write(record_list,h,"fasta")

def scope_fas2csv():
    scope_family_path = "dataset/benchmark/all/IND_FAM"
    csv_path = "dataset/independent/csv/sequence_info.csv"
    
    toolA = Assembly()
    info_df = toolA.fas2info_csvFormat(scope_family_path)

    info_df.to_csv(csv_path,index=False)

# 根据之前的结果
# 把superfamily, fold级别的实验所涉及的序列转为csv格式，方便进行实验
def const_scope_level():
    from Bio.SeqIO import parse, write
    sf_path = "dataset/benchmark/all/IND_SF"
    fold_path = "dataset/benchmark/all/IND_FOLD"
    fas_l = [sf_path, fold_path]

    save_l = [
        "dataset/independent/csv/independent_sf.csv",
        "dataset/independent/csv/independent_fold.csv"
    ]


    for i, fas_path in enumerate(fas_l):
        save_path = save_l[i]
        with open(fas_path,"r") as h:
            seq_list = [
                r.name for r in parse(h,"fasta")
            ]
        
        df = pd.DataFrame(seq_list,columns=["template"])

        df.to_csv(save_path,index=False)

def merge_seq_info():
    toolA = Assembly()

    level = "sf"
    bin = True
    fasPath = "dataset/tmp/merge.fa"
    dict_dir = "dataset/scop_scope/dict/bin/sf"
    csv_path = "dataset/scop_scope/csv/sequence_superfamily.csv"

    toolA.fasta2dict(fasPath,dict_dir,level,bin)
    
    dict_path = os.path.join(dict_dir,"key2value")
    with open(dict_path,"rb") as h:
        kv_dict = cPickle.load(h)
    info_df = toolA.superfamilyName2label(kv_dict)

    info_df.to_csv(csv_path,index=False)


if __name__ == "__main__":
    from src.utils.tools import Assembly
    from six.moves import cPickle
    import os
    import re
    import pandas as pd
    # fasta2dict()
    # use_changeLevel2Dict()
    # split_n_subset()
    # split_file_by()
    # use_cdhit()
    # use_makeblastdb()
    # use_splitfasta()
    # use_psiblast()
    # use_psi2dict()
    # use_filterDatasetBy()
    # subset2dict()
    # use_mmseqs_cluster()
    # use_filterFastaRecord()
    # getFastaFileSize()
    # get_key2value_dict_csv()
    # get_key2value_csv_newLabel()

##############################################################################################################################################################################
# 基于SCOPe制作family, superfamily, fold三个级别的独立测试集
##############################################################################################################################################################################

    # construct_scope_family()
    # scope_cdhit()
    # scope_mmseqs2()
    # scope2seqs()
    # ind_makeblastdb()
    # scope_psiblast()
    # scope_psi2set()
    # scope_filterDatasetBy()
    # construct_scope_superfamily()
    # construct_scope_fold()
    # scope_fas2csv()
    # const_scope_level()

    merge_seq_info()